/* Game.c generated by valac 0.45.3, the Vala compiler
 * generated from Game.vala, do not modify */

/*
This file is part of GameHub.
Copyright (C) 2018-2019 Anatoliy Kashkin

GameHub is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

GameHub is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with GameHub.  If not, see <https://www.gnu.org/licenses/>.
*/

#include <glib-object.h>
#include <glib.h>
#include <gio/gio.h>
#include <gtk/gtk.h>
#include <gee.h>
#include <stdlib.h>
#include <string.h>
#include <glib/gstdio.h>
#include <json-glib/json-glib.h>
#include <glib/gi18n-lib.h>
#include <gobject/gvaluecollector.h>
#include <float.h>
#include <math.h>

#define GAME_HUB_DATA_TYPE_RUNNABLE (game_hub_data_runnable_get_type ())
#define GAME_HUB_DATA_RUNNABLE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GAME_HUB_DATA_TYPE_RUNNABLE, GameHubDataRunnable))
#define GAME_HUB_DATA_RUNNABLE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GAME_HUB_DATA_TYPE_RUNNABLE, GameHubDataRunnableClass))
#define GAME_HUB_DATA_IS_RUNNABLE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GAME_HUB_DATA_TYPE_RUNNABLE))
#define GAME_HUB_DATA_IS_RUNNABLE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GAME_HUB_DATA_TYPE_RUNNABLE))
#define GAME_HUB_DATA_RUNNABLE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GAME_HUB_DATA_TYPE_RUNNABLE, GameHubDataRunnableClass))

typedef struct _GameHubDataRunnable GameHubDataRunnable;
typedef struct _GameHubDataRunnableClass GameHubDataRunnableClass;
typedef struct _GameHubDataRunnablePrivate GameHubDataRunnablePrivate;
typedef enum  {
	GAME_HUB_DATA_PLATFORM_LINUX,
	GAME_HUB_DATA_PLATFORM_WINDOWS,
	GAME_HUB_DATA_PLATFORM_MACOS,
	GAME_HUB_DATA_PLATFORM_EMULATED
} GameHubDataPlatform;

#define GAME_HUB_DATA_TYPE_PLATFORM (game_hub_data_platform_get_type ())
typedef enum  {
	GAME_HUB_DATA_RUNNABLE_INSTALLER_INSTALL_MODE_INTERACTIVE,
	GAME_HUB_DATA_RUNNABLE_INSTALLER_INSTALL_MODE_AUTOMATIC,
	GAME_HUB_DATA_RUNNABLE_INSTALLER_INSTALL_MODE_AUTOMATIC_DOWNLOAD
} GameHubDataRunnableInstallerInstallMode;

#define GAME_HUB_DATA_RUNNABLE_INSTALLER_TYPE_INSTALL_MODE (game_hub_data_runnable_installer_install_mode_get_type ())

#define GAME_HUB_DATA_TYPE_GAME (game_hub_data_game_get_type ())
#define GAME_HUB_DATA_GAME(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GAME_HUB_DATA_TYPE_GAME, GameHubDataGame))
#define GAME_HUB_DATA_GAME_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GAME_HUB_DATA_TYPE_GAME, GameHubDataGameClass))
#define GAME_HUB_DATA_IS_GAME(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GAME_HUB_DATA_TYPE_GAME))
#define GAME_HUB_DATA_IS_GAME_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GAME_HUB_DATA_TYPE_GAME))
#define GAME_HUB_DATA_GAME_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GAME_HUB_DATA_TYPE_GAME, GameHubDataGameClass))

typedef struct _GameHubDataGame GameHubDataGame;
typedef struct _GameHubDataGameClass GameHubDataGameClass;
typedef struct _GameHubDataGamePrivate GameHubDataGamePrivate;

#define GAME_HUB_DATA_GAME_TYPE_ACHIEVEMENT (game_hub_data_game_achievement_get_type ())
#define GAME_HUB_DATA_GAME_ACHIEVEMENT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GAME_HUB_DATA_GAME_TYPE_ACHIEVEMENT, GameHubDataGameAchievement))
#define GAME_HUB_DATA_GAME_ACHIEVEMENT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GAME_HUB_DATA_GAME_TYPE_ACHIEVEMENT, GameHubDataGameAchievementClass))
#define GAME_HUB_DATA_GAME_IS_ACHIEVEMENT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GAME_HUB_DATA_GAME_TYPE_ACHIEVEMENT))
#define GAME_HUB_DATA_GAME_IS_ACHIEVEMENT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GAME_HUB_DATA_GAME_TYPE_ACHIEVEMENT))
#define GAME_HUB_DATA_GAME_ACHIEVEMENT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GAME_HUB_DATA_GAME_TYPE_ACHIEVEMENT, GameHubDataGameAchievementClass))

typedef struct _GameHubDataGameAchievement GameHubDataGameAchievement;
typedef struct _GameHubDataGameAchievementClass GameHubDataGameAchievementClass;

#define GAME_HUB_DATA_GAME_TYPE_STATUS (game_hub_data_game_status_get_type ())
#define GAME_HUB_DATA_GAME_STATUS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GAME_HUB_DATA_GAME_TYPE_STATUS, GameHubDataGameStatus))
#define GAME_HUB_DATA_GAME_STATUS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GAME_HUB_DATA_GAME_TYPE_STATUS, GameHubDataGameStatusClass))
#define GAME_HUB_DATA_GAME_IS_STATUS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GAME_HUB_DATA_GAME_TYPE_STATUS))
#define GAME_HUB_DATA_GAME_IS_STATUS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GAME_HUB_DATA_GAME_TYPE_STATUS))
#define GAME_HUB_DATA_GAME_STATUS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GAME_HUB_DATA_GAME_TYPE_STATUS, GameHubDataGameStatusClass))

typedef struct _GameHubDataGameStatus GameHubDataGameStatus;
typedef struct _GameHubDataGameStatusClass GameHubDataGameStatusClass;

#define GAME_HUB_DATA_GAME_TYPE_OVERLAY (game_hub_data_game_overlay_get_type ())
#define GAME_HUB_DATA_GAME_OVERLAY(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GAME_HUB_DATA_GAME_TYPE_OVERLAY, GameHubDataGameOverlay))
#define GAME_HUB_DATA_GAME_OVERLAY_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GAME_HUB_DATA_GAME_TYPE_OVERLAY, GameHubDataGameOverlayClass))
#define GAME_HUB_DATA_GAME_IS_OVERLAY(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GAME_HUB_DATA_GAME_TYPE_OVERLAY))
#define GAME_HUB_DATA_GAME_IS_OVERLAY_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GAME_HUB_DATA_GAME_TYPE_OVERLAY))
#define GAME_HUB_DATA_GAME_OVERLAY_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GAME_HUB_DATA_GAME_TYPE_OVERLAY, GameHubDataGameOverlayClass))

typedef struct _GameHubDataGameOverlay GameHubDataGameOverlay;
typedef struct _GameHubDataGameOverlayClass GameHubDataGameOverlayClass;

#define GAME_HUB_DATA_TYPE_GAME_SOURCE (game_hub_data_game_source_get_type ())
#define GAME_HUB_DATA_GAME_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GAME_HUB_DATA_TYPE_GAME_SOURCE, GameHubDataGameSource))
#define GAME_HUB_DATA_GAME_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GAME_HUB_DATA_TYPE_GAME_SOURCE, GameHubDataGameSourceClass))
#define GAME_HUB_DATA_IS_GAME_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GAME_HUB_DATA_TYPE_GAME_SOURCE))
#define GAME_HUB_DATA_IS_GAME_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GAME_HUB_DATA_TYPE_GAME_SOURCE))
#define GAME_HUB_DATA_GAME_SOURCE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GAME_HUB_DATA_TYPE_GAME_SOURCE, GameHubDataGameSourceClass))

typedef struct _GameHubDataGameSource GameHubDataGameSource;
typedef struct _GameHubDataGameSourceClass GameHubDataGameSourceClass;

#define GAME_HUB_DATA_DB_TABLES_TAGS_TYPE_TAG (game_hub_data_db_tables_tags_tag_get_type ())
#define GAME_HUB_DATA_DB_TABLES_TAGS_TAG(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GAME_HUB_DATA_DB_TABLES_TAGS_TYPE_TAG, GameHubDataDBTablesTagsTag))
#define GAME_HUB_DATA_DB_TABLES_TAGS_TAG_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GAME_HUB_DATA_DB_TABLES_TAGS_TYPE_TAG, GameHubDataDBTablesTagsTagClass))
#define GAME_HUB_DATA_DB_TABLES_TAGS_IS_TAG(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GAME_HUB_DATA_DB_TABLES_TAGS_TYPE_TAG))
#define GAME_HUB_DATA_DB_TABLES_TAGS_IS_TAG_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GAME_HUB_DATA_DB_TABLES_TAGS_TYPE_TAG))
#define GAME_HUB_DATA_DB_TABLES_TAGS_TAG_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GAME_HUB_DATA_DB_TABLES_TAGS_TYPE_TAG, GameHubDataDBTablesTagsTagClass))

typedef struct _GameHubDataDBTablesTagsTag GameHubDataDBTablesTagsTag;
typedef struct _GameHubDataDBTablesTagsTagClass GameHubDataDBTablesTagsTagClass;

#define GAME_HUB_UTILS_TYPE_FS_OVERLAY (game_hub_utils_fs_overlay_get_type ())
#define GAME_HUB_UTILS_FS_OVERLAY(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GAME_HUB_UTILS_TYPE_FS_OVERLAY, GameHubUtilsFSOverlay))
#define GAME_HUB_UTILS_FS_OVERLAY_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GAME_HUB_UTILS_TYPE_FS_OVERLAY, GameHubUtilsFSOverlayClass))
#define GAME_HUB_UTILS_IS_FS_OVERLAY(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GAME_HUB_UTILS_TYPE_FS_OVERLAY))
#define GAME_HUB_UTILS_IS_FS_OVERLAY_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GAME_HUB_UTILS_TYPE_FS_OVERLAY))
#define GAME_HUB_UTILS_FS_OVERLAY_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GAME_HUB_UTILS_TYPE_FS_OVERLAY, GameHubUtilsFSOverlayClass))

typedef struct _GameHubUtilsFSOverlay GameHubUtilsFSOverlay;
typedef struct _GameHubUtilsFSOverlayClass GameHubUtilsFSOverlayClass;
enum  {
	GAME_HUB_DATA_GAME_0_PROPERTY,
	GAME_HUB_DATA_GAME_SOURCE_PROPERTY,
	GAME_HUB_DATA_GAME_DESCRIPTION_PROPERTY,
	GAME_HUB_DATA_GAME_ICON_PROPERTY,
	GAME_HUB_DATA_GAME_IMAGE_PROPERTY,
	GAME_HUB_DATA_GAME_INFO_PROPERTY,
	GAME_HUB_DATA_GAME_INFO_DETAILED_PROPERTY,
	GAME_HUB_DATA_GAME_FULL_ID_PROPERTY,
	GAME_HUB_DATA_GAME_VERSION_PROPERTY,
	GAME_HUB_DATA_GAME_TAGS_PROPERTY,
	GAME_HUB_DATA_GAME_INSTALLERS_DIR_PROPERTY,
	GAME_HUB_DATA_GAME_IS_INSTALLABLE_PROPERTY,
	GAME_HUB_DATA_GAME_STORE_PAGE_PROPERTY,
	GAME_HUB_DATA_GAME_LAST_LAUNCH_PROPERTY,
	GAME_HUB_DATA_GAME_STATUS_PROPERTY,
	GAME_HUB_DATA_GAME_PLAYTIME_SOURCE_PROPERTY,
	GAME_HUB_DATA_GAME_PLAYTIME_TRACKED_PROPERTY,
	GAME_HUB_DATA_GAME_PLAYTIME_PROPERTY,
	GAME_HUB_DATA_GAME_EXECUTABLE_PROPERTY,
	GAME_HUB_DATA_GAME_OVERLAYS_ENABLED_PROPERTY,
	GAME_HUB_DATA_GAME_ACHIEVEMENTS_PROPERTY,
	GAME_HUB_DATA_GAME_NUM_PROPERTIES
};
static GParamSpec* game_hub_data_game_properties[GAME_HUB_DATA_GAME_NUM_PROPERTIES];
typedef enum  {
	GAME_HUB_DATA_GAME_STATE_UNINSTALLED,
	GAME_HUB_DATA_GAME_STATE_INSTALLED,
	GAME_HUB_DATA_GAME_STATE_DOWNLOADING,
	GAME_HUB_DATA_GAME_STATE_VERIFYING_INSTALLER_INTEGRITY,
	GAME_HUB_DATA_GAME_STATE_INSTALLING
} GameHubDataGameState;

#define GAME_HUB_DATA_GAME_TYPE_STATE (game_hub_data_game_state_get_type ())
#define _game_hub_data_game_source_unref0(var) ((var == NULL) ? NULL : (var = (game_hub_data_game_source_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

#define GAME_HUB_UTILS_DOWNLOADER_TYPE_DOWNLOAD (game_hub_utils_downloader_download_get_type ())
#define GAME_HUB_UTILS_DOWNLOADER_DOWNLOAD(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GAME_HUB_UTILS_DOWNLOADER_TYPE_DOWNLOAD, GameHubUtilsDownloaderDownload))
#define GAME_HUB_UTILS_DOWNLOADER_DOWNLOAD_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GAME_HUB_UTILS_DOWNLOADER_TYPE_DOWNLOAD, GameHubUtilsDownloaderDownloadClass))
#define GAME_HUB_UTILS_DOWNLOADER_IS_DOWNLOAD(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GAME_HUB_UTILS_DOWNLOADER_TYPE_DOWNLOAD))
#define GAME_HUB_UTILS_DOWNLOADER_IS_DOWNLOAD_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GAME_HUB_UTILS_DOWNLOADER_TYPE_DOWNLOAD))
#define GAME_HUB_UTILS_DOWNLOADER_DOWNLOAD_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GAME_HUB_UTILS_DOWNLOADER_TYPE_DOWNLOAD, GameHubUtilsDownloaderDownloadClass))

typedef struct _GameHubUtilsDownloaderDownload GameHubUtilsDownloaderDownload;
typedef struct _GameHubUtilsDownloaderDownloadClass GameHubUtilsDownloaderDownloadClass;
#define _game_hub_data_game_status_unref0(var) ((var == NULL) ? NULL : (var = (game_hub_data_game_status_unref (var), NULL)))
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
typedef struct _GameHubDataGameRunData GameHubDataGameRunData;
typedef struct _GameHubDataGameStatusPrivate GameHubDataGameStatusPrivate;
typedef struct _GameHubDataGameRunOrInstallData GameHubDataGameRunOrInstallData;
typedef struct _GameHubDataGameUpdateGameInfoData GameHubDataGameUpdateGameInfoData;

#define GAME_HUB_DATA_SOURCES_STEAM_TYPE_STEAM_GAME (game_hub_data_sources_steam_steam_game_get_type ())
#define GAME_HUB_DATA_SOURCES_STEAM_STEAM_GAME(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GAME_HUB_DATA_SOURCES_STEAM_TYPE_STEAM_GAME, GameHubDataSourcesSteamSteamGame))
#define GAME_HUB_DATA_SOURCES_STEAM_STEAM_GAME_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GAME_HUB_DATA_SOURCES_STEAM_TYPE_STEAM_GAME, GameHubDataSourcesSteamSteamGameClass))
#define GAME_HUB_DATA_SOURCES_STEAM_IS_STEAM_GAME(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GAME_HUB_DATA_SOURCES_STEAM_TYPE_STEAM_GAME))
#define GAME_HUB_DATA_SOURCES_STEAM_IS_STEAM_GAME_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GAME_HUB_DATA_SOURCES_STEAM_TYPE_STEAM_GAME))
#define GAME_HUB_DATA_SOURCES_STEAM_STEAM_GAME_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GAME_HUB_DATA_SOURCES_STEAM_TYPE_STEAM_GAME, GameHubDataSourcesSteamSteamGameClass))

typedef struct _GameHubDataSourcesSteamSteamGame GameHubDataSourcesSteamSteamGame;
typedef struct _GameHubDataSourcesSteamSteamGameClass GameHubDataSourcesSteamSteamGameClass;
typedef enum  {
	GAME_HUB_UTILS_FS_OVERLAY_ROOT_PATH_SAFETY_SAFE,
	GAME_HUB_UTILS_FS_OVERLAY_ROOT_PATH_SAFETY_UNSAFE,
	GAME_HUB_UTILS_FS_OVERLAY_ROOT_PATH_SAFETY_RESTRICTED
} GameHubUtilsFSOverlayRootPathSafety;

#define GAME_HUB_UTILS_FS_OVERLAY_TYPE_ROOT_PATH_SAFETY (game_hub_utils_fs_overlay_root_path_safety_get_type ())
typedef struct _GameHubDataGameOverlayPrivate GameHubDataGameOverlayPrivate;
#define _json_object_unref0(var) ((var == NULL) ? NULL : (var = (json_object_unref (var), NULL)))
#define __vala_JsonNode_free0(var) ((var == NULL) ? NULL : (var = (_vala_JsonNode_free (var), NULL)))
typedef struct _GameHubDataGameUmountOverlaysData GameHubDataGameUmountOverlaysData;
typedef struct _GameHubDataGameLoadAchievementsData GameHubDataGameLoadAchievementsData;
enum  {
	GAME_HUB_DATA_GAME_OVERLAY_0_PROPERTY,
	GAME_HUB_DATA_GAME_OVERLAY_GAME_PROPERTY,
	GAME_HUB_DATA_GAME_OVERLAY_ID_PROPERTY,
	GAME_HUB_DATA_GAME_OVERLAY_NAME_PROPERTY,
	GAME_HUB_DATA_GAME_OVERLAY_ENABLED_PROPERTY,
	GAME_HUB_DATA_GAME_OVERLAY_REMOVABLE_PROPERTY,
	GAME_HUB_DATA_GAME_OVERLAY_NUM_PROPERTIES
};
static GParamSpec* game_hub_data_game_overlay_properties[GAME_HUB_DATA_GAME_OVERLAY_NUM_PROPERTIES];
#define _game_hub_utils_downloader_download_unref0(var) ((var == NULL) ? NULL : (var = (game_hub_utils_downloader_download_unref (var), NULL)))

#define GAME_HUB_UTILS_DOWNLOADER_TYPE_DOWNLOAD_STATUS (game_hub_utils_downloader_download_status_get_type ())
#define GAME_HUB_UTILS_DOWNLOADER_DOWNLOAD_STATUS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GAME_HUB_UTILS_DOWNLOADER_TYPE_DOWNLOAD_STATUS, GameHubUtilsDownloaderDownloadStatus))
#define GAME_HUB_UTILS_DOWNLOADER_DOWNLOAD_STATUS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GAME_HUB_UTILS_DOWNLOADER_TYPE_DOWNLOAD_STATUS, GameHubUtilsDownloaderDownloadStatusClass))
#define GAME_HUB_UTILS_DOWNLOADER_IS_DOWNLOAD_STATUS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GAME_HUB_UTILS_DOWNLOADER_TYPE_DOWNLOAD_STATUS))
#define GAME_HUB_UTILS_DOWNLOADER_IS_DOWNLOAD_STATUS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GAME_HUB_UTILS_DOWNLOADER_TYPE_DOWNLOAD_STATUS))
#define GAME_HUB_UTILS_DOWNLOADER_DOWNLOAD_STATUS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GAME_HUB_UTILS_DOWNLOADER_TYPE_DOWNLOAD_STATUS, GameHubUtilsDownloaderDownloadStatusClass))

typedef struct _GameHubUtilsDownloaderDownloadStatus GameHubUtilsDownloaderDownloadStatus;
typedef struct _GameHubUtilsDownloaderDownloadStatusClass GameHubUtilsDownloaderDownloadStatusClass;
typedef struct _GameHubDataGameParamSpecStatus GameHubDataGameParamSpecStatus;
typedef struct _GameHubDataGameAchievementPrivate GameHubDataGameAchievementPrivate;
#define _g_date_time_unref0(var) ((var == NULL) ? NULL : (var = (g_date_time_unref (var), NULL)))
typedef struct _GameHubDataGameParamSpecAchievement GameHubDataGameParamSpecAchievement;
enum  {
	GAME_HUB_DATA_GAME_STATUS_CHANGE_SIGNAL,
	GAME_HUB_DATA_GAME_TAGS_UPDATE_SIGNAL,
	GAME_HUB_DATA_GAME_NUM_SIGNALS
};
static guint game_hub_data_game_signals[GAME_HUB_DATA_GAME_NUM_SIGNALS] = {0};

struct _GameHubDataRunnable {
	GObject parent_instance;
	GameHubDataRunnablePrivate * priv;
};

struct _GameHubDataRunnableClass {
	GObjectClass parent_class;
	gboolean (*is_supported) (GameHubDataRunnable* self, GameHubDataPlatform* platform, gboolean with_compat);
	void (*install) (GameHubDataRunnable* self, GameHubDataRunnableInstallerInstallMode install_mode, GAsyncReadyCallback _callback_, gpointer _user_data_);
	void (*install_finish) (GameHubDataRunnable* self, GAsyncResult* _res_);
	void (*run) (GameHubDataRunnable* self, GAsyncReadyCallback _callback_, gpointer _user_data_);
	void (*run_finish) (GameHubDataRunnable* self, GAsyncResult* _res_);
	void (*run_with_compat) (GameHubDataRunnable* self, gboolean is_opened_from_menu, GAsyncReadyCallback _callback_, gpointer _user_data_);
	void (*run_with_compat_finish) (GameHubDataRunnable* self, GAsyncResult* _res_);
	GtkFileChooser* (*setup_executable_chooser) (GameHubDataRunnable* self);
	void (*choose_executable) (GameHubDataRunnable* self, gboolean update);
	void (*set_chosen_executable) (GameHubDataRunnable* self, GFile* file, gboolean update);
	void (*save) (GameHubDataRunnable* self);
	void (*update_status) (GameHubDataRunnable* self);
	void (*import) (GameHubDataRunnable* self, gboolean update);
	GFile* (*get_executable) (GameHubDataRunnable* self);
	void (*set_executable) (GameHubDataRunnable* self, GFile* value);
	GFile* (*get_default_install_dir) (GameHubDataRunnable* self);
};

struct _GameHubDataGame {
	GameHubDataRunnable parent_instance;
	GameHubDataGamePrivate * priv;
	GameHubDataGameStatus* _status;
	GeeArrayList* overlays;
	gchar* executable_path;
};

struct _GameHubDataGameClass {
	GameHubDataRunnableClass parent_class;
	void (*uninstall) (GameHubDataGame* self, GAsyncReadyCallback _callback_, gpointer _user_data_);
	void (*uninstall_finish) (GameHubDataGame* self, GAsyncResult* _res_);
	void (*update_game_info) (GameHubDataGame* self, GAsyncReadyCallback _callback_, gpointer _user_data_);
	void (*update_game_info_finish) (GameHubDataGame* self, GAsyncResult* _res_);
	void (*load_achievements) (GameHubDataGame* self, GAsyncReadyCallback _callback_, gpointer _user_data_);
	GeeArrayList* (*load_achievements_finish) (GameHubDataGame* self, GAsyncResult* _res_);
};

struct _GameHubDataGamePrivate {
	GameHubDataGameSource* _source;
	gchar* _description;
	gchar* _icon;
	gchar* _image;
	gchar* _info;
	gchar* _info_detailed;
	gchar* _version;
	GeeArrayList* _tags;
	GFile* _installers_dir;
	gboolean _is_installable;
	gchar* _store_page;
	gint64 _last_launch;
	gint64 _playtime_source;
	gint64 _playtime_tracked;
	GameHubUtilsFSOverlay* fs_overlay;
	gchar* fs_overlay_last_options;
	GeeArrayList* _achievements;
};

struct _GameHubDataGameRunData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	GameHubDataGame* self;
	gboolean _tmp0_;
	gboolean _tmp1_;
	GFile* _tmp2_;
	GFile* _tmp3_;
	GFile* _tmp4_;
	gchar** cmd;
	GFile* _tmp5_;
	GFile* _tmp6_;
	GFile* _tmp7_;
	gchar* _tmp8_;
	gchar** _tmp9_;
	gchar** _tmp10_;
	gint _tmp10__length1;
	gint cmd_length1;
	gint _cmd_size_;
	gboolean _tmp11_;
	const gchar* _tmp12_;
	const gchar* _tmp13_;
	const gchar* _tmp14_;
	const gchar* _tmp15_;
	gint _tmp16_;
	gint _tmp17_;
	GeeHashMap* variables;
	GeeHashMap* _tmp18_;
	GeeHashMap* _tmp19_;
	const gchar* _tmp20_;
	const gchar* _tmp21_;
	gchar* _tmp22_;
	gchar* _tmp23_;
	gchar* _tmp24_;
	gchar* _tmp25_;
	GeeHashMap* _tmp26_;
	GFile* _tmp27_;
	GFile* _tmp28_;
	gchar* _tmp29_;
	gchar* _tmp30_;
	gchar** args;
	const gchar* _tmp31_;
	const gchar* _tmp32_;
	gint _tmp33_;
	gchar** _tmp34_;
	gint args_length1;
	gint _args_size_;
	gchar** _tmp35_;
	gint _tmp35__length1;
	gchar** _tmp36_;
	gint _tmp36__length1;
	gchar** arg_collection;
	gint arg_collection_length1;
	gint _arg_collection_size_;
	gint arg_it;
	gchar* _tmp37_;
	gchar* arg;
	const gchar* _tmp38_;
	const gchar* _tmp39_;
	GeeHashMap* _tmp40_;
	gchar* _tmp41_;
	gchar** _tmp42_;
	gint _tmp42__length1;
	const gchar* _tmp43_;
	gchar* _tmp44_;
	gchar** _tmp45_;
	gint _tmp45__length1;
	GFile* _tmp46_;
	GFile* _tmp47_;
	GFile* _tmp48_;
	GFile* _tmp49_;
	GFile* _tmp50_;
	gchar* _tmp51_;
	gchar* _tmp52_;
	gchar* _tmp53_;
	gchar* _tmp54_;
	gint64 _tmp55_;
	gint64 _tmp56_;
};

struct _GameHubDataGameStatus {
	GTypeInstance parent_instance;
	volatile int ref_count;
	GameHubDataGameStatusPrivate * priv;
	GameHubDataGameState state;
	GameHubDataGame* game;
	GameHubUtilsDownloaderDownload* download;
};

struct _GameHubDataGameStatusClass {
	GTypeClass parent_class;
	void (*finalize) (GameHubDataGameStatus *self);
};

struct _GameHubDataGameRunOrInstallData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	GameHubDataGame* self;
	gboolean show_compat;
	GameHubDataGameStatus* _tmp0_;
	GameHubDataGameStatus* _tmp1_;
	GameHubDataGameState _tmp2_;
	gboolean _tmp3_;
	gboolean _tmp4_;
	GameHubDataGameStatus* _tmp5_;
	GameHubDataGameStatus* _tmp6_;
	GameHubDataGameState _tmp7_;
};

struct _GameHubDataGameUpdateGameInfoData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	GameHubDataGame* self;
};

struct _GameHubDataGameOverlay {
	GObject parent_instance;
	GameHubDataGameOverlayPrivate * priv;
	GFile* directory;
};

struct _GameHubDataGameOverlayClass {
	GObjectClass parent_class;
};

struct _GameHubDataGameUmountOverlaysData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	GameHubDataGame* self;
	gboolean _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
	GameHubUtilsFSOverlay* _tmp3_;
	GameHubUtilsFSOverlay* _tmp4_;
};

struct _GameHubDataGameLoadAchievementsData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	GameHubDataGame* self;
	GeeArrayList* result;
};

struct _GameHubDataGameOverlayPrivate {
	GameHubDataGame* _game;
	gchar* _id;
	gchar* _name;
	gboolean _enabled;
};

struct _GameHubDataGameParamSpecStatus {
	GParamSpec parent_instance;
};

struct _GameHubDataGameAchievement {
	GTypeInstance parent_instance;
	volatile int ref_count;
	GameHubDataGameAchievementPrivate * priv;
};

struct _GameHubDataGameAchievementClass {
	GTypeClass parent_class;
	void (*finalize) (GameHubDataGameAchievement *self);
};

struct _GameHubDataGameAchievementPrivate {
	gchar* _id;
	gchar* _name;
	gchar* _description;
	gboolean _unlocked;
	GDateTime* _unlock_date;
	gchar* _unlock_time;
	gfloat _global_percentage;
	gchar* _image_locked;
	gchar* _image_unlocked;
};

struct _GameHubDataGameParamSpecAchievement {
	GParamSpec parent_instance;
};

static gint GameHubDataGame_private_offset;
static gpointer game_hub_data_game_parent_class = NULL;
extern GeeArrayList* game_hub_data_db_tables_tags_DYNAMIC_TAGS;
extern gboolean game_hub_data_RunnableIsLaunched;
extern gboolean game_hub_data_sources_steam_steam_IsAnyAppRunning;
static gint GameHubDataGameOverlay_private_offset;
static gpointer game_hub_data_game_overlay_parent_class = NULL;
static gpointer game_hub_data_game_status_parent_class = NULL;
static gint GameHubDataGameAchievement_private_offset;
static gpointer game_hub_data_game_achievement_parent_class = NULL;

GType game_hub_data_runnable_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GameHubDataRunnable, g_object_unref)
GType game_hub_data_platform_get_type (void) G_GNUC_CONST;
GType game_hub_data_runnable_installer_install_mode_get_type (void) G_GNUC_CONST;
GType game_hub_data_game_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GameHubDataGame, g_object_unref)
gpointer game_hub_data_game_achievement_ref (gpointer instance);
void game_hub_data_game_achievement_unref (gpointer instance);
GParamSpec* game_hub_data_game_param_spec_achievement (const gchar* name,
                                                       const gchar* nick,
                                                       const gchar* blurb,
                                                       GType object_type,
                                                       GParamFlags flags);
void game_hub_data_game_value_set_achievement (GValue* value,
                                               gpointer v_object);
void game_hub_data_game_value_take_achievement (GValue* value,
                                                gpointer v_object);
gpointer game_hub_data_game_value_get_achievement (const GValue* value);
GType game_hub_data_game_achievement_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GameHubDataGameAchievement, game_hub_data_game_achievement_unref)
gpointer game_hub_data_game_status_ref (gpointer instance);
void game_hub_data_game_status_unref (gpointer instance);
GParamSpec* game_hub_data_game_param_spec_status (const gchar* name,
                                                  const gchar* nick,
                                                  const gchar* blurb,
                                                  GType object_type,
                                                  GParamFlags flags);
void game_hub_data_game_value_set_status (GValue* value,
                                          gpointer v_object);
void game_hub_data_game_value_take_status (GValue* value,
                                           gpointer v_object);
gpointer game_hub_data_game_value_get_status (const GValue* value);
GType game_hub_data_game_status_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GameHubDataGameStatus, game_hub_data_game_status_unref)
GType game_hub_data_game_overlay_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GameHubDataGameOverlay, g_object_unref)
gpointer game_hub_data_game_source_ref (gpointer instance);
void game_hub_data_game_source_unref (gpointer instance);
GParamSpec* game_hub_data_param_spec_game_source (const gchar* name,
                                                  const gchar* nick,
                                                  const gchar* blurb,
                                                  GType object_type,
                                                  GParamFlags flags);
void game_hub_data_value_set_game_source (GValue* value,
                                          gpointer v_object);
void game_hub_data_value_take_game_source (GValue* value,
                                           gpointer v_object);
gpointer game_hub_data_value_get_game_source (const GValue* value);
GType game_hub_data_game_source_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GameHubDataGameSource, game_hub_data_game_source_unref)
GType game_hub_data_db_tables_tags_tag_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GameHubDataDBTablesTagsTag, g_object_unref)
GType game_hub_utils_fs_overlay_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GameHubUtilsFSOverlay, g_object_unref)
GType game_hub_data_game_state_get_type (void) G_GNUC_CONST;
gboolean game_hub_data_db_tables_tags_tag_is_equal (GameHubDataDBTablesTagsTag* first,
                                                    GameHubDataDBTablesTagsTag* second);
static gboolean _game_hub_data_db_tables_tags_tag_is_equal_gee_equal_data_func (gconstpointer a,
                                                                         gconstpointer b,
                                                                         gpointer self);
gpointer game_hub_utils_downloader_download_ref (gpointer instance);
void game_hub_utils_downloader_download_unref (gpointer instance);
GParamSpec* game_hub_utils_downloader_param_spec_download (const gchar* name,
                                                           const gchar* nick,
                                                           const gchar* blurb,
                                                           GType object_type,
                                                           GParamFlags flags);
void game_hub_utils_downloader_value_set_download (GValue* value,
                                                   gpointer v_object);
void game_hub_utils_downloader_value_take_download (GValue* value,
                                                    gpointer v_object);
gpointer game_hub_utils_downloader_value_get_download (const GValue* value);
GType game_hub_utils_downloader_download_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GameHubUtilsDownloaderDownload, game_hub_utils_downloader_download_unref)
GameHubDataGameStatus* game_hub_data_game_status_new (GameHubDataGameState state,
                                                      GameHubDataGame* game,
                                                      GameHubUtilsDownloaderDownload* download);
GameHubDataGameStatus* game_hub_data_game_status_construct (GType object_type,
                                                            GameHubDataGameState state,
                                                            GameHubDataGame* game,
                                                            GameHubUtilsDownloaderDownload* download);
gboolean game_hub_data_game_has_tag (GameHubDataGame* self,
                                     GameHubDataDBTablesTagsTag* tag);
gboolean game_hub_data_game_has_tag_id (GameHubDataGame* self,
                                        const gchar* tag);
const gchar* game_hub_data_db_tables_tags_tag_get_id (GameHubDataDBTablesTagsTag* self);
GeeArrayList* game_hub_data_game_get_tags (GameHubDataGame* self);
void game_hub_data_game_add_tag (GameHubDataGame* self,
                                 GameHubDataDBTablesTagsTag* tag);
void game_hub_data_runnable_save (GameHubDataRunnable* self);
void game_hub_data_game_remove_tag (GameHubDataGame* self,
                                    GameHubDataDBTablesTagsTag* tag);
void game_hub_data_game_toggle_tag (GameHubDataGame* self,
                                    GameHubDataDBTablesTagsTag* tag);
static void game_hub_data_game_real_save (GameHubDataRunnable* base);
gboolean game_hub_data_db_tables_games_add (GameHubDataGame* game);
void game_hub_data_game_uninstall (GameHubDataGame* self,
                                   GAsyncReadyCallback _callback_,
                                   gpointer _user_data_);
void game_hub_data_game_uninstall_finish (GameHubDataGame* self,
                                          GAsyncResult* _res_);
static void game_hub_data_game_real_run_data_free (gpointer _data);
static void game_hub_data_game_real_run (GameHubDataRunnable* base,
                                  GAsyncReadyCallback _callback_,
                                  gpointer _user_data_);
static gboolean game_hub_data_game_real_run_co (GameHubDataGameRunData* _data_);
GFile* game_hub_data_runnable_get_executable (GameHubDataRunnable* self);
void game_hub_data_runnable_set_is_running (GameHubDataRunnable* self,
                                            gboolean value);
void game_hub_data_runnable_update_status (GameHubDataRunnable* self);
const gchar* game_hub_data_runnable_get_arguments (GameHubDataRunnable* self);
const gchar* game_hub_data_runnable_get_name (GameHubDataRunnable* self);
GFile* game_hub_data_runnable_get_install_dir (GameHubDataRunnable* self);
gchar** game_hub_utils_parse_args (const gchar* args,
                                   gint* result_length1);
gchar* game_hub_utils_fs_utils_expand (const gchar* path,
                                       const gchar* file,
                                       GeeHashMap* variables);
static void _vala_array_add9 (gchar** * array,
                       int* length,
                       int* size,
                       gchar* value);
void game_hub_data_game_set_last_launch (GameHubDataGame* self,
                                         gint64 value);
void game_hub_utils_run_thread (gchar** cmd,
                                gint cmd_length1,
                                const gchar* dir,
                                gchar** env,
                                gint env_length1,
                                gboolean override_runtime,
                                gboolean capture_output,
                                gboolean log,
                                GAsyncReadyCallback _callback_,
                                gpointer _user_data_);
gchar* game_hub_utils_run_thread_finish (GAsyncResult* _res_);
static void game_hub_data_game_run_ready (GObject* source_object,
                                   GAsyncResult* _res_,
                                   gpointer _user_data_);
gint64 game_hub_data_game_get_playtime_tracked (GameHubDataGame* self);
gint64 game_hub_data_game_get_last_launch (GameHubDataGame* self);
void game_hub_data_game_set_playtime_tracked (GameHubDataGame* self,
                                              gint64 value);
static gboolean ___lambda112_ (GameHubDataGame* self);
static gboolean ____lambda112__gsource_func (gpointer self);
static void game_hub_data_game_run_or_install_data_free (gpointer _data);
void game_hub_data_game_run_or_install (GameHubDataGame* self,
                                        gboolean show_compat,
                                        GAsyncReadyCallback _callback_,
                                        gpointer _user_data_);
void game_hub_data_game_run_or_install_finish (GameHubDataGame* self,
                                               GAsyncResult* _res_);
static gboolean game_hub_data_game_run_or_install_co (GameHubDataGameRunOrInstallData* _data_);
GameHubDataGameStatus* game_hub_data_game_get_status (GameHubDataGame* self);
gboolean game_hub_data_runnable_get_use_compat (GameHubDataRunnable* self);
void game_hub_data_runnable_run_with_compat (GameHubDataRunnable* self,
                                             gboolean is_opened_from_menu,
                                             GAsyncReadyCallback _callback_,
                                             gpointer _user_data_);
void game_hub_data_runnable_run_with_compat_finish (GameHubDataRunnable* self,
                                                    GAsyncResult* _res_);
static void game_hub_data_game_run_or_install_ready (GObject* source_object,
                                              GAsyncResult* _res_,
                                              gpointer _user_data_);
void game_hub_data_runnable_run (GameHubDataRunnable* self,
                                 GAsyncReadyCallback _callback_,
                                 gpointer _user_data_);
void game_hub_data_runnable_run_finish (GameHubDataRunnable* self,
                                        GAsyncResult* _res_);
void game_hub_data_runnable_install (GameHubDataRunnable* self,
                                     GameHubDataRunnableInstallerInstallMode install_mode,
                                     GAsyncReadyCallback _callback_,
                                     gpointer _user_data_);
void game_hub_data_runnable_install_finish (GameHubDataRunnable* self,
                                            GAsyncResult* _res_);
static void game_hub_data_game_real_update_game_info_data_free (gpointer _data);
static void game_hub_data_game_real_update_game_info (GameHubDataGame* self,
                                               GAsyncReadyCallback _callback_,
                                               gpointer _user_data_);
void game_hub_data_game_update_game_info (GameHubDataGame* self,
                                          GAsyncReadyCallback _callback_,
                                          gpointer _user_data_);
void game_hub_data_game_update_game_info_finish (GameHubDataGame* self,
                                                 GAsyncResult* _res_);
static gboolean game_hub_data_game_real_update_game_info_co (GameHubDataGameUpdateGameInfoData* _data_);
void game_hub_data_game_update_version (GameHubDataGame* self);
#define GAME_HUB_UTILS_FS_UTILS_GAMEHUB_DIR "_gamehub"
void game_hub_data_game_set_version (GameHubDataGame* self,
                                     const gchar* value);
void game_hub_data_game_save_version (GameHubDataGame* self,
                                      const gchar* ver);
GFile* game_hub_utils_fs_utils_mkdir (const gchar* path,
                                      const gchar* file,
                                      GeeHashMap* variables);
GFile* game_hub_data_game_get_file (GameHubDataGame* self,
                                    const gchar* p,
                                    gboolean from_all_overlays);
gboolean game_hub_data_game_get_overlays_enabled (GameHubDataGame* self);
#define GAME_HUB_DATA_GAME_OVERLAY_BASE "base"
static void _vala_array_add10 (GFile** * array,
                        int* length,
                        int* size,
                        GFile* value);
static void _vala_array_add11 (GFile** * array,
                        int* length,
                        int* size,
                        GFile* value);
void game_hub_data_game_mount_overlays (GameHubDataGame* self,
                                        GFile* persist);
GFile* game_hub_utils_fs_utils_file (const gchar* path,
                                     const gchar* file,
                                     GeeHashMap* variables);
void game_hub_data_game_enable_overlays (GameHubDataGame* self);
GType game_hub_data_sources_steam_steam_game_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GameHubDataSourcesSteamSteamGame, g_object_unref)
GType game_hub_utils_fs_overlay_root_path_safety_get_type (void) G_GNUC_CONST;
GameHubUtilsFSOverlayRootPathSafety game_hub_utils_fs_overlay_root_path_safety_for (GFile* root);
GameHubDataGameOverlay* game_hub_data_game_overlay_new (GameHubDataGame* game,
                                                        const gchar* id,
                                                        const gchar* name,
                                                        gboolean enabled);
GameHubDataGameOverlay* game_hub_data_game_overlay_construct (GType object_type,
                                                              GameHubDataGame* game,
                                                              const gchar* id,
                                                              const gchar* name,
                                                              gboolean enabled);
void game_hub_data_game_save_overlays (GameHubDataGame* self);
#define GAME_HUB_UTILS_FS_UTILS_OVERLAYS_DIR "overlays"
#define GAME_HUB_UTILS_FS_UTILS_OVERLAYS_LIST "overlays.json"
const gchar* game_hub_data_game_overlay_get_id (GameHubDataGameOverlay* self);
const gchar* game_hub_data_game_overlay_get_name (GameHubDataGameOverlay* self);
gboolean game_hub_data_game_overlay_get_enabled (GameHubDataGameOverlay* self);
static void _vala_JsonNode_free (JsonNode* self);
void game_hub_data_game_load_overlays (GameHubDataGame* self);
JsonNode* game_hub_utils_parser_parse_json_file (const gchar* path,
                                                 const gchar* file);
JsonObject* game_hub_utils_parser_json_object (JsonNode* root,
                                               gchar** keys,
                                               gint keys_length1);
GameHubUtilsFSOverlay* game_hub_utils_fs_overlay_new (GFile* target,
                                                      GeeArrayList* overlays,
                                                      GFile* persist,
                                                      GFile* workdir);
GameHubUtilsFSOverlay* game_hub_utils_fs_overlay_construct (GType object_type,
                                                            GFile* target,
                                                            GeeArrayList* overlays,
                                                            GFile* persist,
                                                            GFile* workdir);
const gchar* game_hub_utils_fs_overlay_get_options (GameHubUtilsFSOverlay* self);
void game_hub_utils_fs_overlay_mount (GameHubUtilsFSOverlay* self,
                                      GAsyncReadyCallback _callback_,
                                      gpointer _user_data_);
void game_hub_utils_fs_overlay_mount_finish (GameHubUtilsFSOverlay* self,
                                             GAsyncResult* _res_);
static void game_hub_data_game_umount_overlays_data_free (gpointer _data);
void game_hub_data_game_umount_overlays (GameHubDataGame* self,
                                         GAsyncReadyCallback _callback_,
                                         gpointer _user_data_);
void game_hub_data_game_umount_overlays_finish (GameHubDataGame* self,
                                                GAsyncResult* _res_);
static gboolean game_hub_data_game_umount_overlays_co (GameHubDataGameUmountOverlaysData* _data_);
void game_hub_utils_fs_overlay_umount (GameHubUtilsFSOverlay* self,
                                       GAsyncReadyCallback _callback_,
                                       gpointer _user_data_);
void game_hub_utils_fs_overlay_umount_finish (GameHubUtilsFSOverlay* self,
                                              GAsyncResult* _res_);
static void game_hub_data_game_umount_overlays_ready (GObject* source_object,
                                               GAsyncResult* _res_,
                                               gpointer _user_data_);
static void game_hub_data_game_real_load_achievements_data_free (gpointer _data);
static void game_hub_data_game_real_load_achievements (GameHubDataGame* self,
                                                GAsyncReadyCallback _callback_,
                                                gpointer _user_data_);
void game_hub_data_game_load_achievements (GameHubDataGame* self,
                                           GAsyncReadyCallback _callback_,
                                           gpointer _user_data_);
GeeArrayList* game_hub_data_game_load_achievements_finish (GameHubDataGame* self,
                                                           GAsyncResult* _res_);
static gboolean game_hub_data_game_real_load_achievements_co (GameHubDataGameLoadAchievementsData* _data_);
gboolean game_hub_data_game_is_equal (GameHubDataGame* first,
                                      GameHubDataGame* second);
GameHubDataGameSource* game_hub_data_game_get_source (GameHubDataGame* self);
const gchar* game_hub_data_runnable_get_id (GameHubDataRunnable* self);
guint game_hub_data_game_hash (GameHubDataGame* game);
gchar* game_hub_data_game_get_full_id (GameHubDataGame* self);
GameHubDataGame* game_hub_data_game_construct (GType object_type);
GameHubDataRunnable* game_hub_data_runnable_construct (GType object_type);
void game_hub_data_game_set_source (GameHubDataGame* self,
                                    GameHubDataGameSource* value);
const gchar* game_hub_data_game_get_description (GameHubDataGame* self);
void game_hub_data_game_set_description (GameHubDataGame* self,
                                         const gchar* value);
const gchar* game_hub_data_game_get_icon (GameHubDataGame* self);
void game_hub_data_game_set_icon (GameHubDataGame* self,
                                  const gchar* value);
const gchar* game_hub_data_game_get_image (GameHubDataGame* self);
void game_hub_data_game_set_image (GameHubDataGame* self,
                                   const gchar* value);
const gchar* game_hub_data_game_get_info (GameHubDataGame* self);
void game_hub_data_game_set_info (GameHubDataGame* self,
                                  const gchar* value);
const gchar* game_hub_data_game_get_info_detailed (GameHubDataGame* self);
void game_hub_data_game_set_info_detailed (GameHubDataGame* self,
                                           const gchar* value);
const gchar* game_hub_data_game_source_get_id (GameHubDataGameSource* self);
const gchar* game_hub_data_game_get_version (GameHubDataGame* self);
void game_hub_data_game_set_tags (GameHubDataGame* self,
                                  GeeArrayList* value);
GFile* game_hub_data_game_get_installers_dir (GameHubDataGame* self);
void game_hub_data_game_set_installers_dir (GameHubDataGame* self,
                                            GFile* value);
gboolean game_hub_data_game_get_is_installable (GameHubDataGame* self);
void game_hub_data_game_set_is_installable (GameHubDataGame* self,
                                            gboolean value);
const gchar* game_hub_data_game_get_store_page (GameHubDataGame* self);
void game_hub_data_game_set_store_page (GameHubDataGame* self,
                                        const gchar* value);
void game_hub_data_game_set_status (GameHubDataGame* self,
                                    GameHubDataGameStatus* value);
gint64 game_hub_data_game_get_playtime_source (GameHubDataGame* self);
void game_hub_data_game_set_playtime_source (GameHubDataGame* self,
                                             gint64 value);
gint64 game_hub_data_game_get_playtime (GameHubDataGame* self);
GeeArrayList* game_hub_data_game_get_achievements (GameHubDataGame* self);
void game_hub_data_game_set_achievements (GameHubDataGame* self,
                                          GeeArrayList* value);
static void g_cclosure_user_marshal_VOID__GAME_HUB_DATA_GAME_STATUS (GClosure * closure,
                                                              GValue * return_value,
                                                              guint n_param_values,
                                                              const GValue * param_values,
                                                              gpointer invocation_hint,
                                                              gpointer marshal_data);
void game_hub_data_game_overlay_set_enabled (GameHubDataGameOverlay* self,
                                             gboolean value);
void game_hub_data_game_overlay_remove (GameHubDataGameOverlay* self);
gboolean game_hub_data_game_overlay_get_removable (GameHubDataGameOverlay* self);
GameHubDataGame* game_hub_data_game_overlay_get_game (GameHubDataGameOverlay* self);
static void __lambda84_ (GameHubDataGameOverlay* self,
                  GObject* obj,
                  GAsyncResult* res);
void game_hub_utils_fs_utils_rm (const gchar* path,
                                 const gchar* file,
                                 const gchar* flags,
                                 GeeHashMap* variables);
void game_hub_utils_fs_utils_mv_up (GFile* path,
                                    const gchar* dirname);
static void ___lambda84__gasync_ready_callback (GObject* source_object,
                                         GAsyncResult* res,
                                         gpointer self);
static void game_hub_data_game_overlay_set_game (GameHubDataGameOverlay* self,
                                          GameHubDataGame* value);
static void game_hub_data_game_overlay_set_id (GameHubDataGameOverlay* self,
                                        const gchar* value);
static void game_hub_data_game_overlay_set_name (GameHubDataGameOverlay* self,
                                          const gchar* value);
static GObject * game_hub_data_game_overlay_constructor (GType type,
                                                  guint n_construct_properties,
                                                  GObjectConstructParam * construct_properties);
static void game_hub_data_game_overlay_finalize (GObject * obj);
static void _vala_game_hub_data_game_overlay_get_property (GObject * object,
                                                    guint property_id,
                                                    GValue * value,
                                                    GParamSpec * pspec);
static void _vala_game_hub_data_game_overlay_set_property (GObject * object,
                                                    guint property_id,
                                                    const GValue * value,
                                                    GParamSpec * pspec);
gchar* game_hub_data_game_status_get_description (GameHubDataGameStatus* self);
gboolean game_hub_data_runnable_get_is_running (GameHubDataRunnable* self);
gpointer game_hub_utils_downloader_download_status_ref (gpointer instance);
void game_hub_utils_downloader_download_status_unref (gpointer instance);
GParamSpec* game_hub_utils_downloader_param_spec_download_status (const gchar* name,
                                                                  const gchar* nick,
                                                                  const gchar* blurb,
                                                                  GType object_type,
                                                                  GParamFlags flags);
void game_hub_utils_downloader_value_set_download_status (GValue* value,
                                                          gpointer v_object);
void game_hub_utils_downloader_value_take_download_status (GValue* value,
                                                           gpointer v_object);
gpointer game_hub_utils_downloader_value_get_download_status (const GValue* value);
GType game_hub_utils_downloader_download_status_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GameHubUtilsDownloaderDownloadStatus, game_hub_utils_downloader_download_status_unref)
GameHubUtilsDownloaderDownloadStatus* game_hub_utils_downloader_download_get_status (GameHubUtilsDownloaderDownload* self);
gchar* game_hub_utils_downloader_download_status_get_description (GameHubUtilsDownloaderDownloadStatus* self);
gchar* game_hub_data_game_status_get_header (GameHubDataGameStatus* self);
static void game_hub_data_game_status_finalize (GameHubDataGameStatus * obj);
GameHubDataGameAchievement* game_hub_data_game_achievement_construct (GType object_type);
const gchar* game_hub_data_game_achievement_get_id (GameHubDataGameAchievement* self);
void game_hub_data_game_achievement_set_id (GameHubDataGameAchievement* self,
                                            const gchar* value);
const gchar* game_hub_data_game_achievement_get_name (GameHubDataGameAchievement* self);
void game_hub_data_game_achievement_set_name (GameHubDataGameAchievement* self,
                                              const gchar* value);
const gchar* game_hub_data_game_achievement_get_description (GameHubDataGameAchievement* self);
void game_hub_data_game_achievement_set_description (GameHubDataGameAchievement* self,
                                                     const gchar* value);
gboolean game_hub_data_game_achievement_get_unlocked (GameHubDataGameAchievement* self);
void game_hub_data_game_achievement_set_unlocked (GameHubDataGameAchievement* self,
                                                  gboolean value);
GDateTime* game_hub_data_game_achievement_get_unlock_date (GameHubDataGameAchievement* self);
void game_hub_data_game_achievement_set_unlock_date (GameHubDataGameAchievement* self,
                                                     GDateTime* value);
const gchar* game_hub_data_game_achievement_get_unlock_time (GameHubDataGameAchievement* self);
void game_hub_data_game_achievement_set_unlock_time (GameHubDataGameAchievement* self,
                                                     const gchar* value);
gfloat game_hub_data_game_achievement_get_global_percentage (GameHubDataGameAchievement* self);
void game_hub_data_game_achievement_set_global_percentage (GameHubDataGameAchievement* self,
                                                           gfloat value);
const gchar* game_hub_data_game_achievement_get_image_locked (GameHubDataGameAchievement* self);
void game_hub_data_game_achievement_set_image_locked (GameHubDataGameAchievement* self,
                                                      const gchar* value);
const gchar* game_hub_data_game_achievement_get_image_unlocked (GameHubDataGameAchievement* self);
void game_hub_data_game_achievement_set_image_unlocked (GameHubDataGameAchievement* self,
                                                        const gchar* value);
const gchar* game_hub_data_game_achievement_get_image (GameHubDataGameAchievement* self);
static void game_hub_data_game_achievement_finalize (GameHubDataGameAchievement * obj);
static void game_hub_data_game_finalize (GObject * obj);
static void _vala_game_hub_data_game_get_property (GObject * object,
                                            guint property_id,
                                            GValue * value,
                                            GParamSpec * pspec);
void game_hub_data_runnable_set_executable (GameHubDataRunnable* self,
                                            GFile* value);
static void _vala_game_hub_data_game_set_property (GObject * object,
                                            guint property_id,
                                            const GValue * value,
                                            GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gint array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gint array_length,
                       GDestroyNotify destroy_func);

static inline gpointer
game_hub_data_game_get_instance_private (GameHubDataGame* self)
{
	return G_STRUCT_MEMBER_P (self, GameHubDataGame_private_offset);
}

GType
game_hub_data_game_state_get_type (void)
{
	static volatile gsize game_hub_data_game_state_type_id__volatile = 0;
	if (g_once_init_enter (&game_hub_data_game_state_type_id__volatile)) {
		static const GEnumValue values[] = {{GAME_HUB_DATA_GAME_STATE_UNINSTALLED, "GAME_HUB_DATA_GAME_STATE_UNINSTALLED", "uninstalled"}, {GAME_HUB_DATA_GAME_STATE_INSTALLED, "GAME_HUB_DATA_GAME_STATE_INSTALLED", "installed"}, {GAME_HUB_DATA_GAME_STATE_DOWNLOADING, "GAME_HUB_DATA_GAME_STATE_DOWNLOADING", "downloading"}, {GAME_HUB_DATA_GAME_STATE_VERIFYING_INSTALLER_INTEGRITY, "GAME_HUB_DATA_GAME_STATE_VERIFYING_INSTALLER_INTEGRITY", "verifying-installer-integrity"}, {GAME_HUB_DATA_GAME_STATE_INSTALLING, "GAME_HUB_DATA_GAME_STATE_INSTALLING", "installing"}, {0, NULL, NULL}};
		GType game_hub_data_game_state_type_id;
		game_hub_data_game_state_type_id = g_enum_register_static ("GameHubDataGameState", values);
		g_once_init_leave (&game_hub_data_game_state_type_id__volatile, game_hub_data_game_state_type_id);
	}
	return game_hub_data_game_state_type_id__volatile;
}

static gboolean
_game_hub_data_db_tables_tags_tag_is_equal_gee_equal_data_func (gconstpointer a,
                                                                gconstpointer b,
                                                                gpointer self)
{
	gboolean result;
	result = game_hub_data_db_tables_tags_tag_is_equal ((GameHubDataDBTablesTagsTag*) a, (GameHubDataDBTablesTagsTag*) b);
#line 43 "../src/data/Game.vala"
	return result;
#line 968 "Game.c"
}

gboolean
game_hub_data_game_has_tag (GameHubDataGame* self,
                            GameHubDataDBTablesTagsTag* tag)
{
	gboolean result = FALSE;
	const gchar* _tmp0_;
	const gchar* _tmp1_;
#line 44 "../src/data/Game.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 44 "../src/data/Game.vala"
	g_return_val_if_fail (tag != NULL, FALSE);
#line 46 "../src/data/Game.vala"
	_tmp0_ = game_hub_data_db_tables_tags_tag_get_id (tag);
#line 46 "../src/data/Game.vala"
	_tmp1_ = _tmp0_;
#line 46 "../src/data/Game.vala"
	result = game_hub_data_game_has_tag_id (self, _tmp1_);
#line 46 "../src/data/Game.vala"
	return result;
#line 990 "Game.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 50 "../src/data/Game.vala"
	return self ? g_object_ref (self) : NULL;
#line 998 "Game.c"
}

gboolean
game_hub_data_game_has_tag_id (GameHubDataGame* self,
                               const gchar* tag)
{
	gboolean result = FALSE;
#line 48 "../src/data/Game.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 48 "../src/data/Game.vala"
	g_return_val_if_fail (tag != NULL, FALSE);
#line 1010 "Game.c"
	{
		GeeArrayList* _t_list = NULL;
		GeeArrayList* _tmp0_;
		GeeArrayList* _tmp1_;
		gint _t_size = 0;
		GeeArrayList* _tmp2_;
		gint _tmp3_;
		gint _tmp4_;
		gint _t_index = 0;
#line 50 "../src/data/Game.vala"
		_tmp0_ = self->priv->_tags;
#line 50 "../src/data/Game.vala"
		_tmp1_ = _g_object_ref0 (_tmp0_);
#line 50 "../src/data/Game.vala"
		_t_list = _tmp1_;
#line 50 "../src/data/Game.vala"
		_tmp2_ = _t_list;
#line 50 "../src/data/Game.vala"
		_tmp3_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp2_);
#line 50 "../src/data/Game.vala"
		_tmp4_ = _tmp3_;
#line 50 "../src/data/Game.vala"
		_t_size = _tmp4_;
#line 50 "../src/data/Game.vala"
		_t_index = -1;
#line 50 "../src/data/Game.vala"
		while (TRUE) {
#line 1038 "Game.c"
			GameHubDataDBTablesTagsTag* t = NULL;
			GeeArrayList* _tmp5_;
			gpointer _tmp6_;
			GameHubDataDBTablesTagsTag* _tmp7_;
			const gchar* _tmp8_;
			const gchar* _tmp9_;
#line 50 "../src/data/Game.vala"
			_t_index = _t_index + 1;
#line 50 "../src/data/Game.vala"
			if (!(_t_index < _t_size)) {
#line 50 "../src/data/Game.vala"
				break;
#line 1051 "Game.c"
			}
#line 50 "../src/data/Game.vala"
			_tmp5_ = _t_list;
#line 50 "../src/data/Game.vala"
			_tmp6_ = gee_abstract_list_get ((GeeAbstractList*) _tmp5_, _t_index);
#line 50 "../src/data/Game.vala"
			t = (GameHubDataDBTablesTagsTag*) _tmp6_;
#line 52 "../src/data/Game.vala"
			_tmp7_ = t;
#line 52 "../src/data/Game.vala"
			_tmp8_ = game_hub_data_db_tables_tags_tag_get_id (_tmp7_);
#line 52 "../src/data/Game.vala"
			_tmp9_ = _tmp8_;
#line 52 "../src/data/Game.vala"
			if (g_strcmp0 (_tmp9_, tag) == 0) {
#line 52 "../src/data/Game.vala"
				result = TRUE;
#line 52 "../src/data/Game.vala"
				_g_object_unref0 (t);
#line 52 "../src/data/Game.vala"
				_g_object_unref0 (_t_list);
#line 52 "../src/data/Game.vala"
				return result;
#line 1075 "Game.c"
			}
#line 50 "../src/data/Game.vala"
			_g_object_unref0 (t);
#line 1079 "Game.c"
		}
#line 50 "../src/data/Game.vala"
		_g_object_unref0 (_t_list);
#line 1083 "Game.c"
	}
#line 54 "../src/data/Game.vala"
	result = FALSE;
#line 54 "../src/data/Game.vala"
	return result;
#line 1089 "Game.c"
}

void
game_hub_data_game_add_tag (GameHubDataGame* self,
                            GameHubDataDBTablesTagsTag* tag)
{
	GeeArrayList* _tmp0_;
	GeeArrayList* _tmp2_;
#line 56 "../src/data/Game.vala"
	g_return_if_fail (self != NULL);
#line 56 "../src/data/Game.vala"
	g_return_if_fail (tag != NULL);
#line 58 "../src/data/Game.vala"
	_tmp0_ = self->priv->_tags;
#line 58 "../src/data/Game.vala"
	if (!gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp0_, tag)) {
#line 1106 "Game.c"
		GeeArrayList* _tmp1_;
#line 60 "../src/data/Game.vala"
		_tmp1_ = self->priv->_tags;
#line 60 "../src/data/Game.vala"
		gee_abstract_collection_add ((GeeAbstractCollection*) _tmp1_, tag);
#line 1112 "Game.c"
	}
#line 62 "../src/data/Game.vala"
	_tmp2_ = game_hub_data_db_tables_tags_DYNAMIC_TAGS;
#line 62 "../src/data/Game.vala"
	if (!gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp2_, tag)) {
#line 1118 "Game.c"
		GameHubDataGameStatus* _tmp3_;
#line 64 "../src/data/Game.vala"
		game_hub_data_runnable_save ((GameHubDataRunnable*) self);
#line 65 "../src/data/Game.vala"
		_tmp3_ = self->_status;
#line 65 "../src/data/Game.vala"
		g_signal_emit (self, game_hub_data_game_signals[GAME_HUB_DATA_GAME_STATUS_CHANGE_SIGNAL], 0, _tmp3_);
#line 66 "../src/data/Game.vala"
		g_signal_emit (self, game_hub_data_game_signals[GAME_HUB_DATA_GAME_TAGS_UPDATE_SIGNAL], 0);
#line 1128 "Game.c"
	}
}

void
game_hub_data_game_remove_tag (GameHubDataGame* self,
                               GameHubDataDBTablesTagsTag* tag)
{
	GeeArrayList* _tmp0_;
	GeeArrayList* _tmp2_;
#line 69 "../src/data/Game.vala"
	g_return_if_fail (self != NULL);
#line 69 "../src/data/Game.vala"
	g_return_if_fail (tag != NULL);
#line 71 "../src/data/Game.vala"
	_tmp0_ = self->priv->_tags;
#line 71 "../src/data/Game.vala"
	if (gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp0_, tag)) {
#line 1146 "Game.c"
		GeeArrayList* _tmp1_;
#line 73 "../src/data/Game.vala"
		_tmp1_ = self->priv->_tags;
#line 73 "../src/data/Game.vala"
		gee_abstract_collection_remove ((GeeAbstractCollection*) _tmp1_, tag);
#line 1152 "Game.c"
	}
#line 75 "../src/data/Game.vala"
	_tmp2_ = game_hub_data_db_tables_tags_DYNAMIC_TAGS;
#line 75 "../src/data/Game.vala"
	if (!gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp2_, tag)) {
#line 1158 "Game.c"
		GameHubDataGameStatus* _tmp3_;
#line 77 "../src/data/Game.vala"
		game_hub_data_runnable_save ((GameHubDataRunnable*) self);
#line 78 "../src/data/Game.vala"
		_tmp3_ = self->_status;
#line 78 "../src/data/Game.vala"
		g_signal_emit (self, game_hub_data_game_signals[GAME_HUB_DATA_GAME_STATUS_CHANGE_SIGNAL], 0, _tmp3_);
#line 79 "../src/data/Game.vala"
		g_signal_emit (self, game_hub_data_game_signals[GAME_HUB_DATA_GAME_TAGS_UPDATE_SIGNAL], 0);
#line 1168 "Game.c"
	}
}

void
game_hub_data_game_toggle_tag (GameHubDataGame* self,
                               GameHubDataDBTablesTagsTag* tag)
{
	GeeArrayList* _tmp0_;
#line 82 "../src/data/Game.vala"
	g_return_if_fail (self != NULL);
#line 82 "../src/data/Game.vala"
	g_return_if_fail (tag != NULL);
#line 84 "../src/data/Game.vala"
	_tmp0_ = self->priv->_tags;
#line 84 "../src/data/Game.vala"
	if (gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp0_, tag)) {
#line 86 "../src/data/Game.vala"
		game_hub_data_game_remove_tag (self, tag);
#line 1187 "Game.c"
	} else {
#line 90 "../src/data/Game.vala"
		game_hub_data_game_add_tag (self, tag);
#line 1191 "Game.c"
	}
}

static void
game_hub_data_game_real_save (GameHubDataRunnable* base)
{
	GameHubDataGame * self;
#line 94 "../src/data/Game.vala"
	self = (GameHubDataGame*) base;
#line 96 "../src/data/Game.vala"
	game_hub_data_db_tables_games_add (self);
#line 1203 "Game.c"
}

void
game_hub_data_game_uninstall (GameHubDataGame* self,
                              GAsyncReadyCallback _callback_,
                              gpointer _user_data_)
{
#line 27 "../src/data/Game.vala"
	GAME_HUB_DATA_GAME_GET_CLASS (self)->uninstall (self, _callback_, _user_data_);
#line 1213 "Game.c"
}

void
game_hub_data_game_uninstall_finish (GameHubDataGame* self,
                                     GAsyncResult* _res_)
{
#line 27 "../src/data/Game.vala"
	GAME_HUB_DATA_GAME_GET_CLASS (self)->uninstall_finish (self, _res_);
#line 1222 "Game.c"
}

static void
game_hub_data_game_real_run_data_free (gpointer _data)
{
	GameHubDataGameRunData* _data_;
	_data_ = _data;
#line 27 "../src/data/Game.vala"
	_g_object_unref0 (_data_->self);
#line 27 "../src/data/Game.vala"
	g_slice_free (GameHubDataGameRunData, _data_);
#line 1234 "Game.c"
}

static void
game_hub_data_game_real_run (GameHubDataRunnable* base,
                             GAsyncReadyCallback _callback_,
                             gpointer _user_data_)
{
	GameHubDataGame * self;
	GameHubDataGameRunData* _data_;
	GameHubDataGame* _tmp0_;
#line 27 "../src/data/Game.vala"
	self = (GameHubDataGame*) base;
#line 27 "../src/data/Game.vala"
	_data_ = g_slice_new0 (GameHubDataGameRunData);
#line 27 "../src/data/Game.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 27 "../src/data/Game.vala"
	g_task_set_task_data (_data_->_async_result, _data_, game_hub_data_game_real_run_data_free);
#line 27 "../src/data/Game.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 27 "../src/data/Game.vala"
	_data_->self = _tmp0_;
#line 27 "../src/data/Game.vala"
	game_hub_data_game_real_run_co (_data_);
#line 1259 "Game.c"
}

static void
game_hub_data_game_run_finish (GameHubDataRunnable* base,
                               GAsyncResult* _res_)
{
	GameHubDataGameRunData* _data_;
#line 27 "../src/data/Game.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 1269 "Game.c"
}

static gchar*
string_replace (const gchar* self,
                const gchar* old,
                const gchar* replacement)
{
	gchar* result = NULL;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	GError* _inner_error0_ = NULL;
#line 1480 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1480 "glib-2.0.vapi"
	g_return_val_if_fail (old != NULL, NULL);
#line 1480 "glib-2.0.vapi"
	g_return_val_if_fail (replacement != NULL, NULL);
#line 1481 "glib-2.0.vapi"
	if ((*((gchar*) self)) == '\0') {
#line 1481 "glib-2.0.vapi"
		_tmp1_ = TRUE;
#line 1291 "Game.c"
	} else {
#line 1481 "glib-2.0.vapi"
		_tmp1_ = (*((gchar*) old)) == '\0';
#line 1295 "Game.c"
	}
#line 1481 "glib-2.0.vapi"
	if (_tmp1_) {
#line 1481 "glib-2.0.vapi"
		_tmp0_ = TRUE;
#line 1301 "Game.c"
	} else {
#line 1481 "glib-2.0.vapi"
		_tmp0_ = g_strcmp0 (old, replacement) == 0;
#line 1305 "Game.c"
	}
#line 1481 "glib-2.0.vapi"
	if (_tmp0_) {
#line 1309 "Game.c"
		gchar* _tmp2_;
#line 1482 "glib-2.0.vapi"
		_tmp2_ = g_strdup (self);
#line 1482 "glib-2.0.vapi"
		result = _tmp2_;
#line 1482 "glib-2.0.vapi"
		return result;
#line 1317 "Game.c"
	}
	{
		GRegex* regex = NULL;
		gchar* _tmp3_;
		gchar* _tmp4_;
		GRegex* _tmp5_;
		GRegex* _tmp6_;
		gchar* _tmp7_ = NULL;
		GRegex* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
#line 1485 "glib-2.0.vapi"
		_tmp3_ = g_regex_escape_string (old, -1);
#line 1485 "glib-2.0.vapi"
		_tmp4_ = _tmp3_;
#line 1485 "glib-2.0.vapi"
		_tmp5_ = g_regex_new (_tmp4_, 0, 0, &_inner_error0_);
#line 1485 "glib-2.0.vapi"
		_tmp6_ = _tmp5_;
#line 1485 "glib-2.0.vapi"
		_g_free0 (_tmp4_);
#line 1485 "glib-2.0.vapi"
		regex = _tmp6_;
#line 1485 "glib-2.0.vapi"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1485 "glib-2.0.vapi"
			if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 1345 "Game.c"
				goto __catch8_g_regex_error;
			}
#line 1485 "glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1485 "glib-2.0.vapi"
			g_clear_error (&_inner_error0_);
#line 1485 "glib-2.0.vapi"
			return NULL;
#line 1354 "Game.c"
		}
#line 1486 "glib-2.0.vapi"
		_tmp8_ = regex;
#line 1486 "glib-2.0.vapi"
		_tmp9_ = g_regex_replace_literal (_tmp8_, self, (gssize) -1, 0, replacement, 0, &_inner_error0_);
#line 1486 "glib-2.0.vapi"
		_tmp7_ = _tmp9_;
#line 1486 "glib-2.0.vapi"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1486 "glib-2.0.vapi"
			_g_regex_unref0 (regex);
#line 1486 "glib-2.0.vapi"
			if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 1368 "Game.c"
				goto __catch8_g_regex_error;
			}
#line 1486 "glib-2.0.vapi"
			_g_regex_unref0 (regex);
#line 1486 "glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1486 "glib-2.0.vapi"
			g_clear_error (&_inner_error0_);
#line 1486 "glib-2.0.vapi"
			return NULL;
#line 1379 "Game.c"
		}
#line 1486 "glib-2.0.vapi"
		_tmp10_ = _tmp7_;
#line 1486 "glib-2.0.vapi"
		_tmp7_ = NULL;
#line 1486 "glib-2.0.vapi"
		result = _tmp10_;
#line 1486 "glib-2.0.vapi"
		_g_free0 (_tmp7_);
#line 1486 "glib-2.0.vapi"
		_g_regex_unref0 (regex);
#line 1486 "glib-2.0.vapi"
		return result;
#line 1393 "Game.c"
	}
	goto __finally8;
	__catch8_g_regex_error:
	{
		GError* e = NULL;
#line 1484 "glib-2.0.vapi"
		e = _inner_error0_;
#line 1484 "glib-2.0.vapi"
		_inner_error0_ = NULL;
#line 1488 "glib-2.0.vapi"
		g_assert_not_reached ();
#line 1484 "glib-2.0.vapi"
		_g_error_free0 (e);
#line 1407 "Game.c"
	}
	__finally8:
#line 1484 "glib-2.0.vapi"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1484 "glib-2.0.vapi"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1484 "glib-2.0.vapi"
		g_clear_error (&_inner_error0_);
#line 1484 "glib-2.0.vapi"
		return NULL;
#line 1418 "Game.c"
	}
}

static gboolean
string_contains (const gchar* self,
                 const gchar* needle)
{
	gboolean result = FALSE;
	gchar* _tmp0_;
#line 1476 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1476 "glib-2.0.vapi"
	g_return_val_if_fail (needle != NULL, FALSE);
#line 1477 "glib-2.0.vapi"
	_tmp0_ = strstr ((gchar*) self, (gchar*) needle);
#line 1477 "glib-2.0.vapi"
	result = _tmp0_ != NULL;
#line 1477 "glib-2.0.vapi"
	return result;
#line 1438 "Game.c"
}

static void
_vala_array_add9 (gchar** * array,
                  int* length,
                  int* size,
                  gchar* value)
{
#line 131 "../src/data/Game.vala"
	if ((*length) == (*size)) {
#line 131 "../src/data/Game.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 131 "../src/data/Game.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 1453 "Game.c"
	}
#line 131 "../src/data/Game.vala"
	(*array)[(*length)++] = value;
#line 131 "../src/data/Game.vala"
	(*array)[*length] = NULL;
#line 1459 "Game.c"
}

static void
game_hub_data_game_run_ready (GObject* source_object,
                              GAsyncResult* _res_,
                              gpointer _user_data_)
{
	GameHubDataGameRunData* _data_;
#line 138 "../src/data/Game.vala"
	_data_ = _user_data_;
#line 138 "../src/data/Game.vala"
	_data_->_source_object_ = source_object;
#line 138 "../src/data/Game.vala"
	_data_->_res_ = _res_;
#line 138 "../src/data/Game.vala"
	game_hub_data_game_real_run_co (_data_);
#line 1476 "Game.c"
}

static gboolean
___lambda112_ (GameHubDataGame* self)
{
	gboolean result = FALSE;
#line 143 "../src/data/Game.vala"
	game_hub_data_runnable_set_is_running ((GameHubDataRunnable*) self, FALSE);
#line 143 "../src/data/Game.vala"
	game_hub_data_RunnableIsLaunched = FALSE;
#line 144 "../src/data/Game.vala"
	game_hub_data_runnable_update_status ((GameHubDataRunnable*) self);
#line 145 "../src/data/Game.vala"
	result = G_SOURCE_REMOVE;
#line 145 "../src/data/Game.vala"
	return result;
#line 1493 "Game.c"
}

static gboolean
____lambda112__gsource_func (gpointer self)
{
	gboolean result;
	result = ___lambda112_ ((GameHubDataGame*) self);
#line 142 "../src/data/Game.vala"
	return result;
#line 1503 "Game.c"
}

static gboolean
game_hub_data_game_real_run_co (GameHubDataGameRunData* _data_)
{
#line 108 "../src/data/Game.vala"
	switch (_data_->_state_) {
#line 108 "../src/data/Game.vala"
		case 0:
#line 1513 "Game.c"
		goto _state_0;
#line 108 "../src/data/Game.vala"
		case 1:
#line 1517 "Game.c"
		goto _state_1;
		default:
#line 108 "../src/data/Game.vala"
		g_assert_not_reached ();
#line 1522 "Game.c"
	}
	_state_0:
#line 110 "../src/data/Game.vala"
	if (!game_hub_data_RunnableIsLaunched) {
#line 110 "../src/data/Game.vala"
		_data_->_tmp1_ = !game_hub_data_sources_steam_steam_IsAnyAppRunning;
#line 1529 "Game.c"
	} else {
#line 110 "../src/data/Game.vala"
		_data_->_tmp1_ = FALSE;
#line 1533 "Game.c"
	}
#line 110 "../src/data/Game.vala"
	if (_data_->_tmp1_) {
#line 110 "../src/data/Game.vala"
		_data_->_tmp2_ = game_hub_data_runnable_get_executable ((GameHubDataRunnable*) _data_->self);
#line 110 "../src/data/Game.vala"
		_data_->_tmp3_ = _data_->_tmp2_;
#line 110 "../src/data/Game.vala"
		_data_->_tmp4_ = _data_->_tmp3_;
#line 110 "../src/data/Game.vala"
		_data_->_tmp0_ = g_file_query_exists (_data_->_tmp4_, NULL);
#line 110 "../src/data/Game.vala"
		_g_object_unref0 (_data_->_tmp4_);
#line 1547 "Game.c"
	} else {
#line 110 "../src/data/Game.vala"
		_data_->_tmp0_ = FALSE;
#line 1551 "Game.c"
	}
#line 110 "../src/data/Game.vala"
	if (_data_->_tmp0_) {
#line 112 "../src/data/Game.vala"
		game_hub_data_runnable_set_is_running ((GameHubDataRunnable*) _data_->self, TRUE);
#line 112 "../src/data/Game.vala"
		game_hub_data_RunnableIsLaunched = TRUE;
#line 113 "../src/data/Game.vala"
		game_hub_data_runnable_update_status ((GameHubDataRunnable*) _data_->self);
#line 115 "../src/data/Game.vala"
		_data_->_tmp5_ = game_hub_data_runnable_get_executable ((GameHubDataRunnable*) _data_->self);
#line 115 "../src/data/Game.vala"
		_data_->_tmp6_ = _data_->_tmp5_;
#line 115 "../src/data/Game.vala"
		_data_->_tmp7_ = _data_->_tmp6_;
#line 115 "../src/data/Game.vala"
		_data_->_tmp8_ = g_file_get_path (_data_->_tmp7_);
#line 115 "../src/data/Game.vala"
		_data_->_tmp9_ = g_new0 (gchar*, 1 + 1);
#line 115 "../src/data/Game.vala"
		_data_->_tmp9_[0] = _data_->_tmp8_;
#line 115 "../src/data/Game.vala"
		_data_->_tmp10_ = _data_->_tmp9_;
#line 115 "../src/data/Game.vala"
		_data_->_tmp10__length1 = 1;
#line 115 "../src/data/Game.vala"
		_g_object_unref0 (_data_->_tmp7_);
#line 115 "../src/data/Game.vala"
		_data_->cmd = _data_->_tmp10_;
#line 115 "../src/data/Game.vala"
		_data_->cmd_length1 = _data_->_tmp10__length1;
#line 115 "../src/data/Game.vala"
		_data_->_cmd_size_ = _data_->cmd_length1;
#line 117 "../src/data/Game.vala"
		_data_->_tmp12_ = game_hub_data_runnable_get_arguments ((GameHubDataRunnable*) _data_->self);
#line 117 "../src/data/Game.vala"
		_data_->_tmp13_ = _data_->_tmp12_;
#line 117 "../src/data/Game.vala"
		if (_data_->_tmp13_ != NULL) {
#line 117 "../src/data/Game.vala"
			_data_->_tmp14_ = game_hub_data_runnable_get_arguments ((GameHubDataRunnable*) _data_->self);
#line 117 "../src/data/Game.vala"
			_data_->_tmp15_ = _data_->_tmp14_;
#line 117 "../src/data/Game.vala"
			_data_->_tmp16_ = strlen (_data_->_tmp15_);
#line 117 "../src/data/Game.vala"
			_data_->_tmp17_ = _data_->_tmp16_;
#line 117 "../src/data/Game.vala"
			_data_->_tmp11_ = _data_->_tmp17_ > 0;
#line 1601 "Game.c"
		} else {
#line 117 "../src/data/Game.vala"
			_data_->_tmp11_ = FALSE;
#line 1605 "Game.c"
		}
#line 117 "../src/data/Game.vala"
		if (_data_->_tmp11_) {
#line 119 "../src/data/Game.vala"
			_data_->_tmp18_ = gee_hash_map_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 119 "../src/data/Game.vala"
			_data_->variables = _data_->_tmp18_;
#line 120 "../src/data/Game.vala"
			_data_->_tmp19_ = _data_->variables;
#line 120 "../src/data/Game.vala"
			_data_->_tmp20_ = game_hub_data_runnable_get_name ((GameHubDataRunnable*) _data_->self);
#line 120 "../src/data/Game.vala"
			_data_->_tmp21_ = _data_->_tmp20_;
#line 120 "../src/data/Game.vala"
			_data_->_tmp22_ = string_replace (_data_->_tmp21_, ": ", " - ");
#line 120 "../src/data/Game.vala"
			_data_->_tmp23_ = _data_->_tmp22_;
#line 120 "../src/data/Game.vala"
			_data_->_tmp24_ = string_replace (_data_->_tmp23_, ":", "");
#line 120 "../src/data/Game.vala"
			_data_->_tmp25_ = _data_->_tmp24_;
#line 120 "../src/data/Game.vala"
			gee_abstract_map_set ((GeeAbstractMap*) _data_->_tmp19_, "game", _data_->_tmp25_);
#line 120 "../src/data/Game.vala"
			_g_free0 (_data_->_tmp25_);
#line 120 "../src/data/Game.vala"
			_g_free0 (_data_->_tmp23_);
#line 121 "../src/data/Game.vala"
			_data_->_tmp26_ = _data_->variables;
#line 121 "../src/data/Game.vala"
			_data_->_tmp27_ = game_hub_data_runnable_get_install_dir ((GameHubDataRunnable*) _data_->self);
#line 121 "../src/data/Game.vala"
			_data_->_tmp28_ = _data_->_tmp27_;
#line 121 "../src/data/Game.vala"
			_data_->_tmp29_ = g_file_get_path (_data_->_tmp28_);
#line 121 "../src/data/Game.vala"
			_data_->_tmp30_ = _data_->_tmp29_;
#line 121 "../src/data/Game.vala"
			gee_abstract_map_set ((GeeAbstractMap*) _data_->_tmp26_, "game_dir", _data_->_tmp30_);
#line 121 "../src/data/Game.vala"
			_g_free0 (_data_->_tmp30_);
#line 122 "../src/data/Game.vala"
			_data_->_tmp31_ = game_hub_data_runnable_get_arguments ((GameHubDataRunnable*) _data_->self);
#line 122 "../src/data/Game.vala"
			_data_->_tmp32_ = _data_->_tmp31_;
#line 122 "../src/data/Game.vala"
			_data_->_tmp33_ = 0;
#line 122 "../src/data/Game.vala"
			_data_->_tmp34_ = game_hub_utils_parse_args (_data_->_tmp32_, &_data_->_tmp33_);
#line 122 "../src/data/Game.vala"
			_data_->args = _data_->_tmp34_;
#line 122 "../src/data/Game.vala"
			_data_->args_length1 = _data_->_tmp33_;
#line 122 "../src/data/Game.vala"
			_data_->_args_size_ = _data_->args_length1;
#line 123 "../src/data/Game.vala"
			_data_->_tmp35_ = _data_->args;
#line 123 "../src/data/Game.vala"
			_data_->_tmp35__length1 = _data_->args_length1;
#line 123 "../src/data/Game.vala"
			if (_data_->_tmp35_ != NULL) {
#line 125 "../src/data/Game.vala"
				_data_->_tmp36_ = _data_->args;
#line 125 "../src/data/Game.vala"
				_data_->_tmp36__length1 = _data_->args_length1;
#line 1671 "Game.c"
				{
#line 125 "../src/data/Game.vala"
					_data_->arg_collection_length1 = 0;
#line 125 "../src/data/Game.vala"
					_data_->_arg_collection_size_ = 0;
#line 125 "../src/data/Game.vala"
					_data_->arg_collection = _data_->_tmp36_;
#line 125 "../src/data/Game.vala"
					_data_->arg_collection_length1 = _data_->_tmp36__length1;
#line 125 "../src/data/Game.vala"
					for (_data_->arg_it = 0; _data_->arg_it < _data_->arg_collection_length1; _data_->arg_it = _data_->arg_it + 1) {
#line 125 "../src/data/Game.vala"
						_data_->_tmp37_ = g_strdup (_data_->arg_collection[_data_->arg_it]);
#line 125 "../src/data/Game.vala"
						_data_->arg = _data_->_tmp37_;
#line 1687 "Game.c"
						{
#line 127 "../src/data/Game.vala"
							_data_->_tmp38_ = _data_->arg;
#line 127 "../src/data/Game.vala"
							if (string_contains (_data_->_tmp38_, "$")) {
#line 129 "../src/data/Game.vala"
								_data_->_tmp39_ = _data_->arg;
#line 129 "../src/data/Game.vala"
								_data_->_tmp40_ = _data_->variables;
#line 129 "../src/data/Game.vala"
								_data_->_tmp41_ = game_hub_utils_fs_utils_expand (_data_->_tmp39_, NULL, _data_->_tmp40_);
#line 129 "../src/data/Game.vala"
								_g_free0 (_data_->arg);
#line 129 "../src/data/Game.vala"
								_data_->arg = _data_->_tmp41_;
#line 1703 "Game.c"
							}
#line 131 "../src/data/Game.vala"
							_data_->_tmp42_ = _data_->cmd;
#line 131 "../src/data/Game.vala"
							_data_->_tmp42__length1 = _data_->cmd_length1;
#line 131 "../src/data/Game.vala"
							_data_->_tmp43_ = _data_->arg;
#line 131 "../src/data/Game.vala"
							_data_->_tmp44_ = g_strdup (_data_->_tmp43_);
#line 131 "../src/data/Game.vala"
							_vala_array_add9 (&_data_->cmd, &_data_->cmd_length1, &_data_->_cmd_size_, _data_->_tmp44_);
#line 125 "../src/data/Game.vala"
							_g_free0 (_data_->arg);
#line 1717 "Game.c"
						}
					}
				}
			}
#line 117 "../src/data/Game.vala"
			_data_->args = (_vala_array_free (_data_->args, _data_->args_length1, (GDestroyNotify) g_free), NULL);
#line 117 "../src/data/Game.vala"
			_g_object_unref0 (_data_->variables);
#line 1726 "Game.c"
		}
#line 136 "../src/data/Game.vala"
		game_hub_data_game_set_last_launch (_data_->self, g_get_real_time () / 1000000);
#line 137 "../src/data/Game.vala"
		game_hub_data_runnable_save ((GameHubDataRunnable*) _data_->self);
#line 138 "../src/data/Game.vala"
		_data_->_tmp45_ = _data_->cmd;
#line 138 "../src/data/Game.vala"
		_data_->_tmp45__length1 = _data_->cmd_length1;
#line 138 "../src/data/Game.vala"
		_data_->_tmp46_ = game_hub_data_runnable_get_executable ((GameHubDataRunnable*) _data_->self);
#line 138 "../src/data/Game.vala"
		_data_->_tmp47_ = _data_->_tmp46_;
#line 138 "../src/data/Game.vala"
		_data_->_tmp48_ = _data_->_tmp47_;
#line 138 "../src/data/Game.vala"
		_data_->_tmp49_ = g_file_get_parent (_data_->_tmp48_);
#line 138 "../src/data/Game.vala"
		_data_->_tmp50_ = _data_->_tmp49_;
#line 138 "../src/data/Game.vala"
		_data_->_tmp51_ = g_file_get_path (_data_->_tmp50_);
#line 138 "../src/data/Game.vala"
		_data_->_tmp52_ = _data_->_tmp51_;
#line 138 "../src/data/Game.vala"
		_data_->_state_ = 1;
#line 138 "../src/data/Game.vala"
		game_hub_utils_run_thread (_data_->_tmp45_, (gint) _data_->_tmp45__length1, _data_->_tmp52_, NULL, (gint) 0, TRUE, FALSE, TRUE, game_hub_data_game_run_ready, _data_);
#line 138 "../src/data/Game.vala"
		return FALSE;
#line 1756 "Game.c"
		_state_1:
#line 138 "../src/data/Game.vala"
		_data_->_tmp53_ = game_hub_utils_run_thread_finish (_data_->_res_);
#line 138 "../src/data/Game.vala"
		_data_->_tmp54_ = _data_->_tmp53_;
#line 138 "../src/data/Game.vala"
		_g_free0 (_data_->_tmp54_);
#line 138 "../src/data/Game.vala"
		_g_free0 (_data_->_tmp52_);
#line 138 "../src/data/Game.vala"
		_g_object_unref0 (_data_->_tmp50_);
#line 138 "../src/data/Game.vala"
		_g_object_unref0 (_data_->_tmp48_);
#line 139 "../src/data/Game.vala"
		_data_->_tmp55_ = _data_->self->priv->_playtime_tracked;
#line 139 "../src/data/Game.vala"
		_data_->_tmp56_ = _data_->self->priv->_last_launch;
#line 139 "../src/data/Game.vala"
		game_hub_data_game_set_playtime_tracked (_data_->self, _data_->_tmp55_ + (((g_get_real_time () / 1000000) - _data_->_tmp56_) / 60));
#line 140 "../src/data/Game.vala"
		game_hub_data_runnable_save ((GameHubDataRunnable*) _data_->self);
#line 142 "../src/data/Game.vala"
		g_timeout_add_seconds_full (G_PRIORITY_DEFAULT, (guint) 1, ____lambda112__gsource_func, g_object_ref (_data_->self), g_object_unref);
#line 110 "../src/data/Game.vala"
		_data_->cmd = (_vala_array_free (_data_->cmd, _data_->cmd_length1, (GDestroyNotify) g_free), NULL);
#line 1782 "Game.c"
	}
#line 108 "../src/data/Game.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 108 "../src/data/Game.vala"
	if (_data_->_state_ != 0) {
#line 108 "../src/data/Game.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 108 "../src/data/Game.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 1792 "Game.c"
		}
	}
#line 108 "../src/data/Game.vala"
	g_object_unref (_data_->_async_result);
#line 108 "../src/data/Game.vala"
	return FALSE;
#line 1799 "Game.c"
}

static void
game_hub_data_game_run_or_install_data_free (gpointer _data)
{
	GameHubDataGameRunOrInstallData* _data_;
	_data_ = _data;
#line 27 "../src/data/Game.vala"
	_g_object_unref0 (_data_->self);
#line 27 "../src/data/Game.vala"
	g_slice_free (GameHubDataGameRunOrInstallData, _data_);
#line 1811 "Game.c"
}

void
game_hub_data_game_run_or_install (GameHubDataGame* self,
                                   gboolean show_compat,
                                   GAsyncReadyCallback _callback_,
                                   gpointer _user_data_)
{
	GameHubDataGameRunOrInstallData* _data_;
	GameHubDataGame* _tmp0_;
#line 27 "../src/data/Game.vala"
	_data_ = g_slice_new0 (GameHubDataGameRunOrInstallData);
#line 27 "../src/data/Game.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 27 "../src/data/Game.vala"
	g_task_set_task_data (_data_->_async_result, _data_, game_hub_data_game_run_or_install_data_free);
#line 27 "../src/data/Game.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 27 "../src/data/Game.vala"
	_data_->self = _tmp0_;
#line 27 "../src/data/Game.vala"
	_data_->show_compat = show_compat;
#line 27 "../src/data/Game.vala"
	game_hub_data_game_run_or_install_co (_data_);
#line 1836 "Game.c"
}

void
game_hub_data_game_run_or_install_finish (GameHubDataGame* self,
                                          GAsyncResult* _res_)
{
	GameHubDataGameRunOrInstallData* _data_;
#line 27 "../src/data/Game.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 1846 "Game.c"
}

static void
game_hub_data_game_run_or_install_ready (GObject* source_object,
                                         GAsyncResult* _res_,
                                         gpointer _user_data_)
{
	GameHubDataGameRunOrInstallData* _data_;
#line 156 "../src/data/Game.vala"
	_data_ = _user_data_;
#line 156 "../src/data/Game.vala"
	_data_->_source_object_ = source_object;
#line 156 "../src/data/Game.vala"
	_data_->_res_ = _res_;
#line 156 "../src/data/Game.vala"
	game_hub_data_game_run_or_install_co (_data_);
#line 1863 "Game.c"
}

static gboolean
game_hub_data_game_run_or_install_co (GameHubDataGameRunOrInstallData* _data_)
{
#line 150 "../src/data/Game.vala"
	switch (_data_->_state_) {
#line 150 "../src/data/Game.vala"
		case 0:
#line 1873 "Game.c"
		goto _state_0;
#line 150 "../src/data/Game.vala"
		case 1:
#line 1877 "Game.c"
		goto _state_1;
#line 150 "../src/data/Game.vala"
		case 2:
#line 1881 "Game.c"
		goto _state_2;
#line 150 "../src/data/Game.vala"
		case 3:
#line 1885 "Game.c"
		goto _state_3;
		default:
#line 150 "../src/data/Game.vala"
		g_assert_not_reached ();
#line 1890 "Game.c"
	}
	_state_0:
#line 152 "../src/data/Game.vala"
	_data_->_tmp0_ = game_hub_data_game_get_status (_data_->self);
#line 152 "../src/data/Game.vala"
	_data_->_tmp1_ = _data_->_tmp0_;
#line 152 "../src/data/Game.vala"
	_data_->_tmp2_ = _data_->_tmp1_->state;
#line 152 "../src/data/Game.vala"
	if (_data_->_tmp2_ == GAME_HUB_DATA_GAME_STATE_INSTALLED) {
#line 154 "../src/data/Game.vala"
		_data_->_tmp3_ = game_hub_data_runnable_get_use_compat ((GameHubDataRunnable*) _data_->self);
#line 154 "../src/data/Game.vala"
		_data_->_tmp4_ = _data_->_tmp3_;
#line 154 "../src/data/Game.vala"
		if (_data_->_tmp4_) {
#line 156 "../src/data/Game.vala"
			_data_->_state_ = 1;
#line 156 "../src/data/Game.vala"
			game_hub_data_runnable_run_with_compat ((GameHubDataRunnable*) _data_->self, _data_->show_compat, game_hub_data_game_run_or_install_ready, _data_);
#line 156 "../src/data/Game.vala"
			return FALSE;
#line 1913 "Game.c"
			_state_1:
#line 156 "../src/data/Game.vala"
			game_hub_data_runnable_run_with_compat_finish ((GameHubDataRunnable*) _data_->self, _data_->_res_);
#line 1917 "Game.c"
		} else {
#line 160 "../src/data/Game.vala"
			_data_->_state_ = 2;
#line 160 "../src/data/Game.vala"
			game_hub_data_runnable_run ((GameHubDataRunnable*) _data_->self, game_hub_data_game_run_or_install_ready, _data_);
#line 160 "../src/data/Game.vala"
			return FALSE;
#line 1925 "Game.c"
			_state_2:
#line 160 "../src/data/Game.vala"
			game_hub_data_runnable_run_finish ((GameHubDataRunnable*) _data_->self, _data_->_res_);
#line 1929 "Game.c"
		}
	} else {
#line 163 "../src/data/Game.vala"
		_data_->_tmp5_ = game_hub_data_game_get_status (_data_->self);
#line 163 "../src/data/Game.vala"
		_data_->_tmp6_ = _data_->_tmp5_;
#line 163 "../src/data/Game.vala"
		_data_->_tmp7_ = _data_->_tmp6_->state;
#line 163 "../src/data/Game.vala"
		if (_data_->_tmp7_ == GAME_HUB_DATA_GAME_STATE_UNINSTALLED) {
#line 165 "../src/data/Game.vala"
			_data_->_state_ = 3;
#line 165 "../src/data/Game.vala"
			game_hub_data_runnable_install ((GameHubDataRunnable*) _data_->self, GAME_HUB_DATA_RUNNABLE_INSTALLER_INSTALL_MODE_INTERACTIVE, game_hub_data_game_run_or_install_ready, _data_);
#line 165 "../src/data/Game.vala"
			return FALSE;
#line 1946 "Game.c"
			_state_3:
#line 165 "../src/data/Game.vala"
			game_hub_data_runnable_install_finish ((GameHubDataRunnable*) _data_->self, _data_->_res_);
#line 1950 "Game.c"
		}
	}
#line 150 "../src/data/Game.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 150 "../src/data/Game.vala"
	if (_data_->_state_ != 0) {
#line 150 "../src/data/Game.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 150 "../src/data/Game.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 1961 "Game.c"
		}
	}
#line 150 "../src/data/Game.vala"
	g_object_unref (_data_->_async_result);
#line 150 "../src/data/Game.vala"
	return FALSE;
#line 1968 "Game.c"
}

static void
game_hub_data_game_real_update_game_info_data_free (gpointer _data)
{
	GameHubDataGameUpdateGameInfoData* _data_;
	_data_ = _data;
#line 27 "../src/data/Game.vala"
	_g_object_unref0 (_data_->self);
#line 27 "../src/data/Game.vala"
	g_slice_free (GameHubDataGameUpdateGameInfoData, _data_);
#line 1980 "Game.c"
}

static void
game_hub_data_game_real_update_game_info (GameHubDataGame* self,
                                          GAsyncReadyCallback _callback_,
                                          gpointer _user_data_)
{
	GameHubDataGameUpdateGameInfoData* _data_;
	GameHubDataGame* _tmp0_;
#line 27 "../src/data/Game.vala"
	_data_ = g_slice_new0 (GameHubDataGameUpdateGameInfoData);
#line 27 "../src/data/Game.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 27 "../src/data/Game.vala"
	g_task_set_task_data (_data_->_async_result, _data_, game_hub_data_game_real_update_game_info_data_free);
#line 27 "../src/data/Game.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 27 "../src/data/Game.vala"
	_data_->self = _tmp0_;
#line 27 "../src/data/Game.vala"
	game_hub_data_game_real_update_game_info_co (_data_);
#line 2002 "Game.c"
}

static void
game_hub_data_game_real_update_game_info_finish (GameHubDataGame* self,
                                                 GAsyncResult* _res_)
{
	GameHubDataGameUpdateGameInfoData* _data_;
#line 27 "../src/data/Game.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 2012 "Game.c"
}

static gboolean
game_hub_data_game_real_update_game_info_co (GameHubDataGameUpdateGameInfoData* _data_)
{
#line 169 "../src/data/Game.vala"
	switch (_data_->_state_) {
#line 169 "../src/data/Game.vala"
		case 0:
#line 2022 "Game.c"
		goto _state_0;
		default:
#line 169 "../src/data/Game.vala"
		g_assert_not_reached ();
#line 2027 "Game.c"
	}
	_state_0:
#line 169 "../src/data/Game.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 169 "../src/data/Game.vala"
	if (_data_->_state_ != 0) {
#line 169 "../src/data/Game.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 169 "../src/data/Game.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 2038 "Game.c"
		}
	}
#line 169 "../src/data/Game.vala"
	g_object_unref (_data_->_async_result);
#line 169 "../src/data/Game.vala"
	return FALSE;
#line 2045 "Game.c"
}

void
game_hub_data_game_update_game_info (GameHubDataGame* self,
                                     GAsyncReadyCallback _callback_,
                                     gpointer _user_data_)
{
#line 27 "../src/data/Game.vala"
	GAME_HUB_DATA_GAME_GET_CLASS (self)->update_game_info (self, _callback_, _user_data_);
#line 2055 "Game.c"
}

void
game_hub_data_game_update_game_info_finish (GameHubDataGame* self,
                                            GAsyncResult* _res_)
{
#line 27 "../src/data/Game.vala"
	GAME_HUB_DATA_GAME_GET_CLASS (self)->update_game_info_finish (self, _res_);
#line 2064 "Game.c"
}

void
game_hub_data_game_update_version (GameHubDataGame* self)
{
	gboolean _tmp0_ = FALSE;
	GFile* _tmp1_;
	GFile* _tmp2_;
	GFile* file = NULL;
	GFile* _tmp5_;
	GFile* _tmp6_;
	GFile* _tmp7_;
	GFile* _tmp8_;
	GFile* _tmp9_;
	GFile* _tmp10_;
	gboolean _tmp11_ = FALSE;
	GFile* _tmp12_;
	GError* _inner_error0_ = NULL;
#line 171 "../src/data/Game.vala"
	g_return_if_fail (self != NULL);
#line 173 "../src/data/Game.vala"
	_tmp1_ = game_hub_data_runnable_get_install_dir ((GameHubDataRunnable*) self);
#line 173 "../src/data/Game.vala"
	_tmp2_ = _tmp1_;
#line 173 "../src/data/Game.vala"
	if (_tmp2_ == NULL) {
#line 173 "../src/data/Game.vala"
		_tmp0_ = TRUE;
#line 2093 "Game.c"
	} else {
		GFile* _tmp3_;
		GFile* _tmp4_;
#line 173 "../src/data/Game.vala"
		_tmp3_ = game_hub_data_runnable_get_install_dir ((GameHubDataRunnable*) self);
#line 173 "../src/data/Game.vala"
		_tmp4_ = _tmp3_;
#line 173 "../src/data/Game.vala"
		_tmp0_ = !g_file_query_exists (_tmp4_, NULL);
#line 2103 "Game.c"
	}
#line 173 "../src/data/Game.vala"
	if (_tmp0_) {
#line 173 "../src/data/Game.vala"
		return;
#line 2109 "Game.c"
	}
#line 175 "../src/data/Game.vala"
	_tmp5_ = game_hub_data_runnable_get_install_dir ((GameHubDataRunnable*) self);
#line 175 "../src/data/Game.vala"
	_tmp6_ = _tmp5_;
#line 175 "../src/data/Game.vala"
	_tmp7_ = g_file_get_child (_tmp6_, GAME_HUB_UTILS_FS_UTILS_GAMEHUB_DIR);
#line 175 "../src/data/Game.vala"
	_tmp8_ = _tmp7_;
#line 175 "../src/data/Game.vala"
	_tmp9_ = g_file_get_child (_tmp8_, "version");
#line 175 "../src/data/Game.vala"
	_tmp10_ = _tmp9_;
#line 175 "../src/data/Game.vala"
	_g_object_unref0 (_tmp8_);
#line 175 "../src/data/Game.vala"
	file = _tmp10_;
#line 176 "../src/data/Game.vala"
	_tmp12_ = file;
#line 176 "../src/data/Game.vala"
	if (_tmp12_ != NULL) {
#line 2131 "Game.c"
		GFile* _tmp13_;
#line 176 "../src/data/Game.vala"
		_tmp13_ = file;
#line 176 "../src/data/Game.vala"
		_tmp11_ = g_file_query_exists (_tmp13_, NULL);
#line 2137 "Game.c"
	} else {
#line 176 "../src/data/Game.vala"
		_tmp11_ = FALSE;
#line 2141 "Game.c"
	}
#line 176 "../src/data/Game.vala"
	if (_tmp11_) {
#line 2145 "Game.c"
		{
			gchar* ver = NULL;
			GFile* _tmp14_;
			gchar* _tmp15_;
			gchar* _tmp16_;
			gchar* _tmp17_ = NULL;
			const gchar* _tmp18_;
#line 181 "../src/data/Game.vala"
			_tmp14_ = file;
#line 181 "../src/data/Game.vala"
			_tmp15_ = g_file_get_path (_tmp14_);
#line 181 "../src/data/Game.vala"
			_tmp16_ = _tmp15_;
#line 181 "../src/data/Game.vala"
			g_file_get_contents (_tmp16_, &_tmp17_, NULL, &_inner_error0_);
#line 181 "../src/data/Game.vala"
			_g_free0 (ver);
#line 181 "../src/data/Game.vala"
			ver = _tmp17_;
#line 181 "../src/data/Game.vala"
			_g_free0 (_tmp16_);
#line 181 "../src/data/Game.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 181 "../src/data/Game.vala"
				_g_free0 (ver);
#line 2171 "Game.c"
				goto __catch9_g_error;
			}
#line 182 "../src/data/Game.vala"
			_tmp18_ = ver;
#line 182 "../src/data/Game.vala"
			game_hub_data_game_set_version (self, _tmp18_);
#line 178 "../src/data/Game.vala"
			_g_free0 (ver);
#line 2180 "Game.c"
		}
		goto __finally9;
		__catch9_g_error:
		{
			GError* e = NULL;
			GError* _tmp19_;
			const gchar* _tmp20_;
#line 178 "../src/data/Game.vala"
			e = _inner_error0_;
#line 178 "../src/data/Game.vala"
			_inner_error0_ = NULL;
#line 186 "../src/data/Game.vala"
			_tmp19_ = e;
#line 186 "../src/data/Game.vala"
			_tmp20_ = _tmp19_->message;
#line 186 "../src/data/Game.vala"
			g_warning ("Game.vala:186: [Game.update_version] Error while reading version: %s", _tmp20_);
#line 178 "../src/data/Game.vala"
			_g_error_free0 (e);
#line 2200 "Game.c"
		}
		__finally9:
#line 178 "../src/data/Game.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 178 "../src/data/Game.vala"
			_g_object_unref0 (file);
#line 178 "../src/data/Game.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 178 "../src/data/Game.vala"
			g_clear_error (&_inner_error0_);
#line 178 "../src/data/Game.vala"
			return;
#line 2213 "Game.c"
		}
	}
#line 171 "../src/data/Game.vala"
	_g_object_unref0 (file);
#line 2218 "Game.c"
}

void
game_hub_data_game_save_version (GameHubDataGame* self,
                                 const gchar* ver)
{
	gboolean _tmp0_ = FALSE;
	GFile* _tmp1_;
	GFile* _tmp2_;
	GFile* file = NULL;
	GFile* _tmp5_;
	GFile* _tmp6_;
	GFile* _tmp7_;
	GFile* _tmp8_;
	GFile* _tmp9_;
	GFile* _tmp10_;
	GFile* _tmp11_;
	GError* _inner_error0_ = NULL;
#line 191 "../src/data/Game.vala"
	g_return_if_fail (self != NULL);
#line 191 "../src/data/Game.vala"
	g_return_if_fail (ver != NULL);
#line 193 "../src/data/Game.vala"
	game_hub_data_game_set_version (self, ver);
#line 195 "../src/data/Game.vala"
	_tmp1_ = game_hub_data_runnable_get_install_dir ((GameHubDataRunnable*) self);
#line 195 "../src/data/Game.vala"
	_tmp2_ = _tmp1_;
#line 195 "../src/data/Game.vala"
	if (_tmp2_ == NULL) {
#line 195 "../src/data/Game.vala"
		_tmp0_ = TRUE;
#line 2251 "Game.c"
	} else {
		GFile* _tmp3_;
		GFile* _tmp4_;
#line 195 "../src/data/Game.vala"
		_tmp3_ = game_hub_data_runnable_get_install_dir ((GameHubDataRunnable*) self);
#line 195 "../src/data/Game.vala"
		_tmp4_ = _tmp3_;
#line 195 "../src/data/Game.vala"
		_tmp0_ = !g_file_query_exists (_tmp4_, NULL);
#line 2261 "Game.c"
	}
#line 195 "../src/data/Game.vala"
	if (_tmp0_) {
#line 195 "../src/data/Game.vala"
		return;
#line 2267 "Game.c"
	}
#line 197 "../src/data/Game.vala"
	_tmp5_ = game_hub_data_runnable_get_install_dir ((GameHubDataRunnable*) self);
#line 197 "../src/data/Game.vala"
	_tmp6_ = _tmp5_;
#line 197 "../src/data/Game.vala"
	_tmp7_ = g_file_get_child (_tmp6_, GAME_HUB_UTILS_FS_UTILS_GAMEHUB_DIR);
#line 197 "../src/data/Game.vala"
	_tmp8_ = _tmp7_;
#line 197 "../src/data/Game.vala"
	_tmp9_ = g_file_get_child (_tmp8_, "version");
#line 197 "../src/data/Game.vala"
	_tmp10_ = _tmp9_;
#line 197 "../src/data/Game.vala"
	_g_object_unref0 (_tmp8_);
#line 197 "../src/data/Game.vala"
	file = _tmp10_;
#line 198 "../src/data/Game.vala"
	_tmp11_ = file;
#line 198 "../src/data/Game.vala"
	if (_tmp11_ != NULL) {
#line 2289 "Game.c"
		{
			GFile* _tmp12_;
			GFile* _tmp13_;
			GFile* _tmp14_;
			gchar* _tmp15_;
			gchar* _tmp16_;
			GFile* _tmp17_;
			GFile* _tmp18_;
			GFile* _tmp19_;
			gchar* _tmp20_;
			gchar* _tmp21_;
#line 202 "../src/data/Game.vala"
			_tmp12_ = file;
#line 202 "../src/data/Game.vala"
			_tmp13_ = g_file_get_parent (_tmp12_);
#line 202 "../src/data/Game.vala"
			_tmp14_ = _tmp13_;
#line 202 "../src/data/Game.vala"
			_tmp15_ = g_file_get_path (_tmp14_);
#line 202 "../src/data/Game.vala"
			_tmp16_ = _tmp15_;
#line 202 "../src/data/Game.vala"
			_tmp17_ = game_hub_utils_fs_utils_mkdir (_tmp16_, NULL, NULL);
#line 202 "../src/data/Game.vala"
			_tmp18_ = _tmp17_;
#line 202 "../src/data/Game.vala"
			_g_object_unref0 (_tmp18_);
#line 202 "../src/data/Game.vala"
			_g_free0 (_tmp16_);
#line 202 "../src/data/Game.vala"
			_g_object_unref0 (_tmp14_);
#line 203 "../src/data/Game.vala"
			_tmp19_ = file;
#line 203 "../src/data/Game.vala"
			_tmp20_ = g_file_get_path (_tmp19_);
#line 203 "../src/data/Game.vala"
			_tmp21_ = _tmp20_;
#line 203 "../src/data/Game.vala"
			g_file_set_contents (_tmp21_, ver, (gssize) -1, &_inner_error0_);
#line 203 "../src/data/Game.vala"
			_g_free0 (_tmp21_);
#line 203 "../src/data/Game.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2333 "Game.c"
				goto __catch10_g_error;
			}
		}
		goto __finally10;
		__catch10_g_error:
		{
			GError* e = NULL;
			GError* _tmp22_;
			const gchar* _tmp23_;
#line 200 "../src/data/Game.vala"
			e = _inner_error0_;
#line 200 "../src/data/Game.vala"
			_inner_error0_ = NULL;
#line 207 "../src/data/Game.vala"
			_tmp22_ = e;
#line 207 "../src/data/Game.vala"
			_tmp23_ = _tmp22_->message;
#line 207 "../src/data/Game.vala"
			g_warning ("Game.vala:207: [Game.update_version] Error while reading version: %s", _tmp23_);
#line 200 "../src/data/Game.vala"
			_g_error_free0 (e);
#line 2355 "Game.c"
		}
		__finally10:
#line 200 "../src/data/Game.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 200 "../src/data/Game.vala"
			_g_object_unref0 (file);
#line 200 "../src/data/Game.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 200 "../src/data/Game.vala"
			g_clear_error (&_inner_error0_);
#line 200 "../src/data/Game.vala"
			return;
#line 2368 "Game.c"
		}
	}
#line 191 "../src/data/Game.vala"
	_g_object_unref0 (file);
#line 2373 "Game.c"
}

static void
_vala_array_add10 (GFile** * array,
                   int* length,
                   int* size,
                   GFile* value)
{
#line 245 "../src/data/Game.vala"
	if ((*length) == (*size)) {
#line 245 "../src/data/Game.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 245 "../src/data/Game.vala"
		*array = g_renew (GFile*, *array, (*size) + 1);
#line 2388 "Game.c"
	}
#line 245 "../src/data/Game.vala"
	(*array)[(*length)++] = value;
#line 245 "../src/data/Game.vala"
	(*array)[*length] = NULL;
#line 2394 "Game.c"
}

static void
_vala_array_add11 (GFile** * array,
                   int* length,
                   int* size,
                   GFile* value)
{
#line 247 "../src/data/Game.vala"
	if ((*length) == (*size)) {
#line 247 "../src/data/Game.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 247 "../src/data/Game.vala"
		*array = g_renew (GFile*, *array, (*size) + 1);
#line 2409 "Game.c"
	}
#line 247 "../src/data/Game.vala"
	(*array)[(*length)++] = value;
#line 247 "../src/data/Game.vala"
	(*array)[*length] = NULL;
#line 2415 "Game.c"
}

GFile*
game_hub_data_game_get_file (GameHubDataGame* self,
                             const gchar* p,
                             gboolean from_all_overlays)
{
	GFile* result = NULL;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gchar* path = NULL;
	gchar* _tmp6_;
	gboolean _tmp7_ = FALSE;
	const gchar* _tmp8_;
	GFile** dirs = NULL;
	GFile* _tmp12_;
	GFile* _tmp13_;
	GFile* _tmp14_;
	GFile** _tmp15_;
	gint dirs_length1;
	gint _dirs_size_;
	gboolean _tmp16_;
	gboolean _tmp17_;
	GFile** _tmp36_;
	gint _tmp36__length1;
#line 231 "../src/data/Game.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 233 "../src/data/Game.vala"
	if (p == NULL) {
#line 233 "../src/data/Game.vala"
		_tmp1_ = TRUE;
#line 2447 "Game.c"
	} else {
		gint _tmp2_;
		gint _tmp3_;
#line 233 "../src/data/Game.vala"
		_tmp2_ = strlen (p);
#line 233 "../src/data/Game.vala"
		_tmp3_ = _tmp2_;
#line 233 "../src/data/Game.vala"
		_tmp1_ = _tmp3_ == 0;
#line 2457 "Game.c"
	}
#line 233 "../src/data/Game.vala"
	if (_tmp1_) {
#line 233 "../src/data/Game.vala"
		_tmp0_ = TRUE;
#line 2463 "Game.c"
	} else {
		GFile* _tmp4_;
		GFile* _tmp5_;
#line 233 "../src/data/Game.vala"
		_tmp4_ = game_hub_data_runnable_get_install_dir ((GameHubDataRunnable*) self);
#line 233 "../src/data/Game.vala"
		_tmp5_ = _tmp4_;
#line 233 "../src/data/Game.vala"
		_tmp0_ = _tmp5_ == NULL;
#line 2473 "Game.c"
	}
#line 233 "../src/data/Game.vala"
	if (_tmp0_) {
#line 233 "../src/data/Game.vala"
		result = NULL;
#line 233 "../src/data/Game.vala"
		return result;
#line 2481 "Game.c"
	}
#line 234 "../src/data/Game.vala"
	_tmp6_ = g_strdup (p);
#line 234 "../src/data/Game.vala"
	path = _tmp6_;
#line 235 "../src/data/Game.vala"
	_tmp8_ = path;
#line 235 "../src/data/Game.vala"
	if (!g_str_has_prefix (_tmp8_, "$game_dir/")) {
#line 2491 "Game.c"
		const gchar* _tmp9_;
#line 235 "../src/data/Game.vala"
		_tmp9_ = path;
#line 235 "../src/data/Game.vala"
		_tmp7_ = !g_str_has_prefix (_tmp9_, "/");
#line 2497 "Game.c"
	} else {
#line 235 "../src/data/Game.vala"
		_tmp7_ = FALSE;
#line 2501 "Game.c"
	}
#line 235 "../src/data/Game.vala"
	if (_tmp7_) {
#line 2505 "Game.c"
		const gchar* _tmp10_;
		gchar* _tmp11_;
#line 237 "../src/data/Game.vala"
		_tmp10_ = path;
#line 237 "../src/data/Game.vala"
		_tmp11_ = g_strconcat ("$game_dir/", _tmp10_, NULL);
#line 237 "../src/data/Game.vala"
		_g_free0 (path);
#line 237 "../src/data/Game.vala"
		path = _tmp11_;
#line 2516 "Game.c"
	}
#line 239 "../src/data/Game.vala"
	_tmp12_ = game_hub_data_runnable_get_install_dir ((GameHubDataRunnable*) self);
#line 239 "../src/data/Game.vala"
	_tmp13_ = _tmp12_;
#line 239 "../src/data/Game.vala"
	_tmp14_ = _g_object_ref0 (_tmp13_);
#line 239 "../src/data/Game.vala"
	_tmp15_ = g_new0 (GFile*, 1 + 1);
#line 239 "../src/data/Game.vala"
	_tmp15_[0] = _tmp14_;
#line 239 "../src/data/Game.vala"
	dirs = _tmp15_;
#line 239 "../src/data/Game.vala"
	dirs_length1 = 1;
#line 239 "../src/data/Game.vala"
	_dirs_size_ = dirs_length1;
#line 240 "../src/data/Game.vala"
	_tmp16_ = game_hub_data_game_get_overlays_enabled (self);
#line 240 "../src/data/Game.vala"
	_tmp17_ = _tmp16_;
#line 240 "../src/data/Game.vala"
	if (_tmp17_) {
#line 2540 "Game.c"
		GFile* _tmp18_;
		GFile* _tmp19_;
		GFile* _tmp20_;
		GFile* _tmp21_;
		GFile* _tmp22_;
		GFile* _tmp23_;
		GFile* _tmp24_;
		GFile** _tmp25_;
		GFile** _tmp32_;
		gint _tmp32__length1;
		GFile* _tmp33_;
		GFile* _tmp34_;
		GFile* _tmp35_;
#line 242 "../src/data/Game.vala"
		_tmp18_ = game_hub_data_runnable_get_install_dir ((GameHubDataRunnable*) self);
#line 242 "../src/data/Game.vala"
		_tmp19_ = _tmp18_;
#line 242 "../src/data/Game.vala"
		_tmp20_ = g_file_get_child (_tmp19_, GAME_HUB_UTILS_FS_UTILS_GAMEHUB_DIR);
#line 242 "../src/data/Game.vala"
		_tmp21_ = _tmp20_;
#line 242 "../src/data/Game.vala"
		_tmp22_ = g_file_get_child (_tmp21_, "_overlay");
#line 242 "../src/data/Game.vala"
		_tmp23_ = _tmp22_;
#line 242 "../src/data/Game.vala"
		_tmp24_ = g_file_get_child (_tmp23_, "merged");
#line 242 "../src/data/Game.vala"
		_tmp25_ = g_new0 (GFile*, 1 + 1);
#line 242 "../src/data/Game.vala"
		_tmp25_[0] = _tmp24_;
#line 242 "../src/data/Game.vala"
		dirs = (_vala_array_free (dirs, dirs_length1, (GDestroyNotify) g_object_unref), NULL);
#line 242 "../src/data/Game.vala"
		dirs = _tmp25_;
#line 242 "../src/data/Game.vala"
		dirs_length1 = 1;
#line 242 "../src/data/Game.vala"
		_dirs_size_ = dirs_length1;
#line 242 "../src/data/Game.vala"
		_g_object_unref0 (_tmp23_);
#line 242 "../src/data/Game.vala"
		_g_object_unref0 (_tmp21_);
#line 243 "../src/data/Game.vala"
		if (from_all_overlays) {
#line 2586 "Game.c"
			GFile** _tmp26_;
			gint _tmp26__length1;
			GFile* _tmp27_;
			GFile* _tmp28_;
			GFile* _tmp29_;
			GFile* _tmp30_;
			GFile* _tmp31_;
#line 245 "../src/data/Game.vala"
			_tmp26_ = dirs;
#line 245 "../src/data/Game.vala"
			_tmp26__length1 = dirs_length1;
#line 245 "../src/data/Game.vala"
			_tmp27_ = game_hub_data_runnable_get_install_dir ((GameHubDataRunnable*) self);
#line 245 "../src/data/Game.vala"
			_tmp28_ = _tmp27_;
#line 245 "../src/data/Game.vala"
			_tmp29_ = g_file_get_child (_tmp28_, GAME_HUB_UTILS_FS_UTILS_GAMEHUB_DIR);
#line 245 "../src/data/Game.vala"
			_tmp30_ = _tmp29_;
#line 245 "../src/data/Game.vala"
			_tmp31_ = g_file_get_child (_tmp30_, GAME_HUB_DATA_GAME_OVERLAY_BASE);
#line 245 "../src/data/Game.vala"
			_vala_array_add10 (&dirs, &dirs_length1, &_dirs_size_, _tmp31_);
#line 245 "../src/data/Game.vala"
			_g_object_unref0 (_tmp30_);
#line 2612 "Game.c"
		}
#line 247 "../src/data/Game.vala"
		_tmp32_ = dirs;
#line 247 "../src/data/Game.vala"
		_tmp32__length1 = dirs_length1;
#line 247 "../src/data/Game.vala"
		_tmp33_ = game_hub_data_runnable_get_install_dir ((GameHubDataRunnable*) self);
#line 247 "../src/data/Game.vala"
		_tmp34_ = _tmp33_;
#line 247 "../src/data/Game.vala"
		_tmp35_ = _g_object_ref0 (_tmp34_);
#line 247 "../src/data/Game.vala"
		_vala_array_add11 (&dirs, &dirs_length1, &_dirs_size_, _tmp35_);
#line 248 "../src/data/Game.vala"
		game_hub_data_game_mount_overlays (self, NULL);
#line 2628 "Game.c"
	}
#line 250 "../src/data/Game.vala"
	_tmp36_ = dirs;
#line 250 "../src/data/Game.vala"
	_tmp36__length1 = dirs_length1;
#line 2634 "Game.c"
	{
		GFile** dir_collection = NULL;
		gint dir_collection_length1 = 0;
		gint _dir_collection_size_ = 0;
		gint dir_it = 0;
#line 250 "../src/data/Game.vala"
		dir_collection = _tmp36_;
#line 250 "../src/data/Game.vala"
		dir_collection_length1 = _tmp36__length1;
#line 250 "../src/data/Game.vala"
		for (dir_it = 0; dir_it < dir_collection_length1; dir_it = dir_it + 1) {
#line 2646 "Game.c"
			GFile* _tmp37_;
			GFile* dir = NULL;
#line 250 "../src/data/Game.vala"
			_tmp37_ = _g_object_ref0 (dir_collection[dir_it]);
#line 250 "../src/data/Game.vala"
			dir = _tmp37_;
#line 2653 "Game.c"
			{
				GeeHashMap* variables = NULL;
				GeeHashMap* _tmp38_;
				GeeHashMap* _tmp39_;
				GFile* _tmp40_;
				gchar* _tmp41_;
				gchar* _tmp42_;
				GFile* file = NULL;
				const gchar* _tmp43_;
				GeeHashMap* _tmp44_;
				GFile* _tmp45_;
				gboolean _tmp46_ = FALSE;
				GFile* _tmp47_;
#line 252 "../src/data/Game.vala"
				_tmp38_ = gee_hash_map_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 252 "../src/data/Game.vala"
				variables = _tmp38_;
#line 253 "../src/data/Game.vala"
				_tmp39_ = variables;
#line 253 "../src/data/Game.vala"
				_tmp40_ = dir;
#line 253 "../src/data/Game.vala"
				_tmp41_ = g_file_get_path (_tmp40_);
#line 253 "../src/data/Game.vala"
				_tmp42_ = _tmp41_;
#line 253 "../src/data/Game.vala"
				gee_abstract_map_set ((GeeAbstractMap*) _tmp39_, "game_dir", _tmp42_);
#line 253 "../src/data/Game.vala"
				_g_free0 (_tmp42_);
#line 254 "../src/data/Game.vala"
				_tmp43_ = path;
#line 254 "../src/data/Game.vala"
				_tmp44_ = variables;
#line 254 "../src/data/Game.vala"
				_tmp45_ = game_hub_utils_fs_utils_file (_tmp43_, NULL, _tmp44_);
#line 254 "../src/data/Game.vala"
				file = _tmp45_;
#line 255 "../src/data/Game.vala"
				_tmp47_ = file;
#line 255 "../src/data/Game.vala"
				if (_tmp47_ != NULL) {
#line 2695 "Game.c"
					GFile* _tmp48_;
#line 255 "../src/data/Game.vala"
					_tmp48_ = file;
#line 255 "../src/data/Game.vala"
					_tmp46_ = g_file_query_exists (_tmp48_, NULL);
#line 2701 "Game.c"
				} else {
#line 255 "../src/data/Game.vala"
					_tmp46_ = FALSE;
#line 2705 "Game.c"
				}
#line 255 "../src/data/Game.vala"
				if (_tmp46_) {
#line 257 "../src/data/Game.vala"
					result = file;
#line 257 "../src/data/Game.vala"
					_g_object_unref0 (variables);
#line 257 "../src/data/Game.vala"
					_g_object_unref0 (dir);
#line 257 "../src/data/Game.vala"
					dirs = (_vala_array_free (dirs, dirs_length1, (GDestroyNotify) g_object_unref), NULL);
#line 257 "../src/data/Game.vala"
					_g_free0 (path);
#line 257 "../src/data/Game.vala"
					return result;
#line 2721 "Game.c"
				}
#line 250 "../src/data/Game.vala"
				_g_object_unref0 (file);
#line 250 "../src/data/Game.vala"
				_g_object_unref0 (variables);
#line 250 "../src/data/Game.vala"
				_g_object_unref0 (dir);
#line 2729 "Game.c"
			}
		}
	}
#line 260 "../src/data/Game.vala"
	result = NULL;
#line 260 "../src/data/Game.vala"
	dirs = (_vala_array_free (dirs, dirs_length1, (GDestroyNotify) g_object_unref), NULL);
#line 260 "../src/data/Game.vala"
	_g_free0 (path);
#line 260 "../src/data/Game.vala"
	return result;
#line 2741 "Game.c"
}

void
game_hub_data_game_enable_overlays (GameHubDataGame* self)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
	GFile* _tmp9_;
	GFile* _tmp10_;
	GameHubDataGameOverlay* base_overlay = NULL;
	GameHubDataGameOverlay* _tmp11_;
	GeeArrayList* _tmp36_;
	GameHubDataGameOverlay* _tmp37_;
	GError* _inner_error0_ = NULL;
#line 312 "../src/data/Game.vala"
	g_return_if_fail (self != NULL);
#line 314 "../src/data/Game.vala"
	if (GAME_HUB_DATA_SOURCES_STEAM_IS_STEAM_GAME (self)) {
#line 314 "../src/data/Game.vala"
		_tmp2_ = TRUE;
#line 2763 "Game.c"
	} else {
		GFile* _tmp3_;
		GFile* _tmp4_;
#line 314 "../src/data/Game.vala"
		_tmp3_ = game_hub_data_runnable_get_install_dir ((GameHubDataRunnable*) self);
#line 314 "../src/data/Game.vala"
		_tmp4_ = _tmp3_;
#line 314 "../src/data/Game.vala"
		_tmp2_ = _tmp4_ == NULL;
#line 2773 "Game.c"
	}
#line 314 "../src/data/Game.vala"
	if (_tmp2_) {
#line 314 "../src/data/Game.vala"
		_tmp1_ = TRUE;
#line 2779 "Game.c"
	} else {
		GFile* _tmp5_;
		GFile* _tmp6_;
#line 314 "../src/data/Game.vala"
		_tmp5_ = game_hub_data_runnable_get_install_dir ((GameHubDataRunnable*) self);
#line 314 "../src/data/Game.vala"
		_tmp6_ = _tmp5_;
#line 314 "../src/data/Game.vala"
		_tmp1_ = !g_file_query_exists (_tmp6_, NULL);
#line 2789 "Game.c"
	}
#line 314 "../src/data/Game.vala"
	if (_tmp1_) {
#line 314 "../src/data/Game.vala"
		_tmp0_ = TRUE;
#line 2795 "Game.c"
	} else {
		gboolean _tmp7_;
		gboolean _tmp8_;
#line 314 "../src/data/Game.vala"
		_tmp7_ = game_hub_data_game_get_overlays_enabled (self);
#line 314 "../src/data/Game.vala"
		_tmp8_ = _tmp7_;
#line 314 "../src/data/Game.vala"
		_tmp0_ = _tmp8_;
#line 2805 "Game.c"
	}
#line 314 "../src/data/Game.vala"
	if (_tmp0_) {
#line 314 "../src/data/Game.vala"
		return;
#line 2811 "Game.c"
	}
#line 315 "../src/data/Game.vala"
	_tmp9_ = game_hub_data_runnable_get_install_dir ((GameHubDataRunnable*) self);
#line 315 "../src/data/Game.vala"
	_tmp10_ = _tmp9_;
#line 315 "../src/data/Game.vala"
	if (game_hub_utils_fs_overlay_root_path_safety_for (_tmp10_) == GAME_HUB_UTILS_FS_OVERLAY_ROOT_PATH_SAFETY_RESTRICTED) {
#line 315 "../src/data/Game.vala"
		return;
#line 2821 "Game.c"
	}
#line 317 "../src/data/Game.vala"
	_tmp11_ = game_hub_data_game_overlay_new (self, GAME_HUB_DATA_GAME_OVERLAY_BASE, NULL, TRUE);
#line 317 "../src/data/Game.vala"
	base_overlay = _tmp11_;
#line 2827 "Game.c"
	{
		GFileInfo* finfo = NULL;
		GFileEnumerator* enumerator = NULL;
		GFile* _tmp12_;
		GFile* _tmp13_;
		GFileEnumerator* _tmp14_;
#line 321 "../src/data/Game.vala"
		finfo = NULL;
#line 322 "../src/data/Game.vala"
		_tmp12_ = game_hub_data_runnable_get_install_dir ((GameHubDataRunnable*) self);
#line 322 "../src/data/Game.vala"
		_tmp13_ = _tmp12_;
#line 322 "../src/data/Game.vala"
		_tmp14_ = g_file_enumerate_children (_tmp13_, "standard::*", G_FILE_QUERY_INFO_NOFOLLOW_SYMLINKS, NULL, &_inner_error0_);
#line 322 "../src/data/Game.vala"
		enumerator = _tmp14_;
#line 322 "../src/data/Game.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 322 "../src/data/Game.vala"
			_g_object_unref0 (finfo);
#line 2848 "Game.c"
			goto __catch11_g_error;
		}
#line 323 "../src/data/Game.vala"
		while (TRUE) {
#line 2853 "Game.c"
			GFileInfo* _tmp15_ = NULL;
			GFileEnumerator* _tmp16_;
			GFileInfo* _tmp17_;
			GFileInfo* _tmp18_;
			GFileInfo* _tmp19_;
			gchar* fname = NULL;
			GFileInfo* _tmp20_;
			const gchar* _tmp21_;
			gchar* _tmp22_;
			const gchar* _tmp23_;
			GFile* _tmp24_;
			GFile* _tmp25_;
			const gchar* _tmp26_;
			GFile* _tmp27_;
			GFile* _tmp28_;
			GameHubDataGameOverlay* _tmp29_;
			GFile* _tmp30_;
			const gchar* _tmp31_;
			GFile* _tmp32_;
			GFile* _tmp33_;
#line 323 "../src/data/Game.vala"
			_tmp16_ = enumerator;
#line 323 "../src/data/Game.vala"
			_tmp17_ = g_file_enumerator_next_file (_tmp16_, NULL, &_inner_error0_);
#line 323 "../src/data/Game.vala"
			_tmp15_ = _tmp17_;
#line 323 "../src/data/Game.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 323 "../src/data/Game.vala"
				_g_object_unref0 (enumerator);
#line 323 "../src/data/Game.vala"
				_g_object_unref0 (finfo);
#line 2886 "Game.c"
				goto __catch11_g_error;
			}
#line 323 "../src/data/Game.vala"
			_tmp18_ = _tmp15_;
#line 323 "../src/data/Game.vala"
			_tmp15_ = NULL;
#line 323 "../src/data/Game.vala"
			_g_object_unref0 (finfo);
#line 323 "../src/data/Game.vala"
			finfo = _tmp18_;
#line 323 "../src/data/Game.vala"
			_tmp19_ = finfo;
#line 323 "../src/data/Game.vala"
			if (!(_tmp19_ != NULL)) {
#line 323 "../src/data/Game.vala"
				_g_object_unref0 (_tmp15_);
#line 323 "../src/data/Game.vala"
				break;
#line 2905 "Game.c"
			}
#line 325 "../src/data/Game.vala"
			_tmp20_ = finfo;
#line 325 "../src/data/Game.vala"
			_tmp21_ = g_file_info_get_name (_tmp20_);
#line 325 "../src/data/Game.vala"
			_tmp22_ = g_strdup (_tmp21_);
#line 325 "../src/data/Game.vala"
			fname = _tmp22_;
#line 326 "../src/data/Game.vala"
			_tmp23_ = fname;
#line 326 "../src/data/Game.vala"
			if (g_strcmp0 (_tmp23_, GAME_HUB_UTILS_FS_UTILS_GAMEHUB_DIR) == 0) {
#line 326 "../src/data/Game.vala"
				_g_free0 (fname);
#line 326 "../src/data/Game.vala"
				_g_object_unref0 (_tmp15_);
#line 326 "../src/data/Game.vala"
				continue;
#line 2925 "Game.c"
			}
#line 327 "../src/data/Game.vala"
			_tmp24_ = game_hub_data_runnable_get_install_dir ((GameHubDataRunnable*) self);
#line 327 "../src/data/Game.vala"
			_tmp25_ = _tmp24_;
#line 327 "../src/data/Game.vala"
			_tmp26_ = fname;
#line 327 "../src/data/Game.vala"
			_tmp27_ = g_file_get_child (_tmp25_, _tmp26_);
#line 327 "../src/data/Game.vala"
			_tmp28_ = _tmp27_;
#line 327 "../src/data/Game.vala"
			_tmp29_ = base_overlay;
#line 327 "../src/data/Game.vala"
			_tmp30_ = _tmp29_->directory;
#line 327 "../src/data/Game.vala"
			_tmp31_ = fname;
#line 327 "../src/data/Game.vala"
			_tmp32_ = g_file_get_child (_tmp30_, _tmp31_);
#line 327 "../src/data/Game.vala"
			_tmp33_ = _tmp32_;
#line 327 "../src/data/Game.vala"
			g_file_move (_tmp28_, _tmp33_, G_FILE_COPY_OVERWRITE | G_FILE_COPY_NOFOLLOW_SYMLINKS, NULL, NULL, NULL, &_inner_error0_);
#line 327 "../src/data/Game.vala"
			_g_object_unref0 (_tmp33_);
#line 327 "../src/data/Game.vala"
			_g_object_unref0 (_tmp28_);
#line 327 "../src/data/Game.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 327 "../src/data/Game.vala"
				_g_free0 (fname);
#line 327 "../src/data/Game.vala"
				_g_object_unref0 (_tmp15_);
#line 327 "../src/data/Game.vala"
				_g_object_unref0 (enumerator);
#line 327 "../src/data/Game.vala"
				_g_object_unref0 (finfo);
#line 2963 "Game.c"
				goto __catch11_g_error;
			}
#line 323 "../src/data/Game.vala"
			_g_free0 (fname);
#line 323 "../src/data/Game.vala"
			_g_object_unref0 (_tmp15_);
#line 2970 "Game.c"
		}
#line 319 "../src/data/Game.vala"
		_g_object_unref0 (enumerator);
#line 319 "../src/data/Game.vala"
		_g_object_unref0 (finfo);
#line 2976 "Game.c"
	}
	goto __finally11;
	__catch11_g_error:
	{
		GError* e = NULL;
		GError* _tmp34_;
		const gchar* _tmp35_;
#line 319 "../src/data/Game.vala"
		e = _inner_error0_;
#line 319 "../src/data/Game.vala"
		_inner_error0_ = NULL;
#line 332 "../src/data/Game.vala"
		_tmp34_ = e;
#line 332 "../src/data/Game.vala"
		_tmp35_ = _tmp34_->message;
#line 332 "../src/data/Game.vala"
		g_warning ("Game.vala:332: [Game.enable_overlays] Error while moving game files to" \
" `base` overlay: %s", _tmp35_);
#line 319 "../src/data/Game.vala"
		_g_error_free0 (e);
#line 2996 "Game.c"
	}
	__finally11:
#line 319 "../src/data/Game.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 319 "../src/data/Game.vala"
		_g_object_unref0 (base_overlay);
#line 319 "../src/data/Game.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 319 "../src/data/Game.vala"
		g_clear_error (&_inner_error0_);
#line 319 "../src/data/Game.vala"
		return;
#line 3009 "Game.c"
	}
#line 335 "../src/data/Game.vala"
	_tmp36_ = self->overlays;
#line 335 "../src/data/Game.vala"
	_tmp37_ = base_overlay;
#line 335 "../src/data/Game.vala"
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp36_, _tmp37_);
#line 336 "../src/data/Game.vala"
	game_hub_data_game_save_overlays (self);
#line 337 "../src/data/Game.vala"
	game_hub_data_runnable_save ((GameHubDataRunnable*) self);
#line 312 "../src/data/Game.vala"
	_g_object_unref0 (base_overlay);
#line 3023 "Game.c"
}

static gpointer
_json_object_ref0 (gpointer self)
{
#line 360 "../src/data/Game.vala"
	return self ? json_object_ref (self) : NULL;
#line 3031 "Game.c"
}

static void
_vala_JsonNode_free (JsonNode* self)
{
#line 368 "../src/data/Game.vala"
	g_boxed_free (json_node_get_type (), self);
#line 3039 "Game.c"
}

void
game_hub_data_game_save_overlays (GameHubDataGame* self)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	GFile* _tmp2_;
	GFile* _tmp3_;
	GFile* _tmp7_;
	GFile* _tmp8_;
	GFile* file = NULL;
	GFile* _tmp9_;
	GFile* _tmp10_;
	GFile* _tmp11_;
	GFile* _tmp12_;
	GFile* _tmp13_;
	GFile* _tmp14_;
	GFile* _tmp15_;
	GFile* _tmp16_;
	gboolean _tmp17_ = FALSE;
	GFile* _tmp18_;
	JsonNode* root_node = NULL;
	JsonNode* _tmp22_;
	JsonObject* root = NULL;
	JsonObject* _tmp23_;
	JsonObject* overlays_obj = NULL;
	JsonObject* _tmp24_;
	JsonObject* _tmp50_;
	JsonObject* _tmp51_;
	JsonObject* _tmp52_;
	JsonNode* _tmp53_;
	JsonObject* _tmp54_;
	gchar* json = NULL;
	JsonNode* _tmp55_;
	gchar* _tmp56_;
	GError* _inner_error0_ = NULL;
#line 340 "../src/data/Game.vala"
	g_return_if_fail (self != NULL);
#line 342 "../src/data/Game.vala"
	_tmp2_ = game_hub_data_runnable_get_install_dir ((GameHubDataRunnable*) self);
#line 342 "../src/data/Game.vala"
	_tmp3_ = _tmp2_;
#line 342 "../src/data/Game.vala"
	if (_tmp3_ == NULL) {
#line 342 "../src/data/Game.vala"
		_tmp1_ = TRUE;
#line 3087 "Game.c"
	} else {
		GFile* _tmp4_;
		GFile* _tmp5_;
#line 342 "../src/data/Game.vala"
		_tmp4_ = game_hub_data_runnable_get_install_dir ((GameHubDataRunnable*) self);
#line 342 "../src/data/Game.vala"
		_tmp5_ = _tmp4_;
#line 342 "../src/data/Game.vala"
		_tmp1_ = !g_file_query_exists (_tmp5_, NULL);
#line 3097 "Game.c"
	}
#line 342 "../src/data/Game.vala"
	if (_tmp1_) {
#line 342 "../src/data/Game.vala"
		_tmp0_ = TRUE;
#line 3103 "Game.c"
	} else {
		GeeArrayList* _tmp6_;
#line 342 "../src/data/Game.vala"
		_tmp6_ = self->overlays;
#line 342 "../src/data/Game.vala"
		_tmp0_ = _tmp6_ == NULL;
#line 3110 "Game.c"
	}
#line 342 "../src/data/Game.vala"
	if (_tmp0_) {
#line 342 "../src/data/Game.vala"
		return;
#line 3116 "Game.c"
	}
#line 343 "../src/data/Game.vala"
	_tmp7_ = game_hub_data_runnable_get_install_dir ((GameHubDataRunnable*) self);
#line 343 "../src/data/Game.vala"
	_tmp8_ = _tmp7_;
#line 343 "../src/data/Game.vala"
	if (game_hub_utils_fs_overlay_root_path_safety_for (_tmp8_) == GAME_HUB_UTILS_FS_OVERLAY_ROOT_PATH_SAFETY_RESTRICTED) {
#line 343 "../src/data/Game.vala"
		return;
#line 3126 "Game.c"
	}
#line 345 "../src/data/Game.vala"
	_tmp9_ = game_hub_data_runnable_get_install_dir ((GameHubDataRunnable*) self);
#line 345 "../src/data/Game.vala"
	_tmp10_ = _tmp9_;
#line 345 "../src/data/Game.vala"
	_tmp11_ = g_file_get_child (_tmp10_, GAME_HUB_UTILS_FS_UTILS_GAMEHUB_DIR);
#line 345 "../src/data/Game.vala"
	_tmp12_ = _tmp11_;
#line 345 "../src/data/Game.vala"
	_tmp13_ = g_file_get_child (_tmp12_, GAME_HUB_UTILS_FS_UTILS_OVERLAYS_DIR);
#line 345 "../src/data/Game.vala"
	_tmp14_ = _tmp13_;
#line 345 "../src/data/Game.vala"
	_tmp15_ = g_file_get_child (_tmp14_, GAME_HUB_UTILS_FS_UTILS_OVERLAYS_LIST);
#line 345 "../src/data/Game.vala"
	_tmp16_ = _tmp15_;
#line 345 "../src/data/Game.vala"
	_g_object_unref0 (_tmp14_);
#line 345 "../src/data/Game.vala"
	_g_object_unref0 (_tmp12_);
#line 345 "../src/data/Game.vala"
	file = _tmp16_;
#line 347 "../src/data/Game.vala"
	_tmp18_ = file;
#line 347 "../src/data/Game.vala"
	if (_tmp18_ == NULL) {
#line 347 "../src/data/Game.vala"
		_tmp17_ = TRUE;
#line 3156 "Game.c"
	} else {
		GFile* _tmp19_;
		GFile* _tmp20_;
		GFile* _tmp21_;
#line 347 "../src/data/Game.vala"
		_tmp19_ = file;
#line 347 "../src/data/Game.vala"
		_tmp20_ = g_file_get_parent (_tmp19_);
#line 347 "../src/data/Game.vala"
		_tmp21_ = _tmp20_;
#line 347 "../src/data/Game.vala"
		_tmp17_ = !g_file_query_exists (_tmp21_, NULL);
#line 347 "../src/data/Game.vala"
		_g_object_unref0 (_tmp21_);
#line 3171 "Game.c"
	}
#line 347 "../src/data/Game.vala"
	if (_tmp17_) {
#line 347 "../src/data/Game.vala"
		_g_object_unref0 (file);
#line 347 "../src/data/Game.vala"
		return;
#line 3179 "Game.c"
	}
#line 349 "../src/data/Game.vala"
	_tmp22_ = json_node_new (JSON_NODE_OBJECT);
#line 349 "../src/data/Game.vala"
	root_node = _tmp22_;
#line 350 "../src/data/Game.vala"
	_tmp23_ = json_object_new ();
#line 350 "../src/data/Game.vala"
	root = _tmp23_;
#line 352 "../src/data/Game.vala"
	_tmp24_ = json_object_new ();
#line 352 "../src/data/Game.vala"
	overlays_obj = _tmp24_;
#line 3193 "Game.c"
	{
		GeeArrayList* _overlay_list = NULL;
		GeeArrayList* _tmp25_;
		GeeArrayList* _tmp26_;
		gint _overlay_size = 0;
		GeeArrayList* _tmp27_;
		gint _tmp28_;
		gint _tmp29_;
		gint _overlay_index = 0;
#line 354 "../src/data/Game.vala"
		_tmp25_ = self->overlays;
#line 354 "../src/data/Game.vala"
		_tmp26_ = _g_object_ref0 (_tmp25_);
#line 354 "../src/data/Game.vala"
		_overlay_list = _tmp26_;
#line 354 "../src/data/Game.vala"
		_tmp27_ = _overlay_list;
#line 354 "../src/data/Game.vala"
		_tmp28_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp27_);
#line 354 "../src/data/Game.vala"
		_tmp29_ = _tmp28_;
#line 354 "../src/data/Game.vala"
		_overlay_size = _tmp29_;
#line 354 "../src/data/Game.vala"
		_overlay_index = -1;
#line 354 "../src/data/Game.vala"
		while (TRUE) {
#line 3221 "Game.c"
			GameHubDataGameOverlay* overlay = NULL;
			GeeArrayList* _tmp30_;
			gpointer _tmp31_;
			GameHubDataGameOverlay* _tmp32_;
			const gchar* _tmp33_;
			const gchar* _tmp34_;
			JsonObject* obj = NULL;
			JsonObject* _tmp35_;
			JsonObject* _tmp36_;
			GameHubDataGameOverlay* _tmp37_;
			const gchar* _tmp38_;
			const gchar* _tmp39_;
			JsonObject* _tmp40_;
			GameHubDataGameOverlay* _tmp41_;
			gboolean _tmp42_;
			gboolean _tmp43_;
			JsonObject* _tmp44_;
			GameHubDataGameOverlay* _tmp45_;
			const gchar* _tmp46_;
			const gchar* _tmp47_;
			JsonObject* _tmp48_;
			JsonObject* _tmp49_;
#line 354 "../src/data/Game.vala"
			_overlay_index = _overlay_index + 1;
#line 354 "../src/data/Game.vala"
			if (!(_overlay_index < _overlay_size)) {
#line 354 "../src/data/Game.vala"
				break;
#line 3250 "Game.c"
			}
#line 354 "../src/data/Game.vala"
			_tmp30_ = _overlay_list;
#line 354 "../src/data/Game.vala"
			_tmp31_ = gee_abstract_list_get ((GeeAbstractList*) _tmp30_, _overlay_index);
#line 354 "../src/data/Game.vala"
			overlay = (GameHubDataGameOverlay*) _tmp31_;
#line 356 "../src/data/Game.vala"
			_tmp32_ = overlay;
#line 356 "../src/data/Game.vala"
			_tmp33_ = game_hub_data_game_overlay_get_id (_tmp32_);
#line 356 "../src/data/Game.vala"
			_tmp34_ = _tmp33_;
#line 356 "../src/data/Game.vala"
			if (g_strcmp0 (_tmp34_, GAME_HUB_DATA_GAME_OVERLAY_BASE) == 0) {
#line 356 "../src/data/Game.vala"
				_g_object_unref0 (overlay);
#line 356 "../src/data/Game.vala"
				continue;
#line 3270 "Game.c"
			}
#line 357 "../src/data/Game.vala"
			_tmp35_ = json_object_new ();
#line 357 "../src/data/Game.vala"
			obj = _tmp35_;
#line 358 "../src/data/Game.vala"
			_tmp36_ = obj;
#line 358 "../src/data/Game.vala"
			_tmp37_ = overlay;
#line 358 "../src/data/Game.vala"
			_tmp38_ = game_hub_data_game_overlay_get_name (_tmp37_);
#line 358 "../src/data/Game.vala"
			_tmp39_ = _tmp38_;
#line 358 "../src/data/Game.vala"
			json_object_set_string_member (_tmp36_, "name", _tmp39_);
#line 359 "../src/data/Game.vala"
			_tmp40_ = obj;
#line 359 "../src/data/Game.vala"
			_tmp41_ = overlay;
#line 359 "../src/data/Game.vala"
			_tmp42_ = game_hub_data_game_overlay_get_enabled (_tmp41_);
#line 359 "../src/data/Game.vala"
			_tmp43_ = _tmp42_;
#line 359 "../src/data/Game.vala"
			json_object_set_boolean_member (_tmp40_, "enabled", _tmp43_);
#line 360 "../src/data/Game.vala"
			_tmp44_ = overlays_obj;
#line 360 "../src/data/Game.vala"
			_tmp45_ = overlay;
#line 360 "../src/data/Game.vala"
			_tmp46_ = game_hub_data_game_overlay_get_id (_tmp45_);
#line 360 "../src/data/Game.vala"
			_tmp47_ = _tmp46_;
#line 360 "../src/data/Game.vala"
			_tmp48_ = obj;
#line 360 "../src/data/Game.vala"
			_tmp49_ = _json_object_ref0 (_tmp48_);
#line 360 "../src/data/Game.vala"
			json_object_set_object_member (_tmp44_, _tmp47_, _tmp49_);
#line 354 "../src/data/Game.vala"
			_json_object_unref0 (obj);
#line 354 "../src/data/Game.vala"
			_g_object_unref0 (overlay);
#line 3314 "Game.c"
		}
#line 354 "../src/data/Game.vala"
		_g_object_unref0 (_overlay_list);
#line 3318 "Game.c"
	}
#line 363 "../src/data/Game.vala"
	_tmp50_ = root;
#line 363 "../src/data/Game.vala"
	_tmp51_ = overlays_obj;
#line 363 "../src/data/Game.vala"
	_tmp52_ = _json_object_ref0 (_tmp51_);
#line 363 "../src/data/Game.vala"
	json_object_set_object_member (_tmp50_, "overlays", _tmp52_);
#line 364 "../src/data/Game.vala"
	_tmp53_ = root_node;
#line 364 "../src/data/Game.vala"
	_tmp54_ = root;
#line 364 "../src/data/Game.vala"
	json_node_set_object (_tmp53_, _tmp54_);
#line 366 "../src/data/Game.vala"
	_tmp55_ = root_node;
#line 366 "../src/data/Game.vala"
	_tmp56_ = json_to_string (_tmp55_, TRUE);
#line 366 "../src/data/Game.vala"
	json = _tmp56_;
#line 3340 "Game.c"
	{
		GFile* _tmp57_;
		gchar* _tmp58_;
		gchar* _tmp59_;
		const gchar* _tmp60_;
#line 370 "../src/data/Game.vala"
		_tmp57_ = file;
#line 370 "../src/data/Game.vala"
		_tmp58_ = g_file_get_path (_tmp57_);
#line 370 "../src/data/Game.vala"
		_tmp59_ = _tmp58_;
#line 370 "../src/data/Game.vala"
		_tmp60_ = json;
#line 370 "../src/data/Game.vala"
		g_file_set_contents (_tmp59_, _tmp60_, (gssize) -1, &_inner_error0_);
#line 370 "../src/data/Game.vala"
		_g_free0 (_tmp59_);
#line 370 "../src/data/Game.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 3360 "Game.c"
			goto __catch12_g_error;
		}
	}
	goto __finally12;
	__catch12_g_error:
	{
		GError* e = NULL;
		GError* _tmp61_;
		const gchar* _tmp62_;
#line 368 "../src/data/Game.vala"
		e = _inner_error0_;
#line 368 "../src/data/Game.vala"
		_inner_error0_ = NULL;
#line 374 "../src/data/Game.vala"
		_tmp61_ = e;
#line 374 "../src/data/Game.vala"
		_tmp62_ = _tmp61_->message;
#line 374 "../src/data/Game.vala"
		g_warning ("Game.vala:374: [Game.save_overlays] %s", _tmp62_);
#line 368 "../src/data/Game.vala"
		_g_error_free0 (e);
#line 3382 "Game.c"
	}
	__finally12:
#line 368 "../src/data/Game.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 368 "../src/data/Game.vala"
		_g_free0 (json);
#line 368 "../src/data/Game.vala"
		_json_object_unref0 (overlays_obj);
#line 368 "../src/data/Game.vala"
		_json_object_unref0 (root);
#line 368 "../src/data/Game.vala"
		__vala_JsonNode_free0 (root_node);
#line 368 "../src/data/Game.vala"
		_g_object_unref0 (file);
#line 368 "../src/data/Game.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 368 "../src/data/Game.vala"
		g_clear_error (&_inner_error0_);
#line 368 "../src/data/Game.vala"
		return;
#line 3403 "Game.c"
	}
#line 377 "../src/data/Game.vala"
	g_object_notify ((GObject*) self, "overlays-enabled");
#line 340 "../src/data/Game.vala"
	_g_free0 (json);
#line 340 "../src/data/Game.vala"
	_json_object_unref0 (overlays_obj);
#line 340 "../src/data/Game.vala"
	_json_object_unref0 (root);
#line 340 "../src/data/Game.vala"
	__vala_JsonNode_free0 (root_node);
#line 340 "../src/data/Game.vala"
	_g_object_unref0 (file);
#line 3417 "Game.c"
}

void
game_hub_data_game_load_overlays (GameHubDataGame* self)
{
	gboolean _tmp0_;
	gboolean _tmp1_;
	GeeArrayList* _tmp2_;
	GeeArrayList* _tmp3_;
	GameHubDataGameOverlay* _tmp4_;
	GameHubDataGameOverlay* _tmp5_;
	JsonNode* root_node = NULL;
	GFile* _tmp6_;
	GFile* _tmp7_;
	GFile* _tmp8_;
	GFile* _tmp9_;
	GFile* _tmp10_;
	GFile* _tmp11_;
	GFile* _tmp12_;
	GFile* _tmp13_;
	gchar* _tmp14_;
	gchar* _tmp15_;
	JsonNode* _tmp16_;
	JsonNode* _tmp17_;
	JsonObject* overlays_obj = NULL;
	JsonNode* _tmp18_;
	gchar* _tmp19_;
	gchar** _tmp20_;
	gchar** _tmp21_;
	gint _tmp21__length1;
	JsonObject* _tmp22_;
	JsonObject* _tmp23_;
	JsonObject* _tmp24_;
	JsonObject* _tmp25_;
	GList* _tmp26_;
#line 380 "../src/data/Game.vala"
	g_return_if_fail (self != NULL);
#line 382 "../src/data/Game.vala"
	_tmp0_ = game_hub_data_game_get_overlays_enabled (self);
#line 382 "../src/data/Game.vala"
	_tmp1_ = _tmp0_;
#line 382 "../src/data/Game.vala"
	if (!_tmp1_) {
#line 382 "../src/data/Game.vala"
		return;
#line 3463 "Game.c"
	}
#line 383 "../src/data/Game.vala"
	_tmp2_ = self->overlays;
#line 383 "../src/data/Game.vala"
	gee_abstract_collection_clear ((GeeAbstractCollection*) _tmp2_);
#line 384 "../src/data/Game.vala"
	_tmp3_ = self->overlays;
#line 384 "../src/data/Game.vala"
	_tmp4_ = game_hub_data_game_overlay_new (self, GAME_HUB_DATA_GAME_OVERLAY_BASE, NULL, TRUE);
#line 384 "../src/data/Game.vala"
	_tmp5_ = _tmp4_;
#line 384 "../src/data/Game.vala"
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp3_, _tmp5_);
#line 384 "../src/data/Game.vala"
	_g_object_unref0 (_tmp5_);
#line 386 "../src/data/Game.vala"
	_tmp6_ = game_hub_data_runnable_get_install_dir ((GameHubDataRunnable*) self);
#line 386 "../src/data/Game.vala"
	_tmp7_ = _tmp6_;
#line 386 "../src/data/Game.vala"
	_tmp8_ = g_file_get_child (_tmp7_, GAME_HUB_UTILS_FS_UTILS_GAMEHUB_DIR);
#line 386 "../src/data/Game.vala"
	_tmp9_ = _tmp8_;
#line 386 "../src/data/Game.vala"
	_tmp10_ = g_file_get_child (_tmp9_, GAME_HUB_UTILS_FS_UTILS_OVERLAYS_DIR);
#line 386 "../src/data/Game.vala"
	_tmp11_ = _tmp10_;
#line 386 "../src/data/Game.vala"
	_tmp12_ = g_file_get_child (_tmp11_, GAME_HUB_UTILS_FS_UTILS_OVERLAYS_LIST);
#line 386 "../src/data/Game.vala"
	_tmp13_ = _tmp12_;
#line 386 "../src/data/Game.vala"
	_tmp14_ = g_file_get_path (_tmp13_);
#line 386 "../src/data/Game.vala"
	_tmp15_ = _tmp14_;
#line 386 "../src/data/Game.vala"
	_tmp16_ = game_hub_utils_parser_parse_json_file (_tmp15_, "");
#line 386 "../src/data/Game.vala"
	_tmp17_ = _tmp16_;
#line 386 "../src/data/Game.vala"
	_g_free0 (_tmp15_);
#line 386 "../src/data/Game.vala"
	_g_object_unref0 (_tmp13_);
#line 386 "../src/data/Game.vala"
	_g_object_unref0 (_tmp11_);
#line 386 "../src/data/Game.vala"
	_g_object_unref0 (_tmp9_);
#line 386 "../src/data/Game.vala"
	root_node = _tmp17_;
#line 388 "../src/data/Game.vala"
	_tmp18_ = root_node;
#line 388 "../src/data/Game.vala"
	_tmp19_ = g_strdup ("overlays");
#line 388 "../src/data/Game.vala"
	_tmp20_ = g_new0 (gchar*, 1 + 1);
#line 388 "../src/data/Game.vala"
	_tmp20_[0] = _tmp19_;
#line 388 "../src/data/Game.vala"
	_tmp21_ = _tmp20_;
#line 388 "../src/data/Game.vala"
	_tmp21__length1 = 1;
#line 388 "../src/data/Game.vala"
	_tmp22_ = game_hub_utils_parser_json_object (_tmp18_, _tmp21_, (gint) 1);
#line 388 "../src/data/Game.vala"
	_tmp23_ = _tmp22_;
#line 388 "../src/data/Game.vala"
	_tmp21_ = (_vala_array_free (_tmp21_, _tmp21__length1, (GDestroyNotify) g_free), NULL);
#line 388 "../src/data/Game.vala"
	overlays_obj = _tmp23_;
#line 389 "../src/data/Game.vala"
	_tmp24_ = overlays_obj;
#line 389 "../src/data/Game.vala"
	if (_tmp24_ == NULL) {
#line 389 "../src/data/Game.vala"
		_json_object_unref0 (overlays_obj);
#line 389 "../src/data/Game.vala"
		__vala_JsonNode_free0 (root_node);
#line 389 "../src/data/Game.vala"
		return;
#line 3543 "Game.c"
	}
#line 391 "../src/data/Game.vala"
	_tmp25_ = overlays_obj;
#line 391 "../src/data/Game.vala"
	_tmp26_ = json_object_get_members (_tmp25_);
#line 3549 "Game.c"
	{
		GList* id_collection = NULL;
		GList* id_it = NULL;
#line 391 "../src/data/Game.vala"
		id_collection = _tmp26_;
#line 391 "../src/data/Game.vala"
		for (id_it = id_collection; id_it != NULL; id_it = id_it->next) {
#line 3557 "Game.c"
			const gchar* id = NULL;
#line 391 "../src/data/Game.vala"
			id = (const gchar*) id_it->data;
#line 3561 "Game.c"
			{
				JsonObject* obj = NULL;
				JsonObject* _tmp27_;
				const gchar* _tmp28_;
				JsonObject* _tmp29_;
				JsonObject* _tmp30_;
				GeeArrayList* _tmp31_;
				const gchar* _tmp32_;
				JsonObject* _tmp33_;
				const gchar* _tmp34_;
				JsonObject* _tmp35_;
				GameHubDataGameOverlay* _tmp36_;
				GameHubDataGameOverlay* _tmp37_;
#line 393 "../src/data/Game.vala"
				_tmp27_ = overlays_obj;
#line 393 "../src/data/Game.vala"
				_tmp28_ = id;
#line 393 "../src/data/Game.vala"
				_tmp29_ = json_object_get_object_member (_tmp27_, _tmp28_);
#line 393 "../src/data/Game.vala"
				_tmp30_ = _json_object_ref0 (_tmp29_);
#line 393 "../src/data/Game.vala"
				obj = _tmp30_;
#line 394 "../src/data/Game.vala"
				_tmp31_ = self->overlays;
#line 394 "../src/data/Game.vala"
				_tmp32_ = id;
#line 394 "../src/data/Game.vala"
				_tmp33_ = obj;
#line 394 "../src/data/Game.vala"
				_tmp34_ = json_object_get_string_member (_tmp33_, "name");
#line 394 "../src/data/Game.vala"
				_tmp35_ = obj;
#line 394 "../src/data/Game.vala"
				_tmp36_ = game_hub_data_game_overlay_new (self, _tmp32_, _tmp34_, json_object_get_boolean_member (_tmp35_, "enabled"));
#line 394 "../src/data/Game.vala"
				_tmp37_ = _tmp36_;
#line 394 "../src/data/Game.vala"
				gee_abstract_collection_add ((GeeAbstractCollection*) _tmp31_, _tmp37_);
#line 394 "../src/data/Game.vala"
				_g_object_unref0 (_tmp37_);
#line 391 "../src/data/Game.vala"
				_json_object_unref0 (obj);
#line 3605 "Game.c"
			}
		}
#line 391 "../src/data/Game.vala"
		(id_collection == NULL) ? NULL : (id_collection = (g_list_free (id_collection), NULL));
#line 3610 "Game.c"
	}
#line 380 "../src/data/Game.vala"
	_json_object_unref0 (overlays_obj);
#line 380 "../src/data/Game.vala"
	__vala_JsonNode_free0 (root_node);
#line 3616 "Game.c"
}

void
game_hub_data_game_mount_overlays (GameHubDataGame* self,
                                   GFile* persist)
{
	gboolean _tmp0_;
	gboolean _tmp1_;
	GFile* overlay_dir = NULL;
	GFile* _tmp2_;
	GFile* _tmp3_;
	GFile* _tmp4_;
	GFile* _tmp5_;
	GFile* _tmp6_;
	GFile* _tmp7_;
	GFile* merged_dir = NULL;
	GFile* _tmp8_;
	GFile* _tmp9_;
	GFile* _tmp10_ = NULL;
	GFile* _tmp11_;
	GFile* persist_dir = NULL;
	GFile* _tmp14_;
	GFile* work_dir = NULL;
	GFile* _tmp15_;
	GFile* _tmp16_;
	GeeArrayList* dirs = NULL;
	GeeArrayList* _tmp17_;
	GFile* _tmp31_;
	GeeArrayList* _tmp32_;
	GFile* _tmp33_;
	GFile* _tmp34_;
	GameHubUtilsFSOverlay* _tmp35_;
	GameHubUtilsFSOverlay* _tmp36_;
	const gchar* _tmp37_;
	const gchar* _tmp38_;
	const gchar* _tmp39_;
	GameHubUtilsFSOverlay* _tmp41_;
	const gchar* _tmp42_;
	const gchar* _tmp43_;
	gchar* _tmp44_;
#line 398 "../src/data/Game.vala"
	g_return_if_fail (self != NULL);
#line 400 "../src/data/Game.vala"
	_tmp0_ = game_hub_data_game_get_overlays_enabled (self);
#line 400 "../src/data/Game.vala"
	_tmp1_ = _tmp0_;
#line 400 "../src/data/Game.vala"
	if (!_tmp1_) {
#line 400 "../src/data/Game.vala"
		return;
#line 3667 "Game.c"
	}
#line 401 "../src/data/Game.vala"
	game_hub_data_game_load_overlays (self);
#line 403 "../src/data/Game.vala"
	_tmp2_ = game_hub_data_runnable_get_install_dir ((GameHubDataRunnable*) self);
#line 403 "../src/data/Game.vala"
	_tmp3_ = _tmp2_;
#line 403 "../src/data/Game.vala"
	_tmp4_ = g_file_get_child (_tmp3_, GAME_HUB_UTILS_FS_UTILS_GAMEHUB_DIR);
#line 403 "../src/data/Game.vala"
	_tmp5_ = _tmp4_;
#line 403 "../src/data/Game.vala"
	_tmp6_ = g_file_get_child (_tmp5_, "_overlay");
#line 403 "../src/data/Game.vala"
	_tmp7_ = _tmp6_;
#line 403 "../src/data/Game.vala"
	_g_object_unref0 (_tmp5_);
#line 403 "../src/data/Game.vala"
	overlay_dir = _tmp7_;
#line 404 "../src/data/Game.vala"
	_tmp8_ = overlay_dir;
#line 404 "../src/data/Game.vala"
	_tmp9_ = g_file_get_child (_tmp8_, "merged");
#line 404 "../src/data/Game.vala"
	merged_dir = _tmp9_;
#line 405 "../src/data/Game.vala"
	_tmp11_ = _g_object_ref0 (persist);
#line 405 "../src/data/Game.vala"
	_tmp10_ = _tmp11_;
#line 405 "../src/data/Game.vala"
	if (_tmp10_ == NULL) {
#line 3699 "Game.c"
		GFile* _tmp12_;
		GFile* _tmp13_;
#line 405 "../src/data/Game.vala"
		_tmp12_ = overlay_dir;
#line 405 "../src/data/Game.vala"
		_tmp13_ = g_file_get_child (_tmp12_, "persist");
#line 405 "../src/data/Game.vala"
		_g_object_unref0 (_tmp10_);
#line 405 "../src/data/Game.vala"
		_tmp10_ = _tmp13_;
#line 3710 "Game.c"
	}
#line 405 "../src/data/Game.vala"
	_tmp14_ = _g_object_ref0 (_tmp10_);
#line 405 "../src/data/Game.vala"
	persist_dir = _tmp14_;
#line 406 "../src/data/Game.vala"
	_tmp15_ = overlay_dir;
#line 406 "../src/data/Game.vala"
	_tmp16_ = g_file_get_child (_tmp15_, "workdir");
#line 406 "../src/data/Game.vala"
	work_dir = _tmp16_;
#line 408 "../src/data/Game.vala"
	_tmp17_ = gee_array_list_new (g_file_get_type (), (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 408 "../src/data/Game.vala"
	dirs = _tmp17_;
#line 3726 "Game.c"
	{
		GeeArrayList* _overlay_list = NULL;
		GeeArrayList* _tmp18_;
		GeeArrayList* _tmp19_;
		gint _overlay_size = 0;
		GeeArrayList* _tmp20_;
		gint _tmp21_;
		gint _tmp22_;
		gint _overlay_index = 0;
#line 410 "../src/data/Game.vala"
		_tmp18_ = self->overlays;
#line 410 "../src/data/Game.vala"
		_tmp19_ = _g_object_ref0 (_tmp18_);
#line 410 "../src/data/Game.vala"
		_overlay_list = _tmp19_;
#line 410 "../src/data/Game.vala"
		_tmp20_ = _overlay_list;
#line 410 "../src/data/Game.vala"
		_tmp21_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp20_);
#line 410 "../src/data/Game.vala"
		_tmp22_ = _tmp21_;
#line 410 "../src/data/Game.vala"
		_overlay_size = _tmp22_;
#line 410 "../src/data/Game.vala"
		_overlay_index = -1;
#line 410 "../src/data/Game.vala"
		while (TRUE) {
#line 3754 "Game.c"
			GameHubDataGameOverlay* overlay = NULL;
			GeeArrayList* _tmp23_;
			gpointer _tmp24_;
			GameHubDataGameOverlay* _tmp25_;
			gboolean _tmp26_;
			gboolean _tmp27_;
#line 410 "../src/data/Game.vala"
			_overlay_index = _overlay_index + 1;
#line 410 "../src/data/Game.vala"
			if (!(_overlay_index < _overlay_size)) {
#line 410 "../src/data/Game.vala"
				break;
#line 3767 "Game.c"
			}
#line 410 "../src/data/Game.vala"
			_tmp23_ = _overlay_list;
#line 410 "../src/data/Game.vala"
			_tmp24_ = gee_abstract_list_get ((GeeAbstractList*) _tmp23_, _overlay_index);
#line 410 "../src/data/Game.vala"
			overlay = (GameHubDataGameOverlay*) _tmp24_;
#line 412 "../src/data/Game.vala"
			_tmp25_ = overlay;
#line 412 "../src/data/Game.vala"
			_tmp26_ = game_hub_data_game_overlay_get_enabled (_tmp25_);
#line 412 "../src/data/Game.vala"
			_tmp27_ = _tmp26_;
#line 412 "../src/data/Game.vala"
			if (_tmp27_) {
#line 3783 "Game.c"
				GeeArrayList* _tmp28_;
				GameHubDataGameOverlay* _tmp29_;
				GFile* _tmp30_;
#line 414 "../src/data/Game.vala"
				_tmp28_ = dirs;
#line 414 "../src/data/Game.vala"
				_tmp29_ = overlay;
#line 414 "../src/data/Game.vala"
				_tmp30_ = _tmp29_->directory;
#line 414 "../src/data/Game.vala"
				gee_abstract_collection_add ((GeeAbstractCollection*) _tmp28_, _tmp30_);
#line 3795 "Game.c"
			}
#line 410 "../src/data/Game.vala"
			_g_object_unref0 (overlay);
#line 3799 "Game.c"
		}
#line 410 "../src/data/Game.vala"
		_g_object_unref0 (_overlay_list);
#line 3803 "Game.c"
	}
#line 418 "../src/data/Game.vala"
	_tmp31_ = merged_dir;
#line 418 "../src/data/Game.vala"
	_tmp32_ = dirs;
#line 418 "../src/data/Game.vala"
	_tmp33_ = persist_dir;
#line 418 "../src/data/Game.vala"
	_tmp34_ = work_dir;
#line 418 "../src/data/Game.vala"
	_tmp35_ = game_hub_utils_fs_overlay_new (_tmp31_, _tmp32_, _tmp33_, _tmp34_);
#line 418 "../src/data/Game.vala"
	_g_object_unref0 (self->priv->fs_overlay);
#line 418 "../src/data/Game.vala"
	self->priv->fs_overlay = _tmp35_;
#line 419 "../src/data/Game.vala"
	_tmp36_ = self->priv->fs_overlay;
#line 419 "../src/data/Game.vala"
	_tmp37_ = game_hub_utils_fs_overlay_get_options (_tmp36_);
#line 419 "../src/data/Game.vala"
	_tmp38_ = _tmp37_;
#line 419 "../src/data/Game.vala"
	_tmp39_ = self->priv->fs_overlay_last_options;
#line 419 "../src/data/Game.vala"
	if (g_strcmp0 (_tmp38_, _tmp39_) != 0) {
#line 3829 "Game.c"
		GameHubUtilsFSOverlay* _tmp40_;
#line 421 "../src/data/Game.vala"
		_tmp40_ = self->priv->fs_overlay;
#line 421 "../src/data/Game.vala"
		game_hub_utils_fs_overlay_mount (_tmp40_, NULL, NULL);
#line 3835 "Game.c"
	}
#line 423 "../src/data/Game.vala"
	_tmp41_ = self->priv->fs_overlay;
#line 423 "../src/data/Game.vala"
	_tmp42_ = game_hub_utils_fs_overlay_get_options (_tmp41_);
#line 423 "../src/data/Game.vala"
	_tmp43_ = _tmp42_;
#line 423 "../src/data/Game.vala"
	_tmp44_ = g_strdup (_tmp43_);
#line 423 "../src/data/Game.vala"
	_g_free0 (self->priv->fs_overlay_last_options);
#line 423 "../src/data/Game.vala"
	self->priv->fs_overlay_last_options = _tmp44_;
#line 398 "../src/data/Game.vala"
	_g_object_unref0 (dirs);
#line 398 "../src/data/Game.vala"
	_g_object_unref0 (work_dir);
#line 398 "../src/data/Game.vala"
	_g_object_unref0 (persist_dir);
#line 398 "../src/data/Game.vala"
	_g_object_unref0 (_tmp10_);
#line 398 "../src/data/Game.vala"
	_g_object_unref0 (merged_dir);
#line 398 "../src/data/Game.vala"
	_g_object_unref0 (overlay_dir);
#line 3861 "Game.c"
}

static void
game_hub_data_game_umount_overlays_data_free (gpointer _data)
{
	GameHubDataGameUmountOverlaysData* _data_;
	_data_ = _data;
#line 27 "../src/data/Game.vala"
	_g_object_unref0 (_data_->self);
#line 27 "../src/data/Game.vala"
	g_slice_free (GameHubDataGameUmountOverlaysData, _data_);
#line 3873 "Game.c"
}

void
game_hub_data_game_umount_overlays (GameHubDataGame* self,
                                    GAsyncReadyCallback _callback_,
                                    gpointer _user_data_)
{
	GameHubDataGameUmountOverlaysData* _data_;
	GameHubDataGame* _tmp0_;
#line 27 "../src/data/Game.vala"
	_data_ = g_slice_new0 (GameHubDataGameUmountOverlaysData);
#line 27 "../src/data/Game.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 27 "../src/data/Game.vala"
	g_task_set_task_data (_data_->_async_result, _data_, game_hub_data_game_umount_overlays_data_free);
#line 27 "../src/data/Game.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 27 "../src/data/Game.vala"
	_data_->self = _tmp0_;
#line 27 "../src/data/Game.vala"
	game_hub_data_game_umount_overlays_co (_data_);
#line 3895 "Game.c"
}

void
game_hub_data_game_umount_overlays_finish (GameHubDataGame* self,
                                           GAsyncResult* _res_)
{
	GameHubDataGameUmountOverlaysData* _data_;
#line 27 "../src/data/Game.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 3905 "Game.c"
}

static void
game_hub_data_game_umount_overlays_ready (GObject* source_object,
                                          GAsyncResult* _res_,
                                          gpointer _user_data_)
{
	GameHubDataGameUmountOverlaysData* _data_;
#line 429 "../src/data/Game.vala"
	_data_ = _user_data_;
#line 429 "../src/data/Game.vala"
	_data_->_source_object_ = source_object;
#line 429 "../src/data/Game.vala"
	_data_->_res_ = _res_;
#line 429 "../src/data/Game.vala"
	game_hub_data_game_umount_overlays_co (_data_);
#line 3922 "Game.c"
}

static gboolean
game_hub_data_game_umount_overlays_co (GameHubDataGameUmountOverlaysData* _data_)
{
#line 426 "../src/data/Game.vala"
	switch (_data_->_state_) {
#line 426 "../src/data/Game.vala"
		case 0:
#line 3932 "Game.c"
		goto _state_0;
#line 426 "../src/data/Game.vala"
		case 1:
#line 3936 "Game.c"
		goto _state_1;
		default:
#line 426 "../src/data/Game.vala"
		g_assert_not_reached ();
#line 3941 "Game.c"
	}
	_state_0:
#line 428 "../src/data/Game.vala"
	_data_->_tmp1_ = game_hub_data_game_get_overlays_enabled (_data_->self);
#line 428 "../src/data/Game.vala"
	_data_->_tmp2_ = _data_->_tmp1_;
#line 428 "../src/data/Game.vala"
	if (!_data_->_tmp2_) {
#line 428 "../src/data/Game.vala"
		_data_->_tmp0_ = TRUE;
#line 3952 "Game.c"
	} else {
#line 428 "../src/data/Game.vala"
		_data_->_tmp3_ = _data_->self->priv->fs_overlay;
#line 428 "../src/data/Game.vala"
		_data_->_tmp0_ = _data_->_tmp3_ == NULL;
#line 3958 "Game.c"
	}
#line 428 "../src/data/Game.vala"
	if (_data_->_tmp0_) {
#line 428 "../src/data/Game.vala"
		g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 428 "../src/data/Game.vala"
		if (_data_->_state_ != 0) {
#line 428 "../src/data/Game.vala"
			while (!g_task_get_completed (_data_->_async_result)) {
#line 428 "../src/data/Game.vala"
				g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 3970 "Game.c"
			}
		}
#line 428 "../src/data/Game.vala"
		g_object_unref (_data_->_async_result);
#line 428 "../src/data/Game.vala"
		return FALSE;
#line 3977 "Game.c"
	}
#line 429 "../src/data/Game.vala"
	_data_->_tmp4_ = _data_->self->priv->fs_overlay;
#line 429 "../src/data/Game.vala"
	_data_->_state_ = 1;
#line 429 "../src/data/Game.vala"
	game_hub_utils_fs_overlay_umount (_data_->_tmp4_, game_hub_data_game_umount_overlays_ready, _data_);
#line 429 "../src/data/Game.vala"
	return FALSE;
#line 3987 "Game.c"
	_state_1:
#line 429 "../src/data/Game.vala"
	game_hub_utils_fs_overlay_umount_finish (_data_->_tmp4_, _data_->_res_);
#line 426 "../src/data/Game.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 426 "../src/data/Game.vala"
	if (_data_->_state_ != 0) {
#line 426 "../src/data/Game.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 426 "../src/data/Game.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 3999 "Game.c"
		}
	}
#line 426 "../src/data/Game.vala"
	g_object_unref (_data_->_async_result);
#line 426 "../src/data/Game.vala"
	return FALSE;
#line 4006 "Game.c"
}

static void
game_hub_data_game_real_load_achievements_data_free (gpointer _data)
{
	GameHubDataGameLoadAchievementsData* _data_;
	_data_ = _data;
#line 27 "../src/data/Game.vala"
	_g_object_unref0 (_data_->result);
#line 27 "../src/data/Game.vala"
	_g_object_unref0 (_data_->self);
#line 27 "../src/data/Game.vala"
	g_slice_free (GameHubDataGameLoadAchievementsData, _data_);
#line 4020 "Game.c"
}

static void
game_hub_data_game_real_load_achievements (GameHubDataGame* self,
                                           GAsyncReadyCallback _callback_,
                                           gpointer _user_data_)
{
	GameHubDataGameLoadAchievementsData* _data_;
	GameHubDataGame* _tmp0_;
#line 27 "../src/data/Game.vala"
	_data_ = g_slice_new0 (GameHubDataGameLoadAchievementsData);
#line 27 "../src/data/Game.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 27 "../src/data/Game.vala"
	g_task_set_task_data (_data_->_async_result, _data_, game_hub_data_game_real_load_achievements_data_free);
#line 27 "../src/data/Game.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 27 "../src/data/Game.vala"
	_data_->self = _tmp0_;
#line 27 "../src/data/Game.vala"
	game_hub_data_game_real_load_achievements_co (_data_);
#line 4042 "Game.c"
}

static GeeArrayList*
game_hub_data_game_real_load_achievements_finish (GameHubDataGame* self,
                                                  GAsyncResult* _res_)
{
	GeeArrayList* result;
	GameHubDataGameLoadAchievementsData* _data_;
#line 27 "../src/data/Game.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 27 "../src/data/Game.vala"
	result = _data_->result;
#line 27 "../src/data/Game.vala"
	_data_->result = NULL;
#line 27 "../src/data/Game.vala"
	return result;
#line 4059 "Game.c"
}

static gboolean
game_hub_data_game_real_load_achievements_co (GameHubDataGameLoadAchievementsData* _data_)
{
#line 433 "../src/data/Game.vala"
	switch (_data_->_state_) {
#line 433 "../src/data/Game.vala"
		case 0:
#line 4069 "Game.c"
		goto _state_0;
		default:
#line 433 "../src/data/Game.vala"
		g_assert_not_reached ();
#line 4074 "Game.c"
	}
	_state_0:
#line 433 "../src/data/Game.vala"
	_data_->result = NULL;
#line 433 "../src/data/Game.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 433 "../src/data/Game.vala"
	if (_data_->_state_ != 0) {
#line 433 "../src/data/Game.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 433 "../src/data/Game.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 4087 "Game.c"
		}
	}
#line 433 "../src/data/Game.vala"
	g_object_unref (_data_->_async_result);
#line 433 "../src/data/Game.vala"
	return FALSE;
#line 4094 "Game.c"
}

void
game_hub_data_game_load_achievements (GameHubDataGame* self,
                                      GAsyncReadyCallback _callback_,
                                      gpointer _user_data_)
{
#line 27 "../src/data/Game.vala"
	GAME_HUB_DATA_GAME_GET_CLASS (self)->load_achievements (self, _callback_, _user_data_);
#line 4104 "Game.c"
}

GeeArrayList*
game_hub_data_game_load_achievements_finish (GameHubDataGame* self,
                                             GAsyncResult* _res_)
{
#line 27 "../src/data/Game.vala"
	return GAME_HUB_DATA_GAME_GET_CLASS (self)->load_achievements_finish (self, _res_);
#line 4113 "Game.c"
}

gboolean
game_hub_data_game_is_equal (GameHubDataGame* first,
                             GameHubDataGame* second)
{
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
#line 435 "../src/data/Game.vala"
	g_return_val_if_fail (first != NULL, FALSE);
#line 435 "../src/data/Game.vala"
	g_return_val_if_fail (second != NULL, FALSE);
#line 437 "../src/data/Game.vala"
	if (first == second) {
#line 437 "../src/data/Game.vala"
		_tmp0_ = TRUE;
#line 4130 "Game.c"
	} else {
		gboolean _tmp1_ = FALSE;
		GameHubDataGameSource* _tmp2_;
		GameHubDataGameSource* _tmp3_;
#line 437 "../src/data/Game.vala"
		_tmp2_ = first->priv->_source;
#line 437 "../src/data/Game.vala"
		_tmp3_ = second->priv->_source;
#line 437 "../src/data/Game.vala"
		if (_tmp2_ == _tmp3_) {
#line 4141 "Game.c"
			const gchar* _tmp4_;
			const gchar* _tmp5_;
			const gchar* _tmp6_;
			const gchar* _tmp7_;
#line 437 "../src/data/Game.vala"
			_tmp4_ = game_hub_data_runnable_get_id ((GameHubDataRunnable*) first);
#line 437 "../src/data/Game.vala"
			_tmp5_ = _tmp4_;
#line 437 "../src/data/Game.vala"
			_tmp6_ = game_hub_data_runnable_get_id ((GameHubDataRunnable*) second);
#line 437 "../src/data/Game.vala"
			_tmp7_ = _tmp6_;
#line 437 "../src/data/Game.vala"
			_tmp1_ = g_strcmp0 (_tmp5_, _tmp7_) == 0;
#line 4156 "Game.c"
		} else {
#line 437 "../src/data/Game.vala"
			_tmp1_ = FALSE;
#line 4160 "Game.c"
		}
#line 437 "../src/data/Game.vala"
		_tmp0_ = _tmp1_;
#line 4164 "Game.c"
	}
#line 437 "../src/data/Game.vala"
	result = _tmp0_;
#line 437 "../src/data/Game.vala"
	return result;
#line 4170 "Game.c"
}

guint
game_hub_data_game_hash (GameHubDataGame* game)
{
	guint result = 0U;
	GHashFunc _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	guint _tmp4_;
#line 440 "../src/data/Game.vala"
	g_return_val_if_fail (game != NULL, 0U);
#line 442 "../src/data/Game.vala"
	_tmp0_ = g_str_hash;
#line 442 "../src/data/Game.vala"
	_tmp1_ = game_hub_data_game_get_full_id (game);
#line 442 "../src/data/Game.vala"
	_tmp2_ = _tmp1_;
#line 442 "../src/data/Game.vala"
	_tmp3_ = _tmp2_;
#line 442 "../src/data/Game.vala"
	_tmp4_ = _tmp0_ (_tmp3_);
#line 442 "../src/data/Game.vala"
	_g_free0 (_tmp3_);
#line 442 "../src/data/Game.vala"
	result = _tmp4_;
#line 442 "../src/data/Game.vala"
	return result;
#line 4200 "Game.c"
}

GameHubDataGame*
game_hub_data_game_construct (GType object_type)
{
	GameHubDataGame * self = NULL;
#line 27 "../src/data/Game.vala"
	self = (GameHubDataGame*) game_hub_data_runnable_construct (object_type);
#line 27 "../src/data/Game.vala"
	return self;
#line 4211 "Game.c"
}

GameHubDataGameSource*
game_hub_data_game_get_source (GameHubDataGame* self)
{
	GameHubDataGameSource* result;
	GameHubDataGameSource* _tmp0_;
#line 29 "../src/data/Game.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 29 "../src/data/Game.vala"
	_tmp0_ = self->priv->_source;
#line 29 "../src/data/Game.vala"
	result = _tmp0_;
#line 29 "../src/data/Game.vala"
	return result;
#line 4227 "Game.c"
}

static gpointer
_game_hub_data_game_source_ref0 (gpointer self)
{
#line 29 "../src/data/Game.vala"
	return self ? game_hub_data_game_source_ref (self) : NULL;
#line 4235 "Game.c"
}

void
game_hub_data_game_set_source (GameHubDataGame* self,
                               GameHubDataGameSource* value)
{
#line 29 "../src/data/Game.vala"
	g_return_if_fail (self != NULL);
#line 29 "../src/data/Game.vala"
	if (game_hub_data_game_get_source (self) != value) {
#line 4246 "Game.c"
		GameHubDataGameSource* _tmp0_;
#line 29 "../src/data/Game.vala"
		_tmp0_ = _game_hub_data_game_source_ref0 (value);
#line 29 "../src/data/Game.vala"
		_game_hub_data_game_source_unref0 (self->priv->_source);
#line 29 "../src/data/Game.vala"
		self->priv->_source = _tmp0_;
#line 29 "../src/data/Game.vala"
		g_object_notify_by_pspec ((GObject *) self, game_hub_data_game_properties[GAME_HUB_DATA_GAME_SOURCE_PROPERTY]);
#line 4256 "Game.c"
	}
}

const gchar*
game_hub_data_game_get_description (GameHubDataGame* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 31 "../src/data/Game.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 31 "../src/data/Game.vala"
	_tmp0_ = self->priv->_description;
#line 31 "../src/data/Game.vala"
	result = _tmp0_;
#line 31 "../src/data/Game.vala"
	return result;
#line 4273 "Game.c"
}

void
game_hub_data_game_set_description (GameHubDataGame* self,
                                    const gchar* value)
{
#line 31 "../src/data/Game.vala"
	g_return_if_fail (self != NULL);
#line 31 "../src/data/Game.vala"
	if (g_strcmp0 (value, game_hub_data_game_get_description (self)) != 0) {
#line 4284 "Game.c"
		gchar* _tmp0_;
#line 31 "../src/data/Game.vala"
		_tmp0_ = g_strdup (value);
#line 31 "../src/data/Game.vala"
		_g_free0 (self->priv->_description);
#line 31 "../src/data/Game.vala"
		self->priv->_description = _tmp0_;
#line 31 "../src/data/Game.vala"
		g_object_notify_by_pspec ((GObject *) self, game_hub_data_game_properties[GAME_HUB_DATA_GAME_DESCRIPTION_PROPERTY]);
#line 4294 "Game.c"
	}
}

const gchar*
game_hub_data_game_get_icon (GameHubDataGame* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 33 "../src/data/Game.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 33 "../src/data/Game.vala"
	_tmp0_ = self->priv->_icon;
#line 33 "../src/data/Game.vala"
	result = _tmp0_;
#line 33 "../src/data/Game.vala"
	return result;
#line 4311 "Game.c"
}

void
game_hub_data_game_set_icon (GameHubDataGame* self,
                             const gchar* value)
{
#line 33 "../src/data/Game.vala"
	g_return_if_fail (self != NULL);
#line 33 "../src/data/Game.vala"
	if (g_strcmp0 (value, game_hub_data_game_get_icon (self)) != 0) {
#line 4322 "Game.c"
		gchar* _tmp0_;
#line 33 "../src/data/Game.vala"
		_tmp0_ = g_strdup (value);
#line 33 "../src/data/Game.vala"
		_g_free0 (self->priv->_icon);
#line 33 "../src/data/Game.vala"
		self->priv->_icon = _tmp0_;
#line 33 "../src/data/Game.vala"
		g_object_notify_by_pspec ((GObject *) self, game_hub_data_game_properties[GAME_HUB_DATA_GAME_ICON_PROPERTY]);
#line 4332 "Game.c"
	}
}

const gchar*
game_hub_data_game_get_image (GameHubDataGame* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 34 "../src/data/Game.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 34 "../src/data/Game.vala"
	_tmp0_ = self->priv->_image;
#line 34 "../src/data/Game.vala"
	result = _tmp0_;
#line 34 "../src/data/Game.vala"
	return result;
#line 4349 "Game.c"
}

void
game_hub_data_game_set_image (GameHubDataGame* self,
                              const gchar* value)
{
#line 34 "../src/data/Game.vala"
	g_return_if_fail (self != NULL);
#line 34 "../src/data/Game.vala"
	if (g_strcmp0 (value, game_hub_data_game_get_image (self)) != 0) {
#line 4360 "Game.c"
		gchar* _tmp0_;
#line 34 "../src/data/Game.vala"
		_tmp0_ = g_strdup (value);
#line 34 "../src/data/Game.vala"
		_g_free0 (self->priv->_image);
#line 34 "../src/data/Game.vala"
		self->priv->_image = _tmp0_;
#line 34 "../src/data/Game.vala"
		g_object_notify_by_pspec ((GObject *) self, game_hub_data_game_properties[GAME_HUB_DATA_GAME_IMAGE_PROPERTY]);
#line 4370 "Game.c"
	}
}

const gchar*
game_hub_data_game_get_info (GameHubDataGame* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 36 "../src/data/Game.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 36 "../src/data/Game.vala"
	_tmp0_ = self->priv->_info;
#line 36 "../src/data/Game.vala"
	result = _tmp0_;
#line 36 "../src/data/Game.vala"
	return result;
#line 4387 "Game.c"
}

void
game_hub_data_game_set_info (GameHubDataGame* self,
                             const gchar* value)
{
#line 36 "../src/data/Game.vala"
	g_return_if_fail (self != NULL);
#line 36 "../src/data/Game.vala"
	if (g_strcmp0 (value, game_hub_data_game_get_info (self)) != 0) {
#line 4398 "Game.c"
		gchar* _tmp0_;
#line 36 "../src/data/Game.vala"
		_tmp0_ = g_strdup (value);
#line 36 "../src/data/Game.vala"
		_g_free0 (self->priv->_info);
#line 36 "../src/data/Game.vala"
		self->priv->_info = _tmp0_;
#line 36 "../src/data/Game.vala"
		g_object_notify_by_pspec ((GObject *) self, game_hub_data_game_properties[GAME_HUB_DATA_GAME_INFO_PROPERTY]);
#line 4408 "Game.c"
	}
}

const gchar*
game_hub_data_game_get_info_detailed (GameHubDataGame* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 37 "../src/data/Game.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 37 "../src/data/Game.vala"
	_tmp0_ = self->priv->_info_detailed;
#line 37 "../src/data/Game.vala"
	result = _tmp0_;
#line 37 "../src/data/Game.vala"
	return result;
#line 4425 "Game.c"
}

void
game_hub_data_game_set_info_detailed (GameHubDataGame* self,
                                      const gchar* value)
{
#line 37 "../src/data/Game.vala"
	g_return_if_fail (self != NULL);
#line 37 "../src/data/Game.vala"
	if (g_strcmp0 (value, game_hub_data_game_get_info_detailed (self)) != 0) {
#line 4436 "Game.c"
		gchar* _tmp0_;
#line 37 "../src/data/Game.vala"
		_tmp0_ = g_strdup (value);
#line 37 "../src/data/Game.vala"
		_g_free0 (self->priv->_info_detailed);
#line 37 "../src/data/Game.vala"
		self->priv->_info_detailed = _tmp0_;
#line 37 "../src/data/Game.vala"
		g_object_notify_by_pspec ((GObject *) self, game_hub_data_game_properties[GAME_HUB_DATA_GAME_INFO_DETAILED_PROPERTY]);
#line 4446 "Game.c"
	}
}

gchar*
game_hub_data_game_get_full_id (GameHubDataGame* self)
{
	gchar* result;
	GameHubDataGameSource* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	const gchar* _tmp5_;
	const gchar* _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
#line 39 "../src/data/Game.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 39 "../src/data/Game.vala"
	_tmp0_ = self->priv->_source;
#line 39 "../src/data/Game.vala"
	_tmp1_ = game_hub_data_game_source_get_id (_tmp0_);
#line 39 "../src/data/Game.vala"
	_tmp2_ = _tmp1_;
#line 39 "../src/data/Game.vala"
	_tmp3_ = g_strconcat (_tmp2_, ":", NULL);
#line 39 "../src/data/Game.vala"
	_tmp4_ = _tmp3_;
#line 39 "../src/data/Game.vala"
	_tmp5_ = game_hub_data_runnable_get_id ((GameHubDataRunnable*) self);
#line 39 "../src/data/Game.vala"
	_tmp6_ = _tmp5_;
#line 39 "../src/data/Game.vala"
	_tmp7_ = g_strconcat (_tmp4_, _tmp6_, NULL);
#line 39 "../src/data/Game.vala"
	_tmp8_ = _tmp7_;
#line 39 "../src/data/Game.vala"
	_g_free0 (_tmp4_);
#line 39 "../src/data/Game.vala"
	result = _tmp8_;
#line 39 "../src/data/Game.vala"
	return result;
#line 4489 "Game.c"
}

const gchar*
game_hub_data_game_get_version (GameHubDataGame* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 41 "../src/data/Game.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 41 "../src/data/Game.vala"
	_tmp0_ = self->priv->_version;
#line 41 "../src/data/Game.vala"
	result = _tmp0_;
#line 41 "../src/data/Game.vala"
	return result;
#line 4505 "Game.c"
}

void
game_hub_data_game_set_version (GameHubDataGame* self,
                                const gchar* value)
{
#line 41 "../src/data/Game.vala"
	g_return_if_fail (self != NULL);
#line 41 "../src/data/Game.vala"
	if (g_strcmp0 (value, game_hub_data_game_get_version (self)) != 0) {
#line 4516 "Game.c"
		gchar* _tmp0_;
#line 41 "../src/data/Game.vala"
		_tmp0_ = g_strdup (value);
#line 41 "../src/data/Game.vala"
		_g_free0 (self->priv->_version);
#line 41 "../src/data/Game.vala"
		self->priv->_version = _tmp0_;
#line 41 "../src/data/Game.vala"
		g_object_notify_by_pspec ((GObject *) self, game_hub_data_game_properties[GAME_HUB_DATA_GAME_VERSION_PROPERTY]);
#line 4526 "Game.c"
	}
}

GeeArrayList*
game_hub_data_game_get_tags (GameHubDataGame* self)
{
	GeeArrayList* result;
	GeeArrayList* _tmp0_;
#line 43 "../src/data/Game.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 43 "../src/data/Game.vala"
	_tmp0_ = self->priv->_tags;
#line 43 "../src/data/Game.vala"
	result = _tmp0_;
#line 43 "../src/data/Game.vala"
	return result;
#line 4543 "Game.c"
}

void
game_hub_data_game_set_tags (GameHubDataGame* self,
                             GeeArrayList* value)
{
#line 43 "../src/data/Game.vala"
	g_return_if_fail (self != NULL);
#line 43 "../src/data/Game.vala"
	if (game_hub_data_game_get_tags (self) != value) {
#line 4554 "Game.c"
		GeeArrayList* _tmp0_;
#line 43 "../src/data/Game.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 43 "../src/data/Game.vala"
		_g_object_unref0 (self->priv->_tags);
#line 43 "../src/data/Game.vala"
		self->priv->_tags = _tmp0_;
#line 43 "../src/data/Game.vala"
		g_object_notify_by_pspec ((GObject *) self, game_hub_data_game_properties[GAME_HUB_DATA_GAME_TAGS_PROPERTY]);
#line 4564 "Game.c"
	}
}

GFile*
game_hub_data_game_get_installers_dir (GameHubDataGame* self)
{
	GFile* result;
	GFile* _tmp0_;
#line 99 "../src/data/Game.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 99 "../src/data/Game.vala"
	_tmp0_ = self->priv->_installers_dir;
#line 99 "../src/data/Game.vala"
	result = _tmp0_;
#line 99 "../src/data/Game.vala"
	return result;
#line 4581 "Game.c"
}

void
game_hub_data_game_set_installers_dir (GameHubDataGame* self,
                                       GFile* value)
{
#line 99 "../src/data/Game.vala"
	g_return_if_fail (self != NULL);
#line 99 "../src/data/Game.vala"
	if (game_hub_data_game_get_installers_dir (self) != value) {
#line 4592 "Game.c"
		GFile* _tmp0_;
#line 99 "../src/data/Game.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 99 "../src/data/Game.vala"
		_g_object_unref0 (self->priv->_installers_dir);
#line 99 "../src/data/Game.vala"
		self->priv->_installers_dir = _tmp0_;
#line 99 "../src/data/Game.vala"
		g_object_notify_by_pspec ((GObject *) self, game_hub_data_game_properties[GAME_HUB_DATA_GAME_INSTALLERS_DIR_PROPERTY]);
#line 4602 "Game.c"
	}
}

gboolean
game_hub_data_game_get_is_installable (GameHubDataGame* self)
{
	gboolean result;
#line 100 "../src/data/Game.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 100 "../src/data/Game.vala"
	result = self->priv->_is_installable;
#line 100 "../src/data/Game.vala"
	return result;
#line 4616 "Game.c"
}

void
game_hub_data_game_set_is_installable (GameHubDataGame* self,
                                       gboolean value)
{
#line 100 "../src/data/Game.vala"
	g_return_if_fail (self != NULL);
#line 100 "../src/data/Game.vala"
	if (game_hub_data_game_get_is_installable (self) != value) {
#line 100 "../src/data/Game.vala"
		self->priv->_is_installable = value;
#line 100 "../src/data/Game.vala"
		g_object_notify_by_pspec ((GObject *) self, game_hub_data_game_properties[GAME_HUB_DATA_GAME_IS_INSTALLABLE_PROPERTY]);
#line 4631 "Game.c"
	}
}

const gchar*
game_hub_data_game_get_store_page (GameHubDataGame* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 102 "../src/data/Game.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 102 "../src/data/Game.vala"
	_tmp0_ = self->priv->_store_page;
#line 102 "../src/data/Game.vala"
	result = _tmp0_;
#line 102 "../src/data/Game.vala"
	return result;
#line 4648 "Game.c"
}

void
game_hub_data_game_set_store_page (GameHubDataGame* self,
                                   const gchar* value)
{
#line 102 "../src/data/Game.vala"
	g_return_if_fail (self != NULL);
#line 102 "../src/data/Game.vala"
	if (g_strcmp0 (value, game_hub_data_game_get_store_page (self)) != 0) {
#line 4659 "Game.c"
		gchar* _tmp0_;
#line 102 "../src/data/Game.vala"
		_tmp0_ = g_strdup (value);
#line 102 "../src/data/Game.vala"
		_g_free0 (self->priv->_store_page);
#line 102 "../src/data/Game.vala"
		self->priv->_store_page = _tmp0_;
#line 102 "../src/data/Game.vala"
		g_object_notify_by_pspec ((GObject *) self, game_hub_data_game_properties[GAME_HUB_DATA_GAME_STORE_PAGE_PROPERTY]);
#line 4669 "Game.c"
	}
}

gint64
game_hub_data_game_get_last_launch (GameHubDataGame* self)
{
	gint64 result;
#line 104 "../src/data/Game.vala"
	g_return_val_if_fail (self != NULL, 0LL);
#line 104 "../src/data/Game.vala"
	result = self->priv->_last_launch;
#line 104 "../src/data/Game.vala"
	return result;
#line 4683 "Game.c"
}

void
game_hub_data_game_set_last_launch (GameHubDataGame* self,
                                    gint64 value)
{
#line 104 "../src/data/Game.vala"
	g_return_if_fail (self != NULL);
#line 104 "../src/data/Game.vala"
	if (game_hub_data_game_get_last_launch (self) != value) {
#line 104 "../src/data/Game.vala"
		self->priv->_last_launch = value;
#line 104 "../src/data/Game.vala"
		g_object_notify_by_pspec ((GObject *) self, game_hub_data_game_properties[GAME_HUB_DATA_GAME_LAST_LAUNCH_PROPERTY]);
#line 4698 "Game.c"
	}
}

GameHubDataGameStatus*
game_hub_data_game_get_status (GameHubDataGame* self)
{
	GameHubDataGameStatus* result;
	GameHubDataGameStatus* _tmp0_;
#line 218 "../src/data/Game.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 218 "../src/data/Game.vala"
	_tmp0_ = self->_status;
#line 218 "../src/data/Game.vala"
	result = _tmp0_;
#line 218 "../src/data/Game.vala"
	return result;
#line 4715 "Game.c"
}

static gpointer
_game_hub_data_game_status_ref0 (gpointer self)
{
#line 219 "../src/data/Game.vala"
	return self ? game_hub_data_game_status_ref (self) : NULL;
#line 4723 "Game.c"
}

void
game_hub_data_game_set_status (GameHubDataGame* self,
                               GameHubDataGameStatus* value)
{
	GameHubDataGameStatus* _tmp0_;
	GameHubDataGameStatus* _tmp1_;
#line 219 "../src/data/Game.vala"
	g_return_if_fail (self != NULL);
#line 219 "../src/data/Game.vala"
	_tmp0_ = _game_hub_data_game_status_ref0 (value);
#line 219 "../src/data/Game.vala"
	_game_hub_data_game_status_unref0 (self->_status);
#line 219 "../src/data/Game.vala"
	self->_status = _tmp0_;
#line 219 "../src/data/Game.vala"
	_tmp1_ = self->_status;
#line 219 "../src/data/Game.vala"
	g_signal_emit (self, game_hub_data_game_signals[GAME_HUB_DATA_GAME_STATUS_CHANGE_SIGNAL], 0, _tmp1_);
#line 219 "../src/data/Game.vala"
	g_object_notify_by_pspec ((GObject *) self, game_hub_data_game_properties[GAME_HUB_DATA_GAME_STATUS_PROPERTY]);
#line 4746 "Game.c"
}

gint64
game_hub_data_game_get_playtime_source (GameHubDataGame* self)
{
	gint64 result;
#line 222 "../src/data/Game.vala"
	g_return_val_if_fail (self != NULL, 0LL);
#line 222 "../src/data/Game.vala"
	result = self->priv->_playtime_source;
#line 222 "../src/data/Game.vala"
	return result;
#line 4759 "Game.c"
}

void
game_hub_data_game_set_playtime_source (GameHubDataGame* self,
                                        gint64 value)
{
#line 222 "../src/data/Game.vala"
	g_return_if_fail (self != NULL);
#line 222 "../src/data/Game.vala"
	if (game_hub_data_game_get_playtime_source (self) != value) {
#line 222 "../src/data/Game.vala"
		self->priv->_playtime_source = value;
#line 222 "../src/data/Game.vala"
		g_object_notify_by_pspec ((GObject *) self, game_hub_data_game_properties[GAME_HUB_DATA_GAME_PLAYTIME_SOURCE_PROPERTY]);
#line 4774 "Game.c"
	}
}

gint64
game_hub_data_game_get_playtime_tracked (GameHubDataGame* self)
{
	gint64 result;
#line 223 "../src/data/Game.vala"
	g_return_val_if_fail (self != NULL, 0LL);
#line 223 "../src/data/Game.vala"
	result = self->priv->_playtime_tracked;
#line 223 "../src/data/Game.vala"
	return result;
#line 4788 "Game.c"
}

void
game_hub_data_game_set_playtime_tracked (GameHubDataGame* self,
                                         gint64 value)
{
#line 223 "../src/data/Game.vala"
	g_return_if_fail (self != NULL);
#line 223 "../src/data/Game.vala"
	if (game_hub_data_game_get_playtime_tracked (self) != value) {
#line 223 "../src/data/Game.vala"
		self->priv->_playtime_tracked = value;
#line 223 "../src/data/Game.vala"
		g_object_notify_by_pspec ((GObject *) self, game_hub_data_game_properties[GAME_HUB_DATA_GAME_PLAYTIME_TRACKED_PROPERTY]);
#line 4803 "Game.c"
	}
}

gint64
game_hub_data_game_get_playtime (GameHubDataGame* self)
{
	gint64 result;
	gint64 _tmp0_;
	gint64 _tmp1_;
#line 225 "../src/data/Game.vala"
	g_return_val_if_fail (self != NULL, 0LL);
#line 225 "../src/data/Game.vala"
	_tmp0_ = self->priv->_playtime_source;
#line 225 "../src/data/Game.vala"
	_tmp1_ = self->priv->_playtime_tracked;
#line 225 "../src/data/Game.vala"
	result = _tmp0_ + _tmp1_;
#line 225 "../src/data/Game.vala"
	return result;
#line 4823 "Game.c"
}

static GFile*
game_hub_data_game_real_get_executable (GameHubDataRunnable* base)
{
	GFile* result;
	GameHubDataGame* self;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	const gchar* _tmp2_;
	const gchar* _tmp8_;
	GFile* _tmp9_;
#line 266 "../src/data/Game.vala"
	self = (GameHubDataGame*) base;
#line 268 "../src/data/Game.vala"
	_tmp2_ = self->executable_path;
#line 268 "../src/data/Game.vala"
	if (_tmp2_ == NULL) {
#line 268 "../src/data/Game.vala"
		_tmp1_ = TRUE;
#line 4844 "Game.c"
	} else {
		const gchar* _tmp3_;
		gint _tmp4_;
		gint _tmp5_;
#line 268 "../src/data/Game.vala"
		_tmp3_ = self->executable_path;
#line 268 "../src/data/Game.vala"
		_tmp4_ = strlen (_tmp3_);
#line 268 "../src/data/Game.vala"
		_tmp5_ = _tmp4_;
#line 268 "../src/data/Game.vala"
		_tmp1_ = _tmp5_ == 0;
#line 4857 "Game.c"
	}
#line 268 "../src/data/Game.vala"
	if (_tmp1_) {
#line 268 "../src/data/Game.vala"
		_tmp0_ = TRUE;
#line 4863 "Game.c"
	} else {
		GFile* _tmp6_;
		GFile* _tmp7_;
#line 268 "../src/data/Game.vala"
		_tmp6_ = game_hub_data_runnable_get_install_dir ((GameHubDataRunnable*) self);
#line 268 "../src/data/Game.vala"
		_tmp7_ = _tmp6_;
#line 268 "../src/data/Game.vala"
		_tmp0_ = _tmp7_ == NULL;
#line 4873 "Game.c"
	}
#line 268 "../src/data/Game.vala"
	if (_tmp0_) {
#line 268 "../src/data/Game.vala"
		result = NULL;
#line 268 "../src/data/Game.vala"
		return result;
#line 4881 "Game.c"
	}
#line 269 "../src/data/Game.vala"
	_tmp8_ = self->executable_path;
#line 269 "../src/data/Game.vala"
	_tmp9_ = game_hub_data_game_get_file (self, _tmp8_, TRUE);
#line 269 "../src/data/Game.vala"
	result = _tmp9_;
#line 269 "../src/data/Game.vala"
	return result;
#line 4891 "Game.c"
}

static void
game_hub_data_game_real_set_executable (GameHubDataRunnable* base,
                                        GFile* value)
{
	GameHubDataGame* self;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
#line 271 "../src/data/Game.vala"
	self = (GameHubDataGame*) base;
#line 273 "../src/data/Game.vala"
	if (value != NULL) {
#line 273 "../src/data/Game.vala"
		_tmp2_ = g_file_query_exists (value, NULL);
#line 4908 "Game.c"
	} else {
#line 273 "../src/data/Game.vala"
		_tmp2_ = FALSE;
#line 4912 "Game.c"
	}
#line 273 "../src/data/Game.vala"
	if (_tmp2_) {
#line 4916 "Game.c"
		GFile* _tmp3_;
		GFile* _tmp4_;
#line 273 "../src/data/Game.vala"
		_tmp3_ = game_hub_data_runnable_get_install_dir ((GameHubDataRunnable*) self);
#line 273 "../src/data/Game.vala"
		_tmp4_ = _tmp3_;
#line 273 "../src/data/Game.vala"
		_tmp1_ = _tmp4_ != NULL;
#line 4925 "Game.c"
	} else {
#line 273 "../src/data/Game.vala"
		_tmp1_ = FALSE;
#line 4929 "Game.c"
	}
#line 273 "../src/data/Game.vala"
	if (_tmp1_) {
#line 4933 "Game.c"
		GFile* _tmp5_;
		GFile* _tmp6_;
#line 273 "../src/data/Game.vala"
		_tmp5_ = game_hub_data_runnable_get_install_dir ((GameHubDataRunnable*) self);
#line 273 "../src/data/Game.vala"
		_tmp6_ = _tmp5_;
#line 273 "../src/data/Game.vala"
		_tmp0_ = g_file_query_exists (_tmp6_, NULL);
#line 4942 "Game.c"
	} else {
#line 273 "../src/data/Game.vala"
		_tmp0_ = FALSE;
#line 4946 "Game.c"
	}
#line 273 "../src/data/Game.vala"
	if (_tmp0_) {
#line 4950 "Game.c"
		GFile** dirs = NULL;
		GFile* _tmp7_;
		GFile* _tmp8_;
		GFile* _tmp9_;
		GFile** _tmp10_;
		gint dirs_length1;
		gint _dirs_size_;
		gboolean _tmp11_;
		gboolean _tmp12_;
		GFile** _tmp29_;
		gint _tmp29__length1;
#line 275 "../src/data/Game.vala"
		_tmp7_ = game_hub_data_runnable_get_install_dir ((GameHubDataRunnable*) self);
#line 275 "../src/data/Game.vala"
		_tmp8_ = _tmp7_;
#line 275 "../src/data/Game.vala"
		_tmp9_ = _g_object_ref0 (_tmp8_);
#line 275 "../src/data/Game.vala"
		_tmp10_ = g_new0 (GFile*, 1 + 1);
#line 275 "../src/data/Game.vala"
		_tmp10_[0] = _tmp9_;
#line 275 "../src/data/Game.vala"
		dirs = _tmp10_;
#line 275 "../src/data/Game.vala"
		dirs_length1 = 1;
#line 275 "../src/data/Game.vala"
		_dirs_size_ = dirs_length1;
#line 276 "../src/data/Game.vala"
		_tmp11_ = game_hub_data_game_get_overlays_enabled (self);
#line 276 "../src/data/Game.vala"
		_tmp12_ = _tmp11_;
#line 276 "../src/data/Game.vala"
		if (_tmp12_) {
#line 4984 "Game.c"
			GFile* _tmp13_;
			GFile* _tmp14_;
			GFile* _tmp15_;
			GFile* _tmp16_;
			GFile* _tmp17_;
			GFile* _tmp18_;
			GFile* _tmp19_;
			GFile* _tmp20_;
			GFile* _tmp21_;
			GFile* _tmp22_;
			GFile* _tmp23_;
			GFile* _tmp24_;
			GFile* _tmp25_;
			GFile* _tmp26_;
			GFile* _tmp27_;
			GFile** _tmp28_;
#line 278 "../src/data/Game.vala"
			_tmp13_ = game_hub_data_runnable_get_install_dir ((GameHubDataRunnable*) self);
#line 278 "../src/data/Game.vala"
			_tmp14_ = _tmp13_;
#line 278 "../src/data/Game.vala"
			_tmp15_ = g_file_get_child (_tmp14_, GAME_HUB_UTILS_FS_UTILS_GAMEHUB_DIR);
#line 278 "../src/data/Game.vala"
			_tmp16_ = _tmp15_;
#line 278 "../src/data/Game.vala"
			_tmp17_ = g_file_get_child (_tmp16_, "_overlay");
#line 278 "../src/data/Game.vala"
			_tmp18_ = _tmp17_;
#line 278 "../src/data/Game.vala"
			_tmp19_ = g_file_get_child (_tmp18_, "merged");
#line 278 "../src/data/Game.vala"
			_tmp20_ = game_hub_data_runnable_get_install_dir ((GameHubDataRunnable*) self);
#line 278 "../src/data/Game.vala"
			_tmp21_ = _tmp20_;
#line 278 "../src/data/Game.vala"
			_tmp22_ = g_file_get_child (_tmp21_, GAME_HUB_UTILS_FS_UTILS_GAMEHUB_DIR);
#line 278 "../src/data/Game.vala"
			_tmp23_ = _tmp22_;
#line 278 "../src/data/Game.vala"
			_tmp24_ = g_file_get_child (_tmp23_, GAME_HUB_DATA_GAME_OVERLAY_BASE);
#line 278 "../src/data/Game.vala"
			_tmp25_ = game_hub_data_runnable_get_install_dir ((GameHubDataRunnable*) self);
#line 278 "../src/data/Game.vala"
			_tmp26_ = _tmp25_;
#line 278 "../src/data/Game.vala"
			_tmp27_ = _g_object_ref0 (_tmp26_);
#line 278 "../src/data/Game.vala"
			_tmp28_ = g_new0 (GFile*, 3 + 1);
#line 278 "../src/data/Game.vala"
			_tmp28_[0] = _tmp19_;
#line 278 "../src/data/Game.vala"
			_tmp28_[1] = _tmp24_;
#line 278 "../src/data/Game.vala"
			_tmp28_[2] = _tmp27_;
#line 278 "../src/data/Game.vala"
			dirs = (_vala_array_free (dirs, dirs_length1, (GDestroyNotify) g_object_unref), NULL);
#line 278 "../src/data/Game.vala"
			dirs = _tmp28_;
#line 278 "../src/data/Game.vala"
			dirs_length1 = 3;
#line 278 "../src/data/Game.vala"
			_dirs_size_ = dirs_length1;
#line 278 "../src/data/Game.vala"
			_g_object_unref0 (_tmp23_);
#line 278 "../src/data/Game.vala"
			_g_object_unref0 (_tmp18_);
#line 278 "../src/data/Game.vala"
			_g_object_unref0 (_tmp16_);
#line 5053 "Game.c"
		}
#line 284 "../src/data/Game.vala"
		_tmp29_ = dirs;
#line 284 "../src/data/Game.vala"
		_tmp29__length1 = dirs_length1;
#line 5059 "Game.c"
		{
			GFile** dir_collection = NULL;
			gint dir_collection_length1 = 0;
			gint _dir_collection_size_ = 0;
			gint dir_it = 0;
#line 284 "../src/data/Game.vala"
			dir_collection = _tmp29_;
#line 284 "../src/data/Game.vala"
			dir_collection_length1 = _tmp29__length1;
#line 284 "../src/data/Game.vala"
			for (dir_it = 0; dir_it < dir_collection_length1; dir_it = dir_it + 1) {
#line 5071 "Game.c"
				GFile* _tmp30_;
				GFile* dir = NULL;
#line 284 "../src/data/Game.vala"
				_tmp30_ = _g_object_ref0 (dir_collection[dir_it]);
#line 284 "../src/data/Game.vala"
				dir = _tmp30_;
#line 5078 "Game.c"
				{
					gchar* _tmp31_;
					gchar* _tmp32_;
					GFile* _tmp33_;
					gchar* _tmp34_;
					gchar* _tmp35_;
					gboolean _tmp36_;
#line 286 "../src/data/Game.vala"
					_tmp31_ = g_file_get_path (value);
#line 286 "../src/data/Game.vala"
					_tmp32_ = _tmp31_;
#line 286 "../src/data/Game.vala"
					_tmp33_ = dir;
#line 286 "../src/data/Game.vala"
					_tmp34_ = g_file_get_path (_tmp33_);
#line 286 "../src/data/Game.vala"
					_tmp35_ = _tmp34_;
#line 286 "../src/data/Game.vala"
					_tmp36_ = g_str_has_prefix (_tmp32_, _tmp35_);
#line 286 "../src/data/Game.vala"
					_g_free0 (_tmp35_);
#line 286 "../src/data/Game.vala"
					_g_free0 (_tmp32_);
#line 286 "../src/data/Game.vala"
					if (_tmp36_) {
#line 5104 "Game.c"
						gchar* _tmp37_;
						gchar* _tmp38_;
						GFile* _tmp39_;
						gchar* _tmp40_;
						gchar* _tmp41_;
						gchar* _tmp42_;
#line 288 "../src/data/Game.vala"
						_tmp37_ = g_file_get_path (value);
#line 288 "../src/data/Game.vala"
						_tmp38_ = _tmp37_;
#line 288 "../src/data/Game.vala"
						_tmp39_ = dir;
#line 288 "../src/data/Game.vala"
						_tmp40_ = g_file_get_path (_tmp39_);
#line 288 "../src/data/Game.vala"
						_tmp41_ = _tmp40_;
#line 288 "../src/data/Game.vala"
						_tmp42_ = string_replace (_tmp38_, _tmp41_, "$game_dir");
#line 288 "../src/data/Game.vala"
						_g_free0 (self->executable_path);
#line 288 "../src/data/Game.vala"
						self->executable_path = _tmp42_;
#line 288 "../src/data/Game.vala"
						_g_free0 (_tmp41_);
#line 288 "../src/data/Game.vala"
						_g_free0 (_tmp38_);
#line 289 "../src/data/Game.vala"
						_g_object_unref0 (dir);
#line 289 "../src/data/Game.vala"
						break;
#line 5135 "Game.c"
					}
#line 284 "../src/data/Game.vala"
					_g_object_unref0 (dir);
#line 5139 "Game.c"
				}
			}
		}
#line 273 "../src/data/Game.vala"
		dirs = (_vala_array_free (dirs, dirs_length1, (GDestroyNotify) g_object_unref), NULL);
#line 5145 "Game.c"
	} else {
#line 295 "../src/data/Game.vala"
		_g_free0 (self->executable_path);
#line 295 "../src/data/Game.vala"
		self->executable_path = NULL;
#line 5151 "Game.c"
	}
#line 297 "../src/data/Game.vala"
	game_hub_data_runnable_save ((GameHubDataRunnable*) self);
#line 271 "../src/data/Game.vala"
	g_object_notify_by_pspec ((GObject *) self, game_hub_data_game_properties[GAME_HUB_DATA_GAME_EXECUTABLE_PROPERTY]);
#line 5157 "Game.c"
}

gboolean
game_hub_data_game_get_overlays_enabled (GameHubDataGame* self)
{
	gboolean result;
	GFile* _tmp0_;
	GFile* _tmp1_;
	gboolean _tmp2_ = FALSE;
	gboolean _tmp3_ = FALSE;
	GFile* _tmp4_;
	GFile* _tmp5_;
#line 303 "../src/data/Game.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 305 "../src/data/Game.vala"
	if (GAME_HUB_DATA_SOURCES_STEAM_IS_STEAM_GAME (self)) {
#line 305 "../src/data/Game.vala"
		result = FALSE;
#line 305 "../src/data/Game.vala"
		return result;
#line 5178 "Game.c"
	}
#line 306 "../src/data/Game.vala"
	_tmp0_ = game_hub_data_runnable_get_install_dir ((GameHubDataRunnable*) self);
#line 306 "../src/data/Game.vala"
	_tmp1_ = _tmp0_;
#line 306 "../src/data/Game.vala"
	if (game_hub_utils_fs_overlay_root_path_safety_for (_tmp1_) == GAME_HUB_UTILS_FS_OVERLAY_ROOT_PATH_SAFETY_RESTRICTED) {
#line 306 "../src/data/Game.vala"
		result = FALSE;
#line 306 "../src/data/Game.vala"
		return result;
#line 5190 "Game.c"
	}
#line 307 "../src/data/Game.vala"
	_tmp4_ = game_hub_data_runnable_get_install_dir ((GameHubDataRunnable*) self);
#line 307 "../src/data/Game.vala"
	_tmp5_ = _tmp4_;
#line 307 "../src/data/Game.vala"
	if (_tmp5_ != NULL) {
#line 5198 "Game.c"
		GFile* _tmp6_;
		GFile* _tmp7_;
#line 307 "../src/data/Game.vala"
		_tmp6_ = game_hub_data_runnable_get_install_dir ((GameHubDataRunnable*) self);
#line 307 "../src/data/Game.vala"
		_tmp7_ = _tmp6_;
#line 307 "../src/data/Game.vala"
		_tmp3_ = g_file_query_exists (_tmp7_, NULL);
#line 5207 "Game.c"
	} else {
#line 307 "../src/data/Game.vala"
		_tmp3_ = FALSE;
#line 5211 "Game.c"
	}
#line 307 "../src/data/Game.vala"
	if (_tmp3_) {
#line 5215 "Game.c"
		GFile* _tmp8_;
		GFile* _tmp9_;
		GFile* _tmp10_;
		GFile* _tmp11_;
		GFile* _tmp12_;
		GFile* _tmp13_;
		GFile* _tmp14_;
		GFile* _tmp15_;
#line 308 "../src/data/Game.vala"
		_tmp8_ = game_hub_data_runnable_get_install_dir ((GameHubDataRunnable*) self);
#line 308 "../src/data/Game.vala"
		_tmp9_ = _tmp8_;
#line 308 "../src/data/Game.vala"
		_tmp10_ = g_file_get_child (_tmp9_, GAME_HUB_UTILS_FS_UTILS_GAMEHUB_DIR);
#line 308 "../src/data/Game.vala"
		_tmp11_ = _tmp10_;
#line 308 "../src/data/Game.vala"
		_tmp12_ = g_file_get_child (_tmp11_, GAME_HUB_UTILS_FS_UTILS_OVERLAYS_DIR);
#line 308 "../src/data/Game.vala"
		_tmp13_ = _tmp12_;
#line 308 "../src/data/Game.vala"
		_tmp14_ = g_file_get_child (_tmp13_, GAME_HUB_UTILS_FS_UTILS_OVERLAYS_LIST);
#line 308 "../src/data/Game.vala"
		_tmp15_ = _tmp14_;
#line 308 "../src/data/Game.vala"
		_tmp2_ = g_file_query_exists (_tmp15_, NULL);
#line 308 "../src/data/Game.vala"
		_g_object_unref0 (_tmp15_);
#line 308 "../src/data/Game.vala"
		_g_object_unref0 (_tmp13_);
#line 308 "../src/data/Game.vala"
		_g_object_unref0 (_tmp11_);
#line 5248 "Game.c"
	} else {
#line 307 "../src/data/Game.vala"
		_tmp2_ = FALSE;
#line 5252 "Game.c"
	}
#line 307 "../src/data/Game.vala"
	result = _tmp2_;
#line 307 "../src/data/Game.vala"
	return result;
#line 5258 "Game.c"
}

GeeArrayList*
game_hub_data_game_get_achievements (GameHubDataGame* self)
{
	GeeArrayList* result;
	GeeArrayList* _tmp0_;
#line 432 "../src/data/Game.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 432 "../src/data/Game.vala"
	_tmp0_ = self->priv->_achievements;
#line 432 "../src/data/Game.vala"
	result = _tmp0_;
#line 432 "../src/data/Game.vala"
	return result;
#line 5274 "Game.c"
}

void
game_hub_data_game_set_achievements (GameHubDataGame* self,
                                     GeeArrayList* value)
{
#line 432 "../src/data/Game.vala"
	g_return_if_fail (self != NULL);
#line 432 "../src/data/Game.vala"
	if (game_hub_data_game_get_achievements (self) != value) {
#line 5285 "Game.c"
		GeeArrayList* _tmp0_;
#line 432 "../src/data/Game.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 432 "../src/data/Game.vala"
		_g_object_unref0 (self->priv->_achievements);
#line 432 "../src/data/Game.vala"
		self->priv->_achievements = _tmp0_;
#line 432 "../src/data/Game.vala"
		g_object_notify_by_pspec ((GObject *) self, game_hub_data_game_properties[GAME_HUB_DATA_GAME_ACHIEVEMENTS_PROPERTY]);
#line 5295 "Game.c"
	}
}

static void
g_cclosure_user_marshal_VOID__GAME_HUB_DATA_GAME_STATUS (GClosure * closure,
                                                         GValue * return_value,
                                                         guint n_param_values,
                                                         const GValue * param_values,
                                                         gpointer invocation_hint,
                                                         gpointer marshal_data)
{
	typedef void (*GMarshalFunc_VOID__GAME_HUB_DATA_GAME_STATUS) (gpointer data1, gpointer arg_1, gpointer data2);
	register GMarshalFunc_VOID__GAME_HUB_DATA_GAME_STATUS callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
#line 27 "../src/data/Game.vala"
	g_return_if_fail (n_param_values == 2);
#line 27 "../src/data/Game.vala"
	if (G_CCLOSURE_SWAP_DATA (closure)) {
#line 27 "../src/data/Game.vala"
		data1 = closure->data;
#line 27 "../src/data/Game.vala"
		data2 = param_values->data[0].v_pointer;
#line 5321 "Game.c"
	} else {
#line 27 "../src/data/Game.vala"
		data1 = param_values->data[0].v_pointer;
#line 27 "../src/data/Game.vala"
		data2 = closure->data;
#line 5327 "Game.c"
	}
#line 27 "../src/data/Game.vala"
	callback = (GMarshalFunc_VOID__GAME_HUB_DATA_GAME_STATUS) (marshal_data ? marshal_data : cc->callback);
#line 27 "../src/data/Game.vala"
	callback (data1, game_hub_data_game_value_get_status (param_values + 1), data2);
#line 5333 "Game.c"
}

static inline gpointer
game_hub_data_game_overlay_get_instance_private (GameHubDataGameOverlay* self)
{
	return G_STRUCT_MEMBER_P (self, GameHubDataGameOverlay_private_offset);
}

GameHubDataGameOverlay*
game_hub_data_game_overlay_construct (GType object_type,
                                      GameHubDataGame* game,
                                      const gchar* id,
                                      const gchar* name,
                                      gboolean enabled)
{
	GameHubDataGameOverlay * self = NULL;
	const gchar* _tmp0_ = NULL;
	const gchar* _tmp3_ = NULL;
	gboolean _tmp4_ = FALSE;
#line 472 "../src/data/Game.vala"
	g_return_val_if_fail (game != NULL, NULL);
#line 472 "../src/data/Game.vala"
	g_return_val_if_fail (id != NULL, NULL);
#line 474 "../src/data/Game.vala"
	if (g_strcmp0 (id, GAME_HUB_DATA_GAME_OVERLAY_BASE) == 0) {
#line 5359 "Game.c"
		const gchar* _tmp1_;
		const gchar* _tmp2_;
#line 474 "../src/data/Game.vala"
		_tmp1_ = game_hub_data_runnable_get_name ((GameHubDataRunnable*) game);
#line 474 "../src/data/Game.vala"
		_tmp2_ = _tmp1_;
#line 474 "../src/data/Game.vala"
		_tmp0_ = _tmp2_;
#line 5368 "Game.c"
	} else {
#line 474 "../src/data/Game.vala"
		_tmp0_ = id;
#line 5372 "Game.c"
	}
#line 474 "../src/data/Game.vala"
	_tmp3_ = name;
#line 474 "../src/data/Game.vala"
	if (_tmp3_ == NULL) {
#line 474 "../src/data/Game.vala"
		_tmp3_ = _tmp0_;
#line 5380 "Game.c"
	}
#line 474 "../src/data/Game.vala"
	self = (GameHubDataGameOverlay*) g_object_new (object_type, "game", game, "id", id, "name", _tmp3_, NULL);
#line 475 "../src/data/Game.vala"
	if (g_strcmp0 (id, GAME_HUB_DATA_GAME_OVERLAY_BASE) == 0) {
#line 475 "../src/data/Game.vala"
		_tmp4_ = TRUE;
#line 5388 "Game.c"
	} else {
#line 475 "../src/data/Game.vala"
		_tmp4_ = enabled;
#line 5392 "Game.c"
	}
#line 475 "../src/data/Game.vala"
	game_hub_data_game_overlay_set_enabled (self, _tmp4_);
#line 472 "../src/data/Game.vala"
	return self;
#line 5398 "Game.c"
}

GameHubDataGameOverlay*
game_hub_data_game_overlay_new (GameHubDataGame* game,
                                const gchar* id,
                                const gchar* name,
                                gboolean enabled)
{
#line 472 "../src/data/Game.vala"
	return game_hub_data_game_overlay_construct (GAME_HUB_DATA_GAME_TYPE_OVERLAY, game, id, name, enabled);
#line 5409 "Game.c"
}

static const gchar*
string_to_string (const gchar* self)
{
	const gchar* result = NULL;
#line 1516 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1517 "glib-2.0.vapi"
	result = self;
#line 1517 "glib-2.0.vapi"
	return result;
#line 5422 "Game.c"
}

static void
__lambda84_ (GameHubDataGameOverlay* self,
             GObject* obj,
             GAsyncResult* res)
{
	GameHubDataGame* _tmp0_;
	const gchar* _tmp1_;
	GError* _inner_error0_ = NULL;
#line 489 "../src/data/Game.vala"
	g_return_if_fail (res != NULL);
#line 490 "../src/data/Game.vala"
	_tmp0_ = self->priv->_game;
#line 490 "../src/data/Game.vala"
	game_hub_data_game_umount_overlays_finish (_tmp0_, res);
#line 492 "../src/data/Game.vala"
	_tmp1_ = self->priv->_id;
#line 492 "../src/data/Game.vala"
	if (g_strcmp0 (_tmp1_, GAME_HUB_DATA_GAME_OVERLAY_BASE) != 0) {
#line 5443 "Game.c"
		gboolean _tmp2_ = FALSE;
		GFile* _tmp3_;
		GameHubDataGame* _tmp8_;
		GeeArrayList* _tmp9_;
		GameHubDataGame* _tmp10_;
#line 494 "../src/data/Game.vala"
		_tmp3_ = self->directory;
#line 494 "../src/data/Game.vala"
		if (_tmp3_ != NULL) {
#line 5453 "Game.c"
			GFile* _tmp4_;
#line 494 "../src/data/Game.vala"
			_tmp4_ = self->directory;
#line 494 "../src/data/Game.vala"
			_tmp2_ = g_file_query_exists (_tmp4_, NULL);
#line 5459 "Game.c"
		} else {
#line 494 "../src/data/Game.vala"
			_tmp2_ = FALSE;
#line 5463 "Game.c"
		}
#line 494 "../src/data/Game.vala"
		if (_tmp2_) {
#line 5467 "Game.c"
			GFile* _tmp5_;
			gchar* _tmp6_;
			gchar* _tmp7_;
#line 496 "../src/data/Game.vala"
			_tmp5_ = self->directory;
#line 496 "../src/data/Game.vala"
			_tmp6_ = g_file_get_path (_tmp5_);
#line 496 "../src/data/Game.vala"
			_tmp7_ = _tmp6_;
#line 496 "../src/data/Game.vala"
			game_hub_utils_fs_utils_rm (_tmp7_, NULL, "-rf", NULL);
#line 496 "../src/data/Game.vala"
			_g_free0 (_tmp7_);
#line 5481 "Game.c"
		}
#line 498 "../src/data/Game.vala"
		_tmp8_ = self->priv->_game;
#line 498 "../src/data/Game.vala"
		_tmp9_ = _tmp8_->overlays;
#line 498 "../src/data/Game.vala"
		gee_abstract_collection_remove ((GeeAbstractCollection*) _tmp9_, self);
#line 499 "../src/data/Game.vala"
		_tmp10_ = self->priv->_game;
#line 499 "../src/data/Game.vala"
		game_hub_data_game_save_overlays (_tmp10_);
#line 5493 "Game.c"
	} else {
		{
			GameHubDataGame* _tmp11_;
			GFile* _tmp12_;
			GFile* _tmp13_;
			const gchar* _tmp14_;
			const gchar* _tmp15_;
			const gchar* _tmp16_;
			gchar* _tmp17_;
			gchar* _tmp18_;
			GameHubDataGame* _tmp19_;
			GeeArrayList* _tmp20_;
			GameHubDataGame* _tmp21_;
			GFile* _tmp22_;
			GFile* _tmp23_;
			GFile* _tmp24_;
			GFile* _tmp25_;
			GFile* _tmp26_;
			GFile* _tmp27_;
			GFile* _tmp28_;
			GFile* _tmp29_;
			GameHubDataGame* _tmp30_;
			GFile* _tmp31_;
			GFile* _tmp32_;
			GFile* _tmp33_;
			GFile* _tmp34_;
			GFile* _tmp35_;
			GFile* _tmp36_;
			GameHubDataGame* _tmp37_;
#line 505 "../src/data/Game.vala"
			_tmp11_ = self->priv->_game;
#line 505 "../src/data/Game.vala"
			_tmp12_ = game_hub_data_runnable_get_install_dir ((GameHubDataRunnable*) _tmp11_);
#line 505 "../src/data/Game.vala"
			_tmp13_ = _tmp12_;
#line 505 "../src/data/Game.vala"
			_tmp14_ = string_to_string (GAME_HUB_UTILS_FS_UTILS_GAMEHUB_DIR);
#line 505 "../src/data/Game.vala"
			_tmp15_ = string_to_string (GAME_HUB_UTILS_FS_UTILS_OVERLAYS_DIR);
#line 505 "../src/data/Game.vala"
			_tmp16_ = string_to_string (GAME_HUB_DATA_GAME_OVERLAY_BASE);
#line 505 "../src/data/Game.vala"
			_tmp17_ = g_strconcat (_tmp14_, "/", _tmp15_, "/", _tmp16_, NULL);
#line 505 "../src/data/Game.vala"
			_tmp18_ = _tmp17_;
#line 505 "../src/data/Game.vala"
			game_hub_utils_fs_utils_mv_up (_tmp13_, _tmp18_);
#line 505 "../src/data/Game.vala"
			_g_free0 (_tmp18_);
#line 506 "../src/data/Game.vala"
			_tmp19_ = self->priv->_game;
#line 506 "../src/data/Game.vala"
			_tmp20_ = _tmp19_->overlays;
#line 506 "../src/data/Game.vala"
			gee_abstract_collection_clear ((GeeAbstractCollection*) _tmp20_);
#line 507 "../src/data/Game.vala"
			_tmp21_ = self->priv->_game;
#line 507 "../src/data/Game.vala"
			_tmp22_ = game_hub_data_runnable_get_install_dir ((GameHubDataRunnable*) _tmp21_);
#line 507 "../src/data/Game.vala"
			_tmp23_ = _tmp22_;
#line 507 "../src/data/Game.vala"
			_tmp24_ = g_file_get_child (_tmp23_, GAME_HUB_UTILS_FS_UTILS_GAMEHUB_DIR);
#line 507 "../src/data/Game.vala"
			_tmp25_ = _tmp24_;
#line 507 "../src/data/Game.vala"
			_tmp26_ = g_file_get_child (_tmp25_, GAME_HUB_UTILS_FS_UTILS_OVERLAYS_DIR);
#line 507 "../src/data/Game.vala"
			_tmp27_ = _tmp26_;
#line 507 "../src/data/Game.vala"
			_tmp28_ = g_file_get_child (_tmp27_, GAME_HUB_UTILS_FS_UTILS_OVERLAYS_LIST);
#line 507 "../src/data/Game.vala"
			_tmp29_ = _tmp28_;
#line 507 "../src/data/Game.vala"
			g_file_delete (_tmp29_, NULL, &_inner_error0_);
#line 507 "../src/data/Game.vala"
			_g_object_unref0 (_tmp29_);
#line 507 "../src/data/Game.vala"
			_g_object_unref0 (_tmp27_);
#line 507 "../src/data/Game.vala"
			_g_object_unref0 (_tmp25_);
#line 507 "../src/data/Game.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 5577 "Game.c"
				goto __catch13_g_error;
			}
#line 508 "../src/data/Game.vala"
			_tmp30_ = self->priv->_game;
#line 508 "../src/data/Game.vala"
			_tmp31_ = game_hub_data_runnable_get_install_dir ((GameHubDataRunnable*) _tmp30_);
#line 508 "../src/data/Game.vala"
			_tmp32_ = _tmp31_;
#line 508 "../src/data/Game.vala"
			_tmp33_ = g_file_get_child (_tmp32_, GAME_HUB_UTILS_FS_UTILS_GAMEHUB_DIR);
#line 508 "../src/data/Game.vala"
			_tmp34_ = _tmp33_;
#line 508 "../src/data/Game.vala"
			_tmp35_ = g_file_get_child (_tmp34_, GAME_HUB_UTILS_FS_UTILS_OVERLAYS_DIR);
#line 508 "../src/data/Game.vala"
			_tmp36_ = _tmp35_;
#line 508 "../src/data/Game.vala"
			g_file_delete (_tmp36_, NULL, &_inner_error0_);
#line 508 "../src/data/Game.vala"
			_g_object_unref0 (_tmp36_);
#line 508 "../src/data/Game.vala"
			_g_object_unref0 (_tmp34_);
#line 508 "../src/data/Game.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 5602 "Game.c"
				goto __catch13_g_error;
			}
#line 509 "../src/data/Game.vala"
			_tmp37_ = self->priv->_game;
#line 509 "../src/data/Game.vala"
			g_object_notify ((GObject*) _tmp37_, "overlays-enabled");
#line 5609 "Game.c"
		}
		goto __finally13;
		__catch13_g_error:
		{
			GError* e = NULL;
			GError* _tmp38_;
			const gchar* _tmp39_;
#line 503 "../src/data/Game.vala"
			e = _inner_error0_;
#line 503 "../src/data/Game.vala"
			_inner_error0_ = NULL;
#line 513 "../src/data/Game.vala"
			_tmp38_ = e;
#line 513 "../src/data/Game.vala"
			_tmp39_ = _tmp38_->message;
#line 513 "../src/data/Game.vala"
			g_warning ("Game.vala:513: [Game.Overlay.remove] %s", _tmp39_);
#line 503 "../src/data/Game.vala"
			_g_error_free0 (e);
#line 5629 "Game.c"
		}
		__finally13:
#line 503 "../src/data/Game.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 503 "../src/data/Game.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 503 "../src/data/Game.vala"
			g_clear_error (&_inner_error0_);
#line 503 "../src/data/Game.vala"
			return;
#line 5640 "Game.c"
		}
	}
}

static void
___lambda84__gasync_ready_callback (GObject* source_object,
                                    GAsyncResult* res,
                                    gpointer self)
{
#line 489 "../src/data/Game.vala"
	__lambda84_ ((GameHubDataGameOverlay*) self, source_object, res);
#line 489 "../src/data/Game.vala"
	g_object_unref (self);
#line 5654 "Game.c"
}

void
game_hub_data_game_overlay_remove (GameHubDataGameOverlay* self)
{
	gboolean _tmp0_;
	gboolean _tmp1_;
	GameHubDataGame* _tmp2_;
#line 485 "../src/data/Game.vala"
	g_return_if_fail (self != NULL);
#line 487 "../src/data/Game.vala"
	_tmp0_ = game_hub_data_game_overlay_get_removable (self);
#line 487 "../src/data/Game.vala"
	_tmp1_ = _tmp0_;
#line 487 "../src/data/Game.vala"
	if (!_tmp1_) {
#line 487 "../src/data/Game.vala"
		return;
#line 5673 "Game.c"
	}
#line 489 "../src/data/Game.vala"
	_tmp2_ = self->priv->_game;
#line 489 "../src/data/Game.vala"
	game_hub_data_game_umount_overlays (_tmp2_, ___lambda84__gasync_ready_callback, g_object_ref (self));
#line 5679 "Game.c"
}

GameHubDataGame*
game_hub_data_game_overlay_get_game (GameHubDataGameOverlay* self)
{
	GameHubDataGame* result;
	GameHubDataGame* _tmp0_;
#line 449 "../src/data/Game.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 449 "../src/data/Game.vala"
	_tmp0_ = self->priv->_game;
#line 449 "../src/data/Game.vala"
	result = _tmp0_;
#line 449 "../src/data/Game.vala"
	return result;
#line 5695 "Game.c"
}

static void
game_hub_data_game_overlay_set_game (GameHubDataGameOverlay* self,
                                     GameHubDataGame* value)
{
#line 449 "../src/data/Game.vala"
	g_return_if_fail (self != NULL);
#line 449 "../src/data/Game.vala"
	if (game_hub_data_game_overlay_get_game (self) != value) {
#line 5706 "Game.c"
		GameHubDataGame* _tmp0_;
#line 449 "../src/data/Game.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 449 "../src/data/Game.vala"
		_g_object_unref0 (self->priv->_game);
#line 449 "../src/data/Game.vala"
		self->priv->_game = _tmp0_;
#line 449 "../src/data/Game.vala"
		g_object_notify_by_pspec ((GObject *) self, game_hub_data_game_overlay_properties[GAME_HUB_DATA_GAME_OVERLAY_GAME_PROPERTY]);
#line 5716 "Game.c"
	}
}

const gchar*
game_hub_data_game_overlay_get_id (GameHubDataGameOverlay* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 451 "../src/data/Game.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 451 "../src/data/Game.vala"
	_tmp0_ = self->priv->_id;
#line 451 "../src/data/Game.vala"
	result = _tmp0_;
#line 451 "../src/data/Game.vala"
	return result;
#line 5733 "Game.c"
}

static void
game_hub_data_game_overlay_set_id (GameHubDataGameOverlay* self,
                                   const gchar* value)
{
#line 451 "../src/data/Game.vala"
	g_return_if_fail (self != NULL);
#line 451 "../src/data/Game.vala"
	if (g_strcmp0 (value, game_hub_data_game_overlay_get_id (self)) != 0) {
#line 5744 "Game.c"
		gchar* _tmp0_;
#line 451 "../src/data/Game.vala"
		_tmp0_ = g_strdup (value);
#line 451 "../src/data/Game.vala"
		_g_free0 (self->priv->_id);
#line 451 "../src/data/Game.vala"
		self->priv->_id = _tmp0_;
#line 451 "../src/data/Game.vala"
		g_object_notify_by_pspec ((GObject *) self, game_hub_data_game_overlay_properties[GAME_HUB_DATA_GAME_OVERLAY_ID_PROPERTY]);
#line 5754 "Game.c"
	}
}

const gchar*
game_hub_data_game_overlay_get_name (GameHubDataGameOverlay* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 452 "../src/data/Game.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 452 "../src/data/Game.vala"
	_tmp0_ = self->priv->_name;
#line 452 "../src/data/Game.vala"
	result = _tmp0_;
#line 452 "../src/data/Game.vala"
	return result;
#line 5771 "Game.c"
}

static void
game_hub_data_game_overlay_set_name (GameHubDataGameOverlay* self,
                                     const gchar* value)
{
#line 452 "../src/data/Game.vala"
	g_return_if_fail (self != NULL);
#line 452 "../src/data/Game.vala"
	if (g_strcmp0 (value, game_hub_data_game_overlay_get_name (self)) != 0) {
#line 5782 "Game.c"
		gchar* _tmp0_;
#line 452 "../src/data/Game.vala"
		_tmp0_ = g_strdup (value);
#line 452 "../src/data/Game.vala"
		_g_free0 (self->priv->_name);
#line 452 "../src/data/Game.vala"
		self->priv->_name = _tmp0_;
#line 452 "../src/data/Game.vala"
		g_object_notify_by_pspec ((GObject *) self, game_hub_data_game_overlay_properties[GAME_HUB_DATA_GAME_OVERLAY_NAME_PROPERTY]);
#line 5792 "Game.c"
	}
}

gboolean
game_hub_data_game_overlay_get_enabled (GameHubDataGameOverlay* self)
{
	gboolean result;
#line 453 "../src/data/Game.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 453 "../src/data/Game.vala"
	result = self->priv->_enabled;
#line 453 "../src/data/Game.vala"
	return result;
#line 5806 "Game.c"
}

void
game_hub_data_game_overlay_set_enabled (GameHubDataGameOverlay* self,
                                        gboolean value)
{
#line 453 "../src/data/Game.vala"
	g_return_if_fail (self != NULL);
#line 453 "../src/data/Game.vala"
	if (game_hub_data_game_overlay_get_enabled (self) != value) {
#line 453 "../src/data/Game.vala"
		self->priv->_enabled = value;
#line 453 "../src/data/Game.vala"
		g_object_notify_by_pspec ((GObject *) self, game_hub_data_game_overlay_properties[GAME_HUB_DATA_GAME_OVERLAY_ENABLED_PROPERTY]);
#line 5821 "Game.c"
	}
}

gboolean
game_hub_data_game_overlay_get_removable (GameHubDataGameOverlay* self)
{
	gboolean result;
	gboolean _tmp0_ = FALSE;
	const gchar* _tmp1_;
#line 457 "../src/data/Game.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 459 "../src/data/Game.vala"
	_tmp1_ = self->priv->_id;
#line 459 "../src/data/Game.vala"
	if (g_strcmp0 (_tmp1_, GAME_HUB_DATA_GAME_OVERLAY_BASE) == 0) {
#line 5837 "Game.c"
		GameHubDataGame* _tmp2_;
		GeeArrayList* _tmp3_;
#line 459 "../src/data/Game.vala"
		_tmp2_ = self->priv->_game;
#line 459 "../src/data/Game.vala"
		_tmp3_ = _tmp2_->overlays;
#line 459 "../src/data/Game.vala"
		_tmp0_ = _tmp3_ != NULL;
#line 5846 "Game.c"
	} else {
#line 459 "../src/data/Game.vala"
		_tmp0_ = FALSE;
#line 5850 "Game.c"
	}
#line 459 "../src/data/Game.vala"
	if (_tmp0_) {
#line 5854 "Game.c"
		{
			GeeArrayList* _overlay_list = NULL;
			GameHubDataGame* _tmp4_;
			GeeArrayList* _tmp5_;
			GeeArrayList* _tmp6_;
			gint _overlay_size = 0;
			GeeArrayList* _tmp7_;
			gint _tmp8_;
			gint _tmp9_;
			gint _overlay_index = 0;
#line 461 "../src/data/Game.vala"
			_tmp4_ = self->priv->_game;
#line 461 "../src/data/Game.vala"
			_tmp5_ = _tmp4_->overlays;
#line 461 "../src/data/Game.vala"
			_tmp6_ = _g_object_ref0 (_tmp5_);
#line 461 "../src/data/Game.vala"
			_overlay_list = _tmp6_;
#line 461 "../src/data/Game.vala"
			_tmp7_ = _overlay_list;
#line 461 "../src/data/Game.vala"
			_tmp8_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp7_);
#line 461 "../src/data/Game.vala"
			_tmp9_ = _tmp8_;
#line 461 "../src/data/Game.vala"
			_overlay_size = _tmp9_;
#line 461 "../src/data/Game.vala"
			_overlay_index = -1;
#line 461 "../src/data/Game.vala"
			while (TRUE) {
#line 5885 "Game.c"
				GameHubDataGameOverlay* overlay = NULL;
				GeeArrayList* _tmp10_;
				gpointer _tmp11_;
				GameHubDataGameOverlay* _tmp12_;
				const gchar* _tmp13_;
#line 461 "../src/data/Game.vala"
				_overlay_index = _overlay_index + 1;
#line 461 "../src/data/Game.vala"
				if (!(_overlay_index < _overlay_size)) {
#line 461 "../src/data/Game.vala"
					break;
#line 5897 "Game.c"
				}
#line 461 "../src/data/Game.vala"
				_tmp10_ = _overlay_list;
#line 461 "../src/data/Game.vala"
				_tmp11_ = gee_abstract_list_get ((GeeAbstractList*) _tmp10_, _overlay_index);
#line 461 "../src/data/Game.vala"
				overlay = (GameHubDataGameOverlay*) _tmp11_;
#line 463 "../src/data/Game.vala"
				_tmp12_ = overlay;
#line 463 "../src/data/Game.vala"
				_tmp13_ = _tmp12_->priv->_id;
#line 463 "../src/data/Game.vala"
				if (g_strcmp0 (_tmp13_, GAME_HUB_DATA_GAME_OVERLAY_BASE) != 0) {
#line 463 "../src/data/Game.vala"
					result = FALSE;
#line 463 "../src/data/Game.vala"
					_g_object_unref0 (overlay);
#line 463 "../src/data/Game.vala"
					_g_object_unref0 (_overlay_list);
#line 463 "../src/data/Game.vala"
					return result;
#line 5919 "Game.c"
				}
#line 461 "../src/data/Game.vala"
				_g_object_unref0 (overlay);
#line 5923 "Game.c"
			}
#line 461 "../src/data/Game.vala"
			_g_object_unref0 (_overlay_list);
#line 5927 "Game.c"
		}
	}
#line 466 "../src/data/Game.vala"
	result = TRUE;
#line 466 "../src/data/Game.vala"
	return result;
#line 5934 "Game.c"
}

static GObject *
game_hub_data_game_overlay_constructor (GType type,
                                        guint n_construct_properties,
                                        GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	GameHubDataGameOverlay * self;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	GameHubDataGame* _tmp2_;
	GameHubDataGame* _tmp9_;
	GFile* _tmp10_;
	GFile* _tmp11_;
	GFile* _tmp12_;
	GFile* _tmp13_;
	GFile* _tmp14_;
	GFile* _tmp15_;
	const gchar* _tmp16_;
	GFile* _tmp17_;
	GFile* _tmp18_;
	gchar* _tmp19_;
	gchar* _tmp20_;
	GFile* _tmp21_;
#line 478 "../src/data/Game.vala"
	parent_class = G_OBJECT_CLASS (game_hub_data_game_overlay_parent_class);
#line 478 "../src/data/Game.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 478 "../src/data/Game.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GAME_HUB_DATA_GAME_TYPE_OVERLAY, GameHubDataGameOverlay);
#line 480 "../src/data/Game.vala"
	_tmp2_ = self->priv->_game;
#line 480 "../src/data/Game.vala"
	if (GAME_HUB_DATA_SOURCES_STEAM_IS_STEAM_GAME (_tmp2_)) {
#line 480 "../src/data/Game.vala"
		_tmp1_ = TRUE;
#line 5973 "Game.c"
	} else {
		GameHubDataGame* _tmp3_;
		GFile* _tmp4_;
		GFile* _tmp5_;
#line 480 "../src/data/Game.vala"
		_tmp3_ = self->priv->_game;
#line 480 "../src/data/Game.vala"
		_tmp4_ = game_hub_data_runnable_get_install_dir ((GameHubDataRunnable*) _tmp3_);
#line 480 "../src/data/Game.vala"
		_tmp5_ = _tmp4_;
#line 480 "../src/data/Game.vala"
		_tmp1_ = _tmp5_ == NULL;
#line 5986 "Game.c"
	}
#line 480 "../src/data/Game.vala"
	if (_tmp1_) {
#line 480 "../src/data/Game.vala"
		_tmp0_ = TRUE;
#line 5992 "Game.c"
	} else {
		GameHubDataGame* _tmp6_;
		GFile* _tmp7_;
		GFile* _tmp8_;
#line 480 "../src/data/Game.vala"
		_tmp6_ = self->priv->_game;
#line 480 "../src/data/Game.vala"
		_tmp7_ = game_hub_data_runnable_get_install_dir ((GameHubDataRunnable*) _tmp6_);
#line 480 "../src/data/Game.vala"
		_tmp8_ = _tmp7_;
#line 480 "../src/data/Game.vala"
		_tmp0_ = !g_file_query_exists (_tmp8_, NULL);
#line 6005 "Game.c"
	}
#line 480 "../src/data/Game.vala"
	if (_tmp0_) {
#line 480 "../src/data/Game.vala"
		return obj;
#line 6011 "Game.c"
	}
#line 482 "../src/data/Game.vala"
	_tmp9_ = self->priv->_game;
#line 482 "../src/data/Game.vala"
	_tmp10_ = game_hub_data_runnable_get_install_dir ((GameHubDataRunnable*) _tmp9_);
#line 482 "../src/data/Game.vala"
	_tmp11_ = _tmp10_;
#line 482 "../src/data/Game.vala"
	_tmp12_ = g_file_get_child (_tmp11_, GAME_HUB_UTILS_FS_UTILS_GAMEHUB_DIR);
#line 482 "../src/data/Game.vala"
	_tmp13_ = _tmp12_;
#line 482 "../src/data/Game.vala"
	_tmp14_ = g_file_get_child (_tmp13_, GAME_HUB_UTILS_FS_UTILS_OVERLAYS_DIR);
#line 482 "../src/data/Game.vala"
	_tmp15_ = _tmp14_;
#line 482 "../src/data/Game.vala"
	_tmp16_ = self->priv->_id;
#line 482 "../src/data/Game.vala"
	_tmp17_ = g_file_get_child (_tmp15_, _tmp16_);
#line 482 "../src/data/Game.vala"
	_tmp18_ = _tmp17_;
#line 482 "../src/data/Game.vala"
	_tmp19_ = g_file_get_path (_tmp18_);
#line 482 "../src/data/Game.vala"
	_tmp20_ = _tmp19_;
#line 482 "../src/data/Game.vala"
	_tmp21_ = game_hub_utils_fs_utils_mkdir (_tmp20_, NULL, NULL);
#line 482 "../src/data/Game.vala"
	_g_object_unref0 (self->directory);
#line 482 "../src/data/Game.vala"
	self->directory = _tmp21_;
#line 482 "../src/data/Game.vala"
	_g_free0 (_tmp20_);
#line 482 "../src/data/Game.vala"
	_g_object_unref0 (_tmp18_);
#line 482 "../src/data/Game.vala"
	_g_object_unref0 (_tmp15_);
#line 482 "../src/data/Game.vala"
	_g_object_unref0 (_tmp13_);
#line 478 "../src/data/Game.vala"
	return obj;
#line 6053 "Game.c"
}

static void
game_hub_data_game_overlay_class_init (GameHubDataGameOverlayClass * klass,
                                       gpointer klass_data)
{
#line 445 "../src/data/Game.vala"
	game_hub_data_game_overlay_parent_class = g_type_class_peek_parent (klass);
#line 445 "../src/data/Game.vala"
	g_type_class_adjust_private_offset (klass, &GameHubDataGameOverlay_private_offset);
#line 445 "../src/data/Game.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_game_hub_data_game_overlay_get_property;
#line 445 "../src/data/Game.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_game_hub_data_game_overlay_set_property;
#line 445 "../src/data/Game.vala"
	G_OBJECT_CLASS (klass)->constructor = game_hub_data_game_overlay_constructor;
#line 445 "../src/data/Game.vala"
	G_OBJECT_CLASS (klass)->finalize = game_hub_data_game_overlay_finalize;
#line 445 "../src/data/Game.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GAME_HUB_DATA_GAME_OVERLAY_GAME_PROPERTY, game_hub_data_game_overlay_properties[GAME_HUB_DATA_GAME_OVERLAY_GAME_PROPERTY] = g_param_spec_object ("game", "game", "game", GAME_HUB_DATA_TYPE_GAME, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 445 "../src/data/Game.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GAME_HUB_DATA_GAME_OVERLAY_ID_PROPERTY, game_hub_data_game_overlay_properties[GAME_HUB_DATA_GAME_OVERLAY_ID_PROPERTY] = g_param_spec_string ("id", "id", "id", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 445 "../src/data/Game.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GAME_HUB_DATA_GAME_OVERLAY_NAME_PROPERTY, game_hub_data_game_overlay_properties[GAME_HUB_DATA_GAME_OVERLAY_NAME_PROPERTY] = g_param_spec_string ("name", "name", "name", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 445 "../src/data/Game.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GAME_HUB_DATA_GAME_OVERLAY_ENABLED_PROPERTY, game_hub_data_game_overlay_properties[GAME_HUB_DATA_GAME_OVERLAY_ENABLED_PROPERTY] = g_param_spec_boolean ("enabled", "enabled", "enabled", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 445 "../src/data/Game.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GAME_HUB_DATA_GAME_OVERLAY_REMOVABLE_PROPERTY, game_hub_data_game_overlay_properties[GAME_HUB_DATA_GAME_OVERLAY_REMOVABLE_PROPERTY] = g_param_spec_boolean ("removable", "removable", "removable", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 6082 "Game.c"
}

static void
game_hub_data_game_overlay_instance_init (GameHubDataGameOverlay * self,
                                          gpointer klass)
{
#line 445 "../src/data/Game.vala"
	self->priv = game_hub_data_game_overlay_get_instance_private (self);
#line 6091 "Game.c"
}

static void
game_hub_data_game_overlay_finalize (GObject * obj)
{
	GameHubDataGameOverlay * self;
#line 445 "../src/data/Game.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GAME_HUB_DATA_GAME_TYPE_OVERLAY, GameHubDataGameOverlay);
#line 449 "../src/data/Game.vala"
	_g_object_unref0 (self->priv->_game);
#line 451 "../src/data/Game.vala"
	_g_free0 (self->priv->_id);
#line 452 "../src/data/Game.vala"
	_g_free0 (self->priv->_name);
#line 470 "../src/data/Game.vala"
	_g_object_unref0 (self->directory);
#line 445 "../src/data/Game.vala"
	G_OBJECT_CLASS (game_hub_data_game_overlay_parent_class)->finalize (obj);
#line 6110 "Game.c"
}

GType
game_hub_data_game_overlay_get_type (void)
{
	static volatile gsize game_hub_data_game_overlay_type_id__volatile = 0;
	if (g_once_init_enter (&game_hub_data_game_overlay_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (GameHubDataGameOverlayClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) game_hub_data_game_overlay_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GameHubDataGameOverlay), 0, (GInstanceInitFunc) game_hub_data_game_overlay_instance_init, NULL };
		GType game_hub_data_game_overlay_type_id;
		game_hub_data_game_overlay_type_id = g_type_register_static (G_TYPE_OBJECT, "GameHubDataGameOverlay", &g_define_type_info, 0);
		GameHubDataGameOverlay_private_offset = g_type_add_instance_private (game_hub_data_game_overlay_type_id, sizeof (GameHubDataGameOverlayPrivate));
		g_once_init_leave (&game_hub_data_game_overlay_type_id__volatile, game_hub_data_game_overlay_type_id);
	}
	return game_hub_data_game_overlay_type_id__volatile;
}

static void
_vala_game_hub_data_game_overlay_get_property (GObject * object,
                                               guint property_id,
                                               GValue * value,
                                               GParamSpec * pspec)
{
	GameHubDataGameOverlay * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GAME_HUB_DATA_GAME_TYPE_OVERLAY, GameHubDataGameOverlay);
#line 445 "../src/data/Game.vala"
	switch (property_id) {
#line 445 "../src/data/Game.vala"
		case GAME_HUB_DATA_GAME_OVERLAY_GAME_PROPERTY:
#line 445 "../src/data/Game.vala"
		g_value_set_object (value, game_hub_data_game_overlay_get_game (self));
#line 445 "../src/data/Game.vala"
		break;
#line 445 "../src/data/Game.vala"
		case GAME_HUB_DATA_GAME_OVERLAY_ID_PROPERTY:
#line 445 "../src/data/Game.vala"
		g_value_set_string (value, game_hub_data_game_overlay_get_id (self));
#line 445 "../src/data/Game.vala"
		break;
#line 445 "../src/data/Game.vala"
		case GAME_HUB_DATA_GAME_OVERLAY_NAME_PROPERTY:
#line 445 "../src/data/Game.vala"
		g_value_set_string (value, game_hub_data_game_overlay_get_name (self));
#line 445 "../src/data/Game.vala"
		break;
#line 445 "../src/data/Game.vala"
		case GAME_HUB_DATA_GAME_OVERLAY_ENABLED_PROPERTY:
#line 445 "../src/data/Game.vala"
		g_value_set_boolean (value, game_hub_data_game_overlay_get_enabled (self));
#line 445 "../src/data/Game.vala"
		break;
#line 445 "../src/data/Game.vala"
		case GAME_HUB_DATA_GAME_OVERLAY_REMOVABLE_PROPERTY:
#line 445 "../src/data/Game.vala"
		g_value_set_boolean (value, game_hub_data_game_overlay_get_removable (self));
#line 445 "../src/data/Game.vala"
		break;
#line 6167 "Game.c"
		default:
#line 445 "../src/data/Game.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 445 "../src/data/Game.vala"
		break;
#line 6173 "Game.c"
	}
}

static void
_vala_game_hub_data_game_overlay_set_property (GObject * object,
                                               guint property_id,
                                               const GValue * value,
                                               GParamSpec * pspec)
{
	GameHubDataGameOverlay * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GAME_HUB_DATA_GAME_TYPE_OVERLAY, GameHubDataGameOverlay);
#line 445 "../src/data/Game.vala"
	switch (property_id) {
#line 445 "../src/data/Game.vala"
		case GAME_HUB_DATA_GAME_OVERLAY_GAME_PROPERTY:
#line 445 "../src/data/Game.vala"
		game_hub_data_game_overlay_set_game (self, g_value_get_object (value));
#line 445 "../src/data/Game.vala"
		break;
#line 445 "../src/data/Game.vala"
		case GAME_HUB_DATA_GAME_OVERLAY_ID_PROPERTY:
#line 445 "../src/data/Game.vala"
		game_hub_data_game_overlay_set_id (self, g_value_get_string (value));
#line 445 "../src/data/Game.vala"
		break;
#line 445 "../src/data/Game.vala"
		case GAME_HUB_DATA_GAME_OVERLAY_NAME_PROPERTY:
#line 445 "../src/data/Game.vala"
		game_hub_data_game_overlay_set_name (self, g_value_get_string (value));
#line 445 "../src/data/Game.vala"
		break;
#line 445 "../src/data/Game.vala"
		case GAME_HUB_DATA_GAME_OVERLAY_ENABLED_PROPERTY:
#line 445 "../src/data/Game.vala"
		game_hub_data_game_overlay_set_enabled (self, g_value_get_boolean (value));
#line 445 "../src/data/Game.vala"
		break;
#line 6211 "Game.c"
		default:
#line 445 "../src/data/Game.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 445 "../src/data/Game.vala"
		break;
#line 6217 "Game.c"
	}
}

static gpointer
_game_hub_utils_downloader_download_ref0 (gpointer self)
{
#line 530 "../src/data/Game.vala"
	return self ? game_hub_utils_downloader_download_ref (self) : NULL;
#line 6226 "Game.c"
}

GameHubDataGameStatus*
game_hub_data_game_status_construct (GType object_type,
                                     GameHubDataGameState state,
                                     GameHubDataGame* game,
                                     GameHubUtilsDownloaderDownload* download)
{
	GameHubDataGameStatus* self = NULL;
	GameHubDataGame* _tmp0_;
	GameHubUtilsDownloaderDownload* _tmp1_;
#line 526 "../src/data/Game.vala"
	self = (GameHubDataGameStatus*) g_type_create_instance (object_type);
#line 528 "../src/data/Game.vala"
	self->state = state;
#line 529 "../src/data/Game.vala"
	_tmp0_ = _g_object_ref0 (game);
#line 529 "../src/data/Game.vala"
	_g_object_unref0 (self->game);
#line 529 "../src/data/Game.vala"
	self->game = _tmp0_;
#line 530 "../src/data/Game.vala"
	_tmp1_ = _game_hub_utils_downloader_download_ref0 (download);
#line 530 "../src/data/Game.vala"
	_game_hub_utils_downloader_download_unref0 (self->download);
#line 530 "../src/data/Game.vala"
	self->download = _tmp1_;
#line 526 "../src/data/Game.vala"
	return self;
#line 6256 "Game.c"
}

GameHubDataGameStatus*
game_hub_data_game_status_new (GameHubDataGameState state,
                               GameHubDataGame* game,
                               GameHubUtilsDownloaderDownload* download)
{
#line 526 "../src/data/Game.vala"
	return game_hub_data_game_status_construct (GAME_HUB_DATA_GAME_TYPE_STATUS, state, game, download);
#line 6266 "Game.c"
}

gchar*
game_hub_data_game_status_get_description (GameHubDataGameStatus* self)
{
	gchar* result;
	gboolean _tmp0_ = FALSE;
	GameHubDataGame* _tmp1_;
	GameHubDataGameState _tmp6_;
	gchar* _tmp30_;
#line 535 "../src/data/Game.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 537 "../src/data/Game.vala"
	_tmp1_ = self->game;
#line 537 "../src/data/Game.vala"
	if (_tmp1_ != NULL) {
#line 6283 "Game.c"
		GameHubDataGame* _tmp2_;
		gboolean _tmp3_;
		gboolean _tmp4_;
#line 537 "../src/data/Game.vala"
		_tmp2_ = self->game;
#line 537 "../src/data/Game.vala"
		_tmp3_ = game_hub_data_runnable_get_is_running ((GameHubDataRunnable*) _tmp2_);
#line 537 "../src/data/Game.vala"
		_tmp4_ = _tmp3_;
#line 537 "../src/data/Game.vala"
		_tmp0_ = _tmp4_;
#line 6295 "Game.c"
	} else {
#line 537 "../src/data/Game.vala"
		_tmp0_ = FALSE;
#line 6299 "Game.c"
	}
#line 537 "../src/data/Game.vala"
	if (_tmp0_) {
#line 6303 "Game.c"
		gchar* _tmp5_;
#line 537 "../src/data/Game.vala"
		_tmp5_ = g_strdup (C_ ("status", "Running"));
#line 537 "../src/data/Game.vala"
		result = _tmp5_;
#line 537 "../src/data/Game.vala"
		return result;
#line 6311 "Game.c"
	}
#line 538 "../src/data/Game.vala"
	_tmp6_ = self->state;
#line 538 "../src/data/Game.vala"
	switch (_tmp6_) {
#line 538 "../src/data/Game.vala"
		case GAME_HUB_DATA_GAME_STATE_INSTALLED:
#line 6319 "Game.c"
		{
			gchar* _tmp7_ = NULL;
			gboolean _tmp8_ = FALSE;
			GameHubDataGame* _tmp9_;
			gchar* _tmp19_;
#line 540 "../src/data/Game.vala"
			_tmp9_ = self->game;
#line 540 "../src/data/Game.vala"
			if (_tmp9_ != NULL) {
#line 6329 "Game.c"
				GameHubDataGame* _tmp10_;
				const gchar* _tmp11_;
				const gchar* _tmp12_;
#line 540 "../src/data/Game.vala"
				_tmp10_ = self->game;
#line 540 "../src/data/Game.vala"
				_tmp11_ = game_hub_data_game_get_version (_tmp10_);
#line 540 "../src/data/Game.vala"
				_tmp12_ = _tmp11_;
#line 540 "../src/data/Game.vala"
				_tmp8_ = _tmp12_ != NULL;
#line 6341 "Game.c"
			} else {
#line 540 "../src/data/Game.vala"
				_tmp8_ = FALSE;
#line 6345 "Game.c"
			}
#line 540 "../src/data/Game.vala"
			if (_tmp8_) {
#line 6349 "Game.c"
				GameHubDataGame* _tmp13_;
				const gchar* _tmp14_;
				const gchar* _tmp15_;
				const gchar* _tmp16_;
				gchar* _tmp17_;
#line 540 "../src/data/Game.vala"
				_tmp13_ = self->game;
#line 540 "../src/data/Game.vala"
				_tmp14_ = game_hub_data_game_get_version (_tmp13_);
#line 540 "../src/data/Game.vala"
				_tmp15_ = _tmp14_;
#line 540 "../src/data/Game.vala"
				_tmp16_ = string_to_string (_tmp15_);
#line 540 "../src/data/Game.vala"
				_tmp17_ = g_strconcat (": ", _tmp16_, NULL);
#line 540 "../src/data/Game.vala"
				_g_free0 (_tmp7_);
#line 540 "../src/data/Game.vala"
				_tmp7_ = _tmp17_;
#line 6369 "Game.c"
			} else {
				gchar* _tmp18_;
#line 540 "../src/data/Game.vala"
				_tmp18_ = g_strdup ("");
#line 540 "../src/data/Game.vala"
				_g_free0 (_tmp7_);
#line 540 "../src/data/Game.vala"
				_tmp7_ = _tmp18_;
#line 6378 "Game.c"
			}
#line 540 "../src/data/Game.vala"
			_tmp19_ = g_strconcat (C_ ("status", "Installed"), _tmp7_, NULL);
#line 540 "../src/data/Game.vala"
			result = _tmp19_;
#line 540 "../src/data/Game.vala"
			_g_free0 (_tmp7_);
#line 540 "../src/data/Game.vala"
			return result;
#line 6388 "Game.c"
		}
#line 538 "../src/data/Game.vala"
		case GAME_HUB_DATA_GAME_STATE_INSTALLING:
#line 6392 "Game.c"
		{
			gchar* _tmp20_;
#line 541 "../src/data/Game.vala"
			_tmp20_ = g_strdup (C_ ("status", "Installing"));
#line 541 "../src/data/Game.vala"
			result = _tmp20_;
#line 541 "../src/data/Game.vala"
			return result;
#line 6401 "Game.c"
		}
#line 538 "../src/data/Game.vala"
		case GAME_HUB_DATA_GAME_STATE_VERIFYING_INSTALLER_INTEGRITY:
#line 6405 "Game.c"
		{
			gchar* _tmp21_;
#line 542 "../src/data/Game.vala"
			_tmp21_ = g_strdup (C_ ("status", "Verifying installer integrity"));
#line 542 "../src/data/Game.vala"
			result = _tmp21_;
#line 542 "../src/data/Game.vala"
			return result;
#line 6414 "Game.c"
		}
#line 538 "../src/data/Game.vala"
		case GAME_HUB_DATA_GAME_STATE_DOWNLOADING:
#line 6418 "Game.c"
		{
			gchar* _tmp22_ = NULL;
			GameHubUtilsDownloaderDownload* _tmp23_;
#line 543 "../src/data/Game.vala"
			_tmp23_ = self->download;
#line 543 "../src/data/Game.vala"
			if (_tmp23_ != NULL) {
#line 6426 "Game.c"
				GameHubUtilsDownloaderDownload* _tmp24_;
				GameHubUtilsDownloaderDownloadStatus* _tmp25_;
				GameHubUtilsDownloaderDownloadStatus* _tmp26_;
				gchar* _tmp27_;
				gchar* _tmp28_;
#line 543 "../src/data/Game.vala"
				_tmp24_ = self->download;
#line 543 "../src/data/Game.vala"
				_tmp25_ = game_hub_utils_downloader_download_get_status (_tmp24_);
#line 543 "../src/data/Game.vala"
				_tmp26_ = _tmp25_;
#line 543 "../src/data/Game.vala"
				_tmp27_ = game_hub_utils_downloader_download_status_get_description (_tmp26_);
#line 543 "../src/data/Game.vala"
				_tmp28_ = _tmp27_;
#line 543 "../src/data/Game.vala"
				_g_free0 (_tmp22_);
#line 543 "../src/data/Game.vala"
				_tmp22_ = _tmp28_;
#line 6446 "Game.c"
			} else {
				gchar* _tmp29_;
#line 543 "../src/data/Game.vala"
				_tmp29_ = g_strdup (C_ ("status", "Download started"));
#line 543 "../src/data/Game.vala"
				_g_free0 (_tmp22_);
#line 543 "../src/data/Game.vala"
				_tmp22_ = _tmp29_;
#line 6455 "Game.c"
			}
#line 543 "../src/data/Game.vala"
			result = _tmp22_;
#line 543 "../src/data/Game.vala"
			return result;
#line 6461 "Game.c"
		}
		default:
#line 538 "../src/data/Game.vala"
		break;
#line 6466 "Game.c"
	}
#line 545 "../src/data/Game.vala"
	_tmp30_ = g_strdup (C_ ("status", "Not installed"));
#line 545 "../src/data/Game.vala"
	result = _tmp30_;
#line 545 "../src/data/Game.vala"
	return result;
#line 6474 "Game.c"
}

gchar*
game_hub_data_game_status_get_header (GameHubDataGameStatus* self)
{
	gchar* result;
	GameHubDataGameState _tmp0_;
	gchar* _tmp4_;
#line 551 "../src/data/Game.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 553 "../src/data/Game.vala"
	_tmp0_ = self->state;
#line 553 "../src/data/Game.vala"
	switch (_tmp0_) {
#line 553 "../src/data/Game.vala"
		case GAME_HUB_DATA_GAME_STATE_INSTALLED:
#line 6491 "Game.c"
		{
			gchar* _tmp1_;
#line 555 "../src/data/Game.vala"
			_tmp1_ = g_strdup (C_ ("status_header", "Installed"));
#line 555 "../src/data/Game.vala"
			result = _tmp1_;
#line 555 "../src/data/Game.vala"
			return result;
#line 6500 "Game.c"
		}
#line 553 "../src/data/Game.vala"
		case GAME_HUB_DATA_GAME_STATE_INSTALLING:
#line 6504 "Game.c"
		{
			gchar* _tmp2_;
#line 556 "../src/data/Game.vala"
			_tmp2_ = g_strdup (C_ ("status_header", "Installing"));
#line 556 "../src/data/Game.vala"
			result = _tmp2_;
#line 556 "../src/data/Game.vala"
			return result;
#line 6513 "Game.c"
		}
#line 553 "../src/data/Game.vala"
		case GAME_HUB_DATA_GAME_STATE_VERIFYING_INSTALLER_INTEGRITY:
#line 553 "../src/data/Game.vala"
		case GAME_HUB_DATA_GAME_STATE_DOWNLOADING:
#line 6519 "Game.c"
		{
			gchar* _tmp3_;
#line 558 "../src/data/Game.vala"
			_tmp3_ = g_strdup (C_ ("status_header", "Downloading"));
#line 558 "../src/data/Game.vala"
			result = _tmp3_;
#line 558 "../src/data/Game.vala"
			return result;
#line 6528 "Game.c"
		}
		default:
#line 553 "../src/data/Game.vala"
		break;
#line 6533 "Game.c"
	}
#line 560 "../src/data/Game.vala"
	_tmp4_ = g_strdup (C_ ("status_header", "Not installed"));
#line 560 "../src/data/Game.vala"
	result = _tmp4_;
#line 560 "../src/data/Game.vala"
	return result;
#line 6541 "Game.c"
}

static void
game_hub_data_game_value_status_init (GValue* value)
{
#line 520 "../src/data/Game.vala"
	value->data[0].v_pointer = NULL;
#line 6549 "Game.c"
}

static void
game_hub_data_game_value_status_free_value (GValue* value)
{
#line 520 "../src/data/Game.vala"
	if (value->data[0].v_pointer) {
#line 520 "../src/data/Game.vala"
		game_hub_data_game_status_unref (value->data[0].v_pointer);
#line 6559 "Game.c"
	}
}

static void
game_hub_data_game_value_status_copy_value (const GValue* src_value,
                                            GValue* dest_value)
{
#line 520 "../src/data/Game.vala"
	if (src_value->data[0].v_pointer) {
#line 520 "../src/data/Game.vala"
		dest_value->data[0].v_pointer = game_hub_data_game_status_ref (src_value->data[0].v_pointer);
#line 6571 "Game.c"
	} else {
#line 520 "../src/data/Game.vala"
		dest_value->data[0].v_pointer = NULL;
#line 6575 "Game.c"
	}
}

static gpointer
game_hub_data_game_value_status_peek_pointer (const GValue* value)
{
#line 520 "../src/data/Game.vala"
	return value->data[0].v_pointer;
#line 6584 "Game.c"
}

static gchar*
game_hub_data_game_value_status_collect_value (GValue* value,
                                               guint n_collect_values,
                                               GTypeCValue* collect_values,
                                               guint collect_flags)
{
#line 520 "../src/data/Game.vala"
	if (collect_values[0].v_pointer) {
#line 6595 "Game.c"
		GameHubDataGameStatus * object;
		object = collect_values[0].v_pointer;
#line 520 "../src/data/Game.vala"
		if (object->parent_instance.g_class == NULL) {
#line 520 "../src/data/Game.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 6602 "Game.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 520 "../src/data/Game.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 6606 "Game.c"
		}
#line 520 "../src/data/Game.vala"
		value->data[0].v_pointer = game_hub_data_game_status_ref (object);
#line 6610 "Game.c"
	} else {
#line 520 "../src/data/Game.vala"
		value->data[0].v_pointer = NULL;
#line 6614 "Game.c"
	}
#line 520 "../src/data/Game.vala"
	return NULL;
#line 6618 "Game.c"
}

static gchar*
game_hub_data_game_value_status_lcopy_value (const GValue* value,
                                             guint n_collect_values,
                                             GTypeCValue* collect_values,
                                             guint collect_flags)
{
	GameHubDataGameStatus ** object_p;
	object_p = collect_values[0].v_pointer;
#line 520 "../src/data/Game.vala"
	if (!object_p) {
#line 520 "../src/data/Game.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 6633 "Game.c"
	}
#line 520 "../src/data/Game.vala"
	if (!value->data[0].v_pointer) {
#line 520 "../src/data/Game.vala"
		*object_p = NULL;
#line 6639 "Game.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 520 "../src/data/Game.vala"
		*object_p = value->data[0].v_pointer;
#line 6643 "Game.c"
	} else {
#line 520 "../src/data/Game.vala"
		*object_p = game_hub_data_game_status_ref (value->data[0].v_pointer);
#line 6647 "Game.c"
	}
#line 520 "../src/data/Game.vala"
	return NULL;
#line 6651 "Game.c"
}

GParamSpec*
game_hub_data_game_param_spec_status (const gchar* name,
                                      const gchar* nick,
                                      const gchar* blurb,
                                      GType object_type,
                                      GParamFlags flags)
{
	GameHubDataGameParamSpecStatus* spec;
#line 520 "../src/data/Game.vala"
	g_return_val_if_fail (g_type_is_a (object_type, GAME_HUB_DATA_GAME_TYPE_STATUS), NULL);
#line 520 "../src/data/Game.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 520 "../src/data/Game.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 520 "../src/data/Game.vala"
	return G_PARAM_SPEC (spec);
#line 6670 "Game.c"
}

gpointer
game_hub_data_game_value_get_status (const GValue* value)
{
#line 520 "../src/data/Game.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, GAME_HUB_DATA_GAME_TYPE_STATUS), NULL);
#line 520 "../src/data/Game.vala"
	return value->data[0].v_pointer;
#line 6680 "Game.c"
}

void
game_hub_data_game_value_set_status (GValue* value,
                                     gpointer v_object)
{
	GameHubDataGameStatus * old;
#line 520 "../src/data/Game.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, GAME_HUB_DATA_GAME_TYPE_STATUS));
#line 520 "../src/data/Game.vala"
	old = value->data[0].v_pointer;
#line 520 "../src/data/Game.vala"
	if (v_object) {
#line 520 "../src/data/Game.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, GAME_HUB_DATA_GAME_TYPE_STATUS));
#line 520 "../src/data/Game.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 520 "../src/data/Game.vala"
		value->data[0].v_pointer = v_object;
#line 520 "../src/data/Game.vala"
		game_hub_data_game_status_ref (value->data[0].v_pointer);
#line 6702 "Game.c"
	} else {
#line 520 "../src/data/Game.vala"
		value->data[0].v_pointer = NULL;
#line 6706 "Game.c"
	}
#line 520 "../src/data/Game.vala"
	if (old) {
#line 520 "../src/data/Game.vala"
		game_hub_data_game_status_unref (old);
#line 6712 "Game.c"
	}
}

void
game_hub_data_game_value_take_status (GValue* value,
                                      gpointer v_object)
{
	GameHubDataGameStatus * old;
#line 520 "../src/data/Game.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, GAME_HUB_DATA_GAME_TYPE_STATUS));
#line 520 "../src/data/Game.vala"
	old = value->data[0].v_pointer;
#line 520 "../src/data/Game.vala"
	if (v_object) {
#line 520 "../src/data/Game.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, GAME_HUB_DATA_GAME_TYPE_STATUS));
#line 520 "../src/data/Game.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 520 "../src/data/Game.vala"
		value->data[0].v_pointer = v_object;
#line 6733 "Game.c"
	} else {
#line 520 "../src/data/Game.vala"
		value->data[0].v_pointer = NULL;
#line 6737 "Game.c"
	}
#line 520 "../src/data/Game.vala"
	if (old) {
#line 520 "../src/data/Game.vala"
		game_hub_data_game_status_unref (old);
#line 6743 "Game.c"
	}
}

static void
game_hub_data_game_status_class_init (GameHubDataGameStatusClass * klass,
                                      gpointer klass_data)
{
#line 520 "../src/data/Game.vala"
	game_hub_data_game_status_parent_class = g_type_class_peek_parent (klass);
#line 520 "../src/data/Game.vala"
	((GameHubDataGameStatusClass *) klass)->finalize = game_hub_data_game_status_finalize;
#line 6755 "Game.c"
}

static void
game_hub_data_game_status_instance_init (GameHubDataGameStatus * self,
                                         gpointer klass)
{
#line 520 "../src/data/Game.vala"
	self->ref_count = 1;
#line 6764 "Game.c"
}

static void
game_hub_data_game_status_finalize (GameHubDataGameStatus * obj)
{
	GameHubDataGameStatus * self;
#line 520 "../src/data/Game.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GAME_HUB_DATA_GAME_TYPE_STATUS, GameHubDataGameStatus);
#line 520 "../src/data/Game.vala"
	g_signal_handlers_destroy (self);
#line 523 "../src/data/Game.vala"
	_g_object_unref0 (self->game);
#line 524 "../src/data/Game.vala"
	_game_hub_utils_downloader_download_unref0 (self->download);
#line 6779 "Game.c"
}

GType
game_hub_data_game_status_get_type (void)
{
	static volatile gsize game_hub_data_game_status_type_id__volatile = 0;
	if (g_once_init_enter (&game_hub_data_game_status_type_id__volatile)) {
		static const GTypeValueTable g_define_type_value_table = { game_hub_data_game_value_status_init, game_hub_data_game_value_status_free_value, game_hub_data_game_value_status_copy_value, game_hub_data_game_value_status_peek_pointer, "p", game_hub_data_game_value_status_collect_value, "p", game_hub_data_game_value_status_lcopy_value };
		static const GTypeInfo g_define_type_info = { sizeof (GameHubDataGameStatusClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) game_hub_data_game_status_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GameHubDataGameStatus), 0, (GInstanceInitFunc) game_hub_data_game_status_instance_init, &g_define_type_value_table };
		static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
		GType game_hub_data_game_status_type_id;
		game_hub_data_game_status_type_id = g_type_register_fundamental (g_type_fundamental_next (), "GameHubDataGameStatus", &g_define_type_info, &g_define_type_fundamental_info, 0);
		g_once_init_leave (&game_hub_data_game_status_type_id__volatile, game_hub_data_game_status_type_id);
	}
	return game_hub_data_game_status_type_id__volatile;
}

gpointer
game_hub_data_game_status_ref (gpointer instance)
{
	GameHubDataGameStatus * self;
	self = instance;
#line 520 "../src/data/Game.vala"
	g_atomic_int_inc (&self->ref_count);
#line 520 "../src/data/Game.vala"
	return instance;
#line 6806 "Game.c"
}

void
game_hub_data_game_status_unref (gpointer instance)
{
	GameHubDataGameStatus * self;
	self = instance;
#line 520 "../src/data/Game.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 520 "../src/data/Game.vala"
		GAME_HUB_DATA_GAME_STATUS_GET_CLASS (self)->finalize (self);
#line 520 "../src/data/Game.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 6820 "Game.c"
	}
}

static inline gpointer
game_hub_data_game_achievement_get_instance_private (GameHubDataGameAchievement* self)
{
	return G_STRUCT_MEMBER_P (self, GameHubDataGameAchievement_private_offset);
}

GameHubDataGameAchievement*
game_hub_data_game_achievement_construct (GType object_type)
{
	GameHubDataGameAchievement* self = NULL;
#line 570 "../src/data/Game.vala"
	self = (GameHubDataGameAchievement*) g_type_create_instance (object_type);
#line 570 "../src/data/Game.vala"
	return self;
#line 6838 "Game.c"
}

const gchar*
game_hub_data_game_achievement_get_id (GameHubDataGameAchievement* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 572 "../src/data/Game.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 572 "../src/data/Game.vala"
	_tmp0_ = self->priv->_id;
#line 572 "../src/data/Game.vala"
	result = _tmp0_;
#line 572 "../src/data/Game.vala"
	return result;
#line 6854 "Game.c"
}

void
game_hub_data_game_achievement_set_id (GameHubDataGameAchievement* self,
                                       const gchar* value)
{
	gchar* _tmp0_;
#line 572 "../src/data/Game.vala"
	g_return_if_fail (self != NULL);
#line 572 "../src/data/Game.vala"
	_tmp0_ = g_strdup (value);
#line 572 "../src/data/Game.vala"
	_g_free0 (self->priv->_id);
#line 572 "../src/data/Game.vala"
	self->priv->_id = _tmp0_;
#line 6870 "Game.c"
}

const gchar*
game_hub_data_game_achievement_get_name (GameHubDataGameAchievement* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 573 "../src/data/Game.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 573 "../src/data/Game.vala"
	_tmp0_ = self->priv->_name;
#line 573 "../src/data/Game.vala"
	result = _tmp0_;
#line 573 "../src/data/Game.vala"
	return result;
#line 6886 "Game.c"
}

void
game_hub_data_game_achievement_set_name (GameHubDataGameAchievement* self,
                                         const gchar* value)
{
	gchar* _tmp0_;
#line 573 "../src/data/Game.vala"
	g_return_if_fail (self != NULL);
#line 573 "../src/data/Game.vala"
	_tmp0_ = g_strdup (value);
#line 573 "../src/data/Game.vala"
	_g_free0 (self->priv->_name);
#line 573 "../src/data/Game.vala"
	self->priv->_name = _tmp0_;
#line 6902 "Game.c"
}

const gchar*
game_hub_data_game_achievement_get_description (GameHubDataGameAchievement* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 574 "../src/data/Game.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 574 "../src/data/Game.vala"
	_tmp0_ = self->priv->_description;
#line 574 "../src/data/Game.vala"
	result = _tmp0_;
#line 574 "../src/data/Game.vala"
	return result;
#line 6918 "Game.c"
}

void
game_hub_data_game_achievement_set_description (GameHubDataGameAchievement* self,
                                                const gchar* value)
{
	gchar* _tmp0_;
#line 574 "../src/data/Game.vala"
	g_return_if_fail (self != NULL);
#line 574 "../src/data/Game.vala"
	_tmp0_ = g_strdup (value);
#line 574 "../src/data/Game.vala"
	_g_free0 (self->priv->_description);
#line 574 "../src/data/Game.vala"
	self->priv->_description = _tmp0_;
#line 6934 "Game.c"
}

gboolean
game_hub_data_game_achievement_get_unlocked (GameHubDataGameAchievement* self)
{
	gboolean result;
#line 575 "../src/data/Game.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 575 "../src/data/Game.vala"
	result = self->priv->_unlocked;
#line 575 "../src/data/Game.vala"
	return result;
#line 6947 "Game.c"
}

void
game_hub_data_game_achievement_set_unlocked (GameHubDataGameAchievement* self,
                                             gboolean value)
{
#line 575 "../src/data/Game.vala"
	g_return_if_fail (self != NULL);
#line 575 "../src/data/Game.vala"
	self->priv->_unlocked = value;
#line 6958 "Game.c"
}

GDateTime*
game_hub_data_game_achievement_get_unlock_date (GameHubDataGameAchievement* self)
{
	GDateTime* result;
	GDateTime* _tmp0_;
#line 576 "../src/data/Game.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 576 "../src/data/Game.vala"
	_tmp0_ = self->priv->_unlock_date;
#line 576 "../src/data/Game.vala"
	result = _tmp0_;
#line 576 "../src/data/Game.vala"
	return result;
#line 6974 "Game.c"
}

static gpointer
_g_date_time_ref0 (gpointer self)
{
#line 576 "../src/data/Game.vala"
	return self ? g_date_time_ref (self) : NULL;
#line 6982 "Game.c"
}

void
game_hub_data_game_achievement_set_unlock_date (GameHubDataGameAchievement* self,
                                                GDateTime* value)
{
	GDateTime* _tmp0_;
#line 576 "../src/data/Game.vala"
	g_return_if_fail (self != NULL);
#line 576 "../src/data/Game.vala"
	_tmp0_ = _g_date_time_ref0 (value);
#line 576 "../src/data/Game.vala"
	_g_date_time_unref0 (self->priv->_unlock_date);
#line 576 "../src/data/Game.vala"
	self->priv->_unlock_date = _tmp0_;
#line 6998 "Game.c"
}

const gchar*
game_hub_data_game_achievement_get_unlock_time (GameHubDataGameAchievement* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 577 "../src/data/Game.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 577 "../src/data/Game.vala"
	_tmp0_ = self->priv->_unlock_time;
#line 577 "../src/data/Game.vala"
	result = _tmp0_;
#line 577 "../src/data/Game.vala"
	return result;
#line 7014 "Game.c"
}

void
game_hub_data_game_achievement_set_unlock_time (GameHubDataGameAchievement* self,
                                                const gchar* value)
{
	gchar* _tmp0_;
#line 577 "../src/data/Game.vala"
	g_return_if_fail (self != NULL);
#line 577 "../src/data/Game.vala"
	_tmp0_ = g_strdup (value);
#line 577 "../src/data/Game.vala"
	_g_free0 (self->priv->_unlock_time);
#line 577 "../src/data/Game.vala"
	self->priv->_unlock_time = _tmp0_;
#line 7030 "Game.c"
}

gfloat
game_hub_data_game_achievement_get_global_percentage (GameHubDataGameAchievement* self)
{
	gfloat result;
#line 578 "../src/data/Game.vala"
	g_return_val_if_fail (self != NULL, 0.0F);
#line 578 "../src/data/Game.vala"
	result = self->priv->_global_percentage;
#line 578 "../src/data/Game.vala"
	return result;
#line 7043 "Game.c"
}

void
game_hub_data_game_achievement_set_global_percentage (GameHubDataGameAchievement* self,
                                                      gfloat value)
{
#line 578 "../src/data/Game.vala"
	g_return_if_fail (self != NULL);
#line 578 "../src/data/Game.vala"
	self->priv->_global_percentage = value;
#line 7054 "Game.c"
}

const gchar*
game_hub_data_game_achievement_get_image_locked (GameHubDataGameAchievement* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 579 "../src/data/Game.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 579 "../src/data/Game.vala"
	_tmp0_ = self->priv->_image_locked;
#line 579 "../src/data/Game.vala"
	result = _tmp0_;
#line 579 "../src/data/Game.vala"
	return result;
#line 7070 "Game.c"
}

void
game_hub_data_game_achievement_set_image_locked (GameHubDataGameAchievement* self,
                                                 const gchar* value)
{
	gchar* _tmp0_;
#line 579 "../src/data/Game.vala"
	g_return_if_fail (self != NULL);
#line 579 "../src/data/Game.vala"
	_tmp0_ = g_strdup (value);
#line 579 "../src/data/Game.vala"
	_g_free0 (self->priv->_image_locked);
#line 579 "../src/data/Game.vala"
	self->priv->_image_locked = _tmp0_;
#line 7086 "Game.c"
}

const gchar*
game_hub_data_game_achievement_get_image_unlocked (GameHubDataGameAchievement* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 580 "../src/data/Game.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 580 "../src/data/Game.vala"
	_tmp0_ = self->priv->_image_unlocked;
#line 580 "../src/data/Game.vala"
	result = _tmp0_;
#line 580 "../src/data/Game.vala"
	return result;
#line 7102 "Game.c"
}

void
game_hub_data_game_achievement_set_image_unlocked (GameHubDataGameAchievement* self,
                                                   const gchar* value)
{
	gchar* _tmp0_;
#line 580 "../src/data/Game.vala"
	g_return_if_fail (self != NULL);
#line 580 "../src/data/Game.vala"
	_tmp0_ = g_strdup (value);
#line 580 "../src/data/Game.vala"
	_g_free0 (self->priv->_image_unlocked);
#line 580 "../src/data/Game.vala"
	self->priv->_image_unlocked = _tmp0_;
#line 7118 "Game.c"
}

const gchar*
game_hub_data_game_achievement_get_image (GameHubDataGameAchievement* self)
{
	const gchar* result;
	const gchar* _tmp0_ = NULL;
	gboolean _tmp1_;
#line 581 "../src/data/Game.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 581 "../src/data/Game.vala"
	_tmp1_ = self->priv->_unlocked;
#line 581 "../src/data/Game.vala"
	if (_tmp1_) {
#line 7133 "Game.c"
		const gchar* _tmp2_;
#line 581 "../src/data/Game.vala"
		_tmp2_ = self->priv->_image_unlocked;
#line 581 "../src/data/Game.vala"
		_tmp0_ = _tmp2_;
#line 7139 "Game.c"
	} else {
		const gchar* _tmp3_;
#line 581 "../src/data/Game.vala"
		_tmp3_ = self->priv->_image_locked;
#line 581 "../src/data/Game.vala"
		_tmp0_ = _tmp3_;
#line 7146 "Game.c"
	}
#line 581 "../src/data/Game.vala"
	result = _tmp0_;
#line 581 "../src/data/Game.vala"
	return result;
#line 7152 "Game.c"
}

static void
game_hub_data_game_value_achievement_init (GValue* value)
{
#line 570 "../src/data/Game.vala"
	value->data[0].v_pointer = NULL;
#line 7160 "Game.c"
}

static void
game_hub_data_game_value_achievement_free_value (GValue* value)
{
#line 570 "../src/data/Game.vala"
	if (value->data[0].v_pointer) {
#line 570 "../src/data/Game.vala"
		game_hub_data_game_achievement_unref (value->data[0].v_pointer);
#line 7170 "Game.c"
	}
}

static void
game_hub_data_game_value_achievement_copy_value (const GValue* src_value,
                                                 GValue* dest_value)
{
#line 570 "../src/data/Game.vala"
	if (src_value->data[0].v_pointer) {
#line 570 "../src/data/Game.vala"
		dest_value->data[0].v_pointer = game_hub_data_game_achievement_ref (src_value->data[0].v_pointer);
#line 7182 "Game.c"
	} else {
#line 570 "../src/data/Game.vala"
		dest_value->data[0].v_pointer = NULL;
#line 7186 "Game.c"
	}
}

static gpointer
game_hub_data_game_value_achievement_peek_pointer (const GValue* value)
{
#line 570 "../src/data/Game.vala"
	return value->data[0].v_pointer;
#line 7195 "Game.c"
}

static gchar*
game_hub_data_game_value_achievement_collect_value (GValue* value,
                                                    guint n_collect_values,
                                                    GTypeCValue* collect_values,
                                                    guint collect_flags)
{
#line 570 "../src/data/Game.vala"
	if (collect_values[0].v_pointer) {
#line 7206 "Game.c"
		GameHubDataGameAchievement * object;
		object = collect_values[0].v_pointer;
#line 570 "../src/data/Game.vala"
		if (object->parent_instance.g_class == NULL) {
#line 570 "../src/data/Game.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 7213 "Game.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 570 "../src/data/Game.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 7217 "Game.c"
		}
#line 570 "../src/data/Game.vala"
		value->data[0].v_pointer = game_hub_data_game_achievement_ref (object);
#line 7221 "Game.c"
	} else {
#line 570 "../src/data/Game.vala"
		value->data[0].v_pointer = NULL;
#line 7225 "Game.c"
	}
#line 570 "../src/data/Game.vala"
	return NULL;
#line 7229 "Game.c"
}

static gchar*
game_hub_data_game_value_achievement_lcopy_value (const GValue* value,
                                                  guint n_collect_values,
                                                  GTypeCValue* collect_values,
                                                  guint collect_flags)
{
	GameHubDataGameAchievement ** object_p;
	object_p = collect_values[0].v_pointer;
#line 570 "../src/data/Game.vala"
	if (!object_p) {
#line 570 "../src/data/Game.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 7244 "Game.c"
	}
#line 570 "../src/data/Game.vala"
	if (!value->data[0].v_pointer) {
#line 570 "../src/data/Game.vala"
		*object_p = NULL;
#line 7250 "Game.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 570 "../src/data/Game.vala"
		*object_p = value->data[0].v_pointer;
#line 7254 "Game.c"
	} else {
#line 570 "../src/data/Game.vala"
		*object_p = game_hub_data_game_achievement_ref (value->data[0].v_pointer);
#line 7258 "Game.c"
	}
#line 570 "../src/data/Game.vala"
	return NULL;
#line 7262 "Game.c"
}

GParamSpec*
game_hub_data_game_param_spec_achievement (const gchar* name,
                                           const gchar* nick,
                                           const gchar* blurb,
                                           GType object_type,
                                           GParamFlags flags)
{
	GameHubDataGameParamSpecAchievement* spec;
#line 570 "../src/data/Game.vala"
	g_return_val_if_fail (g_type_is_a (object_type, GAME_HUB_DATA_GAME_TYPE_ACHIEVEMENT), NULL);
#line 570 "../src/data/Game.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 570 "../src/data/Game.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 570 "../src/data/Game.vala"
	return G_PARAM_SPEC (spec);
#line 7281 "Game.c"
}

gpointer
game_hub_data_game_value_get_achievement (const GValue* value)
{
#line 570 "../src/data/Game.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, GAME_HUB_DATA_GAME_TYPE_ACHIEVEMENT), NULL);
#line 570 "../src/data/Game.vala"
	return value->data[0].v_pointer;
#line 7291 "Game.c"
}

void
game_hub_data_game_value_set_achievement (GValue* value,
                                          gpointer v_object)
{
	GameHubDataGameAchievement * old;
#line 570 "../src/data/Game.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, GAME_HUB_DATA_GAME_TYPE_ACHIEVEMENT));
#line 570 "../src/data/Game.vala"
	old = value->data[0].v_pointer;
#line 570 "../src/data/Game.vala"
	if (v_object) {
#line 570 "../src/data/Game.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, GAME_HUB_DATA_GAME_TYPE_ACHIEVEMENT));
#line 570 "../src/data/Game.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 570 "../src/data/Game.vala"
		value->data[0].v_pointer = v_object;
#line 570 "../src/data/Game.vala"
		game_hub_data_game_achievement_ref (value->data[0].v_pointer);
#line 7313 "Game.c"
	} else {
#line 570 "../src/data/Game.vala"
		value->data[0].v_pointer = NULL;
#line 7317 "Game.c"
	}
#line 570 "../src/data/Game.vala"
	if (old) {
#line 570 "../src/data/Game.vala"
		game_hub_data_game_achievement_unref (old);
#line 7323 "Game.c"
	}
}

void
game_hub_data_game_value_take_achievement (GValue* value,
                                           gpointer v_object)
{
	GameHubDataGameAchievement * old;
#line 570 "../src/data/Game.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, GAME_HUB_DATA_GAME_TYPE_ACHIEVEMENT));
#line 570 "../src/data/Game.vala"
	old = value->data[0].v_pointer;
#line 570 "../src/data/Game.vala"
	if (v_object) {
#line 570 "../src/data/Game.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, GAME_HUB_DATA_GAME_TYPE_ACHIEVEMENT));
#line 570 "../src/data/Game.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 570 "../src/data/Game.vala"
		value->data[0].v_pointer = v_object;
#line 7344 "Game.c"
	} else {
#line 570 "../src/data/Game.vala"
		value->data[0].v_pointer = NULL;
#line 7348 "Game.c"
	}
#line 570 "../src/data/Game.vala"
	if (old) {
#line 570 "../src/data/Game.vala"
		game_hub_data_game_achievement_unref (old);
#line 7354 "Game.c"
	}
}

static void
game_hub_data_game_achievement_class_init (GameHubDataGameAchievementClass * klass,
                                           gpointer klass_data)
{
#line 570 "../src/data/Game.vala"
	game_hub_data_game_achievement_parent_class = g_type_class_peek_parent (klass);
#line 570 "../src/data/Game.vala"
	((GameHubDataGameAchievementClass *) klass)->finalize = game_hub_data_game_achievement_finalize;
#line 570 "../src/data/Game.vala"
	g_type_class_adjust_private_offset (klass, &GameHubDataGameAchievement_private_offset);
#line 7368 "Game.c"
}

static void
game_hub_data_game_achievement_instance_init (GameHubDataGameAchievement * self,
                                              gpointer klass)
{
#line 570 "../src/data/Game.vala"
	self->priv = game_hub_data_game_achievement_get_instance_private (self);
#line 575 "../src/data/Game.vala"
	self->priv->_unlocked = FALSE;
#line 578 "../src/data/Game.vala"
	self->priv->_global_percentage = (gfloat) 0;
#line 570 "../src/data/Game.vala"
	self->ref_count = 1;
#line 7383 "Game.c"
}

static void
game_hub_data_game_achievement_finalize (GameHubDataGameAchievement * obj)
{
	GameHubDataGameAchievement * self;
#line 570 "../src/data/Game.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GAME_HUB_DATA_GAME_TYPE_ACHIEVEMENT, GameHubDataGameAchievement);
#line 570 "../src/data/Game.vala"
	g_signal_handlers_destroy (self);
#line 572 "../src/data/Game.vala"
	_g_free0 (self->priv->_id);
#line 573 "../src/data/Game.vala"
	_g_free0 (self->priv->_name);
#line 574 "../src/data/Game.vala"
	_g_free0 (self->priv->_description);
#line 576 "../src/data/Game.vala"
	_g_date_time_unref0 (self->priv->_unlock_date);
#line 577 "../src/data/Game.vala"
	_g_free0 (self->priv->_unlock_time);
#line 579 "../src/data/Game.vala"
	_g_free0 (self->priv->_image_locked);
#line 580 "../src/data/Game.vala"
	_g_free0 (self->priv->_image_unlocked);
#line 7408 "Game.c"
}

GType
game_hub_data_game_achievement_get_type (void)
{
	static volatile gsize game_hub_data_game_achievement_type_id__volatile = 0;
	if (g_once_init_enter (&game_hub_data_game_achievement_type_id__volatile)) {
		static const GTypeValueTable g_define_type_value_table = { game_hub_data_game_value_achievement_init, game_hub_data_game_value_achievement_free_value, game_hub_data_game_value_achievement_copy_value, game_hub_data_game_value_achievement_peek_pointer, "p", game_hub_data_game_value_achievement_collect_value, "p", game_hub_data_game_value_achievement_lcopy_value };
		static const GTypeInfo g_define_type_info = { sizeof (GameHubDataGameAchievementClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) game_hub_data_game_achievement_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GameHubDataGameAchievement), 0, (GInstanceInitFunc) game_hub_data_game_achievement_instance_init, &g_define_type_value_table };
		static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
		GType game_hub_data_game_achievement_type_id;
		game_hub_data_game_achievement_type_id = g_type_register_fundamental (g_type_fundamental_next (), "GameHubDataGameAchievement", &g_define_type_info, &g_define_type_fundamental_info, G_TYPE_FLAG_ABSTRACT);
		GameHubDataGameAchievement_private_offset = g_type_add_instance_private (game_hub_data_game_achievement_type_id, sizeof (GameHubDataGameAchievementPrivate));
		g_once_init_leave (&game_hub_data_game_achievement_type_id__volatile, game_hub_data_game_achievement_type_id);
	}
	return game_hub_data_game_achievement_type_id__volatile;
}

gpointer
game_hub_data_game_achievement_ref (gpointer instance)
{
	GameHubDataGameAchievement * self;
	self = instance;
#line 570 "../src/data/Game.vala"
	g_atomic_int_inc (&self->ref_count);
#line 570 "../src/data/Game.vala"
	return instance;
#line 7436 "Game.c"
}

void
game_hub_data_game_achievement_unref (gpointer instance)
{
	GameHubDataGameAchievement * self;
	self = instance;
#line 570 "../src/data/Game.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 570 "../src/data/Game.vala"
		GAME_HUB_DATA_GAME_ACHIEVEMENT_GET_CLASS (self)->finalize (self);
#line 570 "../src/data/Game.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 7450 "Game.c"
	}
}

static void
game_hub_data_game_class_init (GameHubDataGameClass * klass,
                               gpointer klass_data)
{
#line 27 "../src/data/Game.vala"
	game_hub_data_game_parent_class = g_type_class_peek_parent (klass);
#line 27 "../src/data/Game.vala"
	g_type_class_adjust_private_offset (klass, &GameHubDataGame_private_offset);
#line 27 "../src/data/Game.vala"
	((GameHubDataRunnableClass *) klass)->save = (void (*) (GameHubDataRunnable*)) game_hub_data_game_real_save;
#line 27 "../src/data/Game.vala"
	((GameHubDataRunnableClass *) klass)->run = (void (*) (GameHubDataRunnable*, GAsyncReadyCallback, gpointer)) game_hub_data_game_real_run;
#line 27 "../src/data/Game.vala"
	((GameHubDataRunnableClass *) klass)->run_finish = (void (*) (GameHubDataRunnable*, GAsyncResult*)) game_hub_data_game_run_finish;
#line 27 "../src/data/Game.vala"
	((GameHubDataGameClass *) klass)->update_game_info = (void (*) (GameHubDataGame*, GAsyncReadyCallback, gpointer)) game_hub_data_game_real_update_game_info;
#line 27 "../src/data/Game.vala"
	((GameHubDataGameClass *) klass)->update_game_info_finish = (void (*) (GameHubDataGame*, GAsyncResult*)) game_hub_data_game_real_update_game_info_finish;
#line 27 "../src/data/Game.vala"
	((GameHubDataGameClass *) klass)->load_achievements = (void (*) (GameHubDataGame*, GAsyncReadyCallback, gpointer)) game_hub_data_game_real_load_achievements;
#line 27 "../src/data/Game.vala"
	((GameHubDataGameClass *) klass)->load_achievements_finish = (GeeArrayList* (*) (GameHubDataGame*, GAsyncResult*)) game_hub_data_game_real_load_achievements_finish;
#line 27 "../src/data/Game.vala"
	GAME_HUB_DATA_RUNNABLE_CLASS (klass)->get_executable = game_hub_data_game_real_get_executable;
#line 27 "../src/data/Game.vala"
	GAME_HUB_DATA_RUNNABLE_CLASS (klass)->set_executable = game_hub_data_game_real_set_executable;
#line 27 "../src/data/Game.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_game_hub_data_game_get_property;
#line 27 "../src/data/Game.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_game_hub_data_game_set_property;
#line 27 "../src/data/Game.vala"
	G_OBJECT_CLASS (klass)->finalize = game_hub_data_game_finalize;
#line 27 "../src/data/Game.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GAME_HUB_DATA_GAME_SOURCE_PROPERTY, game_hub_data_game_properties[GAME_HUB_DATA_GAME_SOURCE_PROPERTY] = game_hub_data_param_spec_game_source ("source", "source", "source", GAME_HUB_DATA_TYPE_GAME_SOURCE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 27 "../src/data/Game.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GAME_HUB_DATA_GAME_DESCRIPTION_PROPERTY, game_hub_data_game_properties[GAME_HUB_DATA_GAME_DESCRIPTION_PROPERTY] = g_param_spec_string ("description", "description", "description", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 27 "../src/data/Game.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GAME_HUB_DATA_GAME_ICON_PROPERTY, game_hub_data_game_properties[GAME_HUB_DATA_GAME_ICON_PROPERTY] = g_param_spec_string ("icon", "icon", "icon", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 27 "../src/data/Game.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GAME_HUB_DATA_GAME_IMAGE_PROPERTY, game_hub_data_game_properties[GAME_HUB_DATA_GAME_IMAGE_PROPERTY] = g_param_spec_string ("image", "image", "image", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 27 "../src/data/Game.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GAME_HUB_DATA_GAME_INFO_PROPERTY, game_hub_data_game_properties[GAME_HUB_DATA_GAME_INFO_PROPERTY] = g_param_spec_string ("info", "info", "info", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 27 "../src/data/Game.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GAME_HUB_DATA_GAME_INFO_DETAILED_PROPERTY, game_hub_data_game_properties[GAME_HUB_DATA_GAME_INFO_DETAILED_PROPERTY] = g_param_spec_string ("info-detailed", "info-detailed", "info-detailed", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 27 "../src/data/Game.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GAME_HUB_DATA_GAME_FULL_ID_PROPERTY, game_hub_data_game_properties[GAME_HUB_DATA_GAME_FULL_ID_PROPERTY] = g_param_spec_string ("full-id", "full-id", "full-id", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 27 "../src/data/Game.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GAME_HUB_DATA_GAME_VERSION_PROPERTY, game_hub_data_game_properties[GAME_HUB_DATA_GAME_VERSION_PROPERTY] = g_param_spec_string ("version", "version", "version", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 27 "../src/data/Game.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GAME_HUB_DATA_GAME_TAGS_PROPERTY, game_hub_data_game_properties[GAME_HUB_DATA_GAME_TAGS_PROPERTY] = g_param_spec_object ("tags", "tags", "tags", GEE_TYPE_ARRAY_LIST, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 27 "../src/data/Game.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GAME_HUB_DATA_GAME_INSTALLERS_DIR_PROPERTY, game_hub_data_game_properties[GAME_HUB_DATA_GAME_INSTALLERS_DIR_PROPERTY] = g_param_spec_object ("installers-dir", "installers-dir", "installers-dir", g_file_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 27 "../src/data/Game.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GAME_HUB_DATA_GAME_IS_INSTALLABLE_PROPERTY, game_hub_data_game_properties[GAME_HUB_DATA_GAME_IS_INSTALLABLE_PROPERTY] = g_param_spec_boolean ("is-installable", "is-installable", "is-installable", TRUE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 27 "../src/data/Game.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GAME_HUB_DATA_GAME_STORE_PAGE_PROPERTY, game_hub_data_game_properties[GAME_HUB_DATA_GAME_STORE_PAGE_PROPERTY] = g_param_spec_string ("store-page", "store-page", "store-page", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 27 "../src/data/Game.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GAME_HUB_DATA_GAME_LAST_LAUNCH_PROPERTY, game_hub_data_game_properties[GAME_HUB_DATA_GAME_LAST_LAUNCH_PROPERTY] = g_param_spec_int64 ("last-launch", "last-launch", "last-launch", G_MININT64, G_MAXINT64, (gint64) 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 27 "../src/data/Game.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GAME_HUB_DATA_GAME_STATUS_PROPERTY, game_hub_data_game_properties[GAME_HUB_DATA_GAME_STATUS_PROPERTY] = game_hub_data_game_param_spec_status ("status", "status", "status", GAME_HUB_DATA_GAME_TYPE_STATUS, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 27 "../src/data/Game.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GAME_HUB_DATA_GAME_PLAYTIME_SOURCE_PROPERTY, game_hub_data_game_properties[GAME_HUB_DATA_GAME_PLAYTIME_SOURCE_PROPERTY] = g_param_spec_int64 ("playtime-source", "playtime-source", "playtime-source", G_MININT64, G_MAXINT64, (gint64) 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 27 "../src/data/Game.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GAME_HUB_DATA_GAME_PLAYTIME_TRACKED_PROPERTY, game_hub_data_game_properties[GAME_HUB_DATA_GAME_PLAYTIME_TRACKED_PROPERTY] = g_param_spec_int64 ("playtime-tracked", "playtime-tracked", "playtime-tracked", G_MININT64, G_MAXINT64, (gint64) 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 27 "../src/data/Game.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GAME_HUB_DATA_GAME_PLAYTIME_PROPERTY, game_hub_data_game_properties[GAME_HUB_DATA_GAME_PLAYTIME_PROPERTY] = g_param_spec_int64 ("playtime", "playtime", "playtime", G_MININT64, G_MAXINT64, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 27 "../src/data/Game.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GAME_HUB_DATA_GAME_EXECUTABLE_PROPERTY, game_hub_data_game_properties[GAME_HUB_DATA_GAME_EXECUTABLE_PROPERTY] = g_param_spec_object ("executable", "executable", "executable", g_file_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 27 "../src/data/Game.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GAME_HUB_DATA_GAME_OVERLAYS_ENABLED_PROPERTY, game_hub_data_game_properties[GAME_HUB_DATA_GAME_OVERLAYS_ENABLED_PROPERTY] = g_param_spec_boolean ("overlays-enabled", "overlays-enabled", "overlays-enabled", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 27 "../src/data/Game.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GAME_HUB_DATA_GAME_ACHIEVEMENTS_PROPERTY, game_hub_data_game_properties[GAME_HUB_DATA_GAME_ACHIEVEMENTS_PROPERTY] = g_param_spec_object ("achievements", "achievements", "achievements", GEE_TYPE_ARRAY_LIST, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 27 "../src/data/Game.vala"
	game_hub_data_game_signals[GAME_HUB_DATA_GAME_STATUS_CHANGE_SIGNAL] = g_signal_new ("status-change", GAME_HUB_DATA_TYPE_GAME, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__GAME_HUB_DATA_GAME_STATUS, G_TYPE_NONE, 1, GAME_HUB_DATA_GAME_TYPE_STATUS);
#line 27 "../src/data/Game.vala"
	game_hub_data_game_signals[GAME_HUB_DATA_GAME_TAGS_UPDATE_SIGNAL] = g_signal_new ("tags-update", GAME_HUB_DATA_TYPE_GAME, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 7530 "Game.c"
}

static void
game_hub_data_game_instance_init (GameHubDataGame * self,
                                  gpointer klass)
{
	GeeArrayList* _tmp0_;
	GameHubDataGameStatus* _tmp1_;
	GeeArrayList* _tmp2_;
#line 27 "../src/data/Game.vala"
	self->priv = game_hub_data_game_get_instance_private (self);
#line 43 "../src/data/Game.vala"
	_tmp0_ = gee_array_list_new (GAME_HUB_DATA_DB_TABLES_TAGS_TYPE_TAG, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, _game_hub_data_db_tables_tags_tag_is_equal_gee_equal_data_func, NULL, NULL);
#line 43 "../src/data/Game.vala"
	self->priv->_tags = _tmp0_;
#line 99 "../src/data/Game.vala"
	self->priv->_installers_dir = NULL;
#line 100 "../src/data/Game.vala"
	self->priv->_is_installable = TRUE;
#line 102 "../src/data/Game.vala"
	self->priv->_store_page = NULL;
#line 104 "../src/data/Game.vala"
	self->priv->_last_launch = (gint64) 0;
#line 212 "../src/data/Game.vala"
	_tmp1_ = game_hub_data_game_status_new (GAME_HUB_DATA_GAME_STATE_UNINSTALLED, NULL, NULL);
#line 212 "../src/data/Game.vala"
	self->_status = _tmp1_;
#line 222 "../src/data/Game.vala"
	self->priv->_playtime_source = (gint64) 0;
#line 223 "../src/data/Game.vala"
	self->priv->_playtime_tracked = (gint64) 0;
#line 227 "../src/data/Game.vala"
	_tmp2_ = gee_array_list_new (GAME_HUB_DATA_GAME_TYPE_OVERLAY, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 227 "../src/data/Game.vala"
	self->overlays = _tmp2_;
#line 432 "../src/data/Game.vala"
	self->priv->_achievements = NULL;
#line 7568 "Game.c"
}

static void
game_hub_data_game_finalize (GObject * obj)
{
	GameHubDataGame * self;
#line 27 "../src/data/Game.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GAME_HUB_DATA_TYPE_GAME, GameHubDataGame);
#line 29 "../src/data/Game.vala"
	_game_hub_data_game_source_unref0 (self->priv->_source);
#line 31 "../src/data/Game.vala"
	_g_free0 (self->priv->_description);
#line 33 "../src/data/Game.vala"
	_g_free0 (self->priv->_icon);
#line 34 "../src/data/Game.vala"
	_g_free0 (self->priv->_image);
#line 36 "../src/data/Game.vala"
	_g_free0 (self->priv->_info);
#line 37 "../src/data/Game.vala"
	_g_free0 (self->priv->_info_detailed);
#line 41 "../src/data/Game.vala"
	_g_free0 (self->priv->_version);
#line 43 "../src/data/Game.vala"
	_g_object_unref0 (self->priv->_tags);
#line 99 "../src/data/Game.vala"
	_g_object_unref0 (self->priv->_installers_dir);
#line 102 "../src/data/Game.vala"
	_g_free0 (self->priv->_store_page);
#line 212 "../src/data/Game.vala"
	_game_hub_data_game_status_unref0 (self->_status);
#line 227 "../src/data/Game.vala"
	_g_object_unref0 (self->overlays);
#line 228 "../src/data/Game.vala"
	_g_object_unref0 (self->priv->fs_overlay);
#line 229 "../src/data/Game.vala"
	_g_free0 (self->priv->fs_overlay_last_options);
#line 263 "../src/data/Game.vala"
	_g_free0 (self->executable_path);
#line 432 "../src/data/Game.vala"
	_g_object_unref0 (self->priv->_achievements);
#line 27 "../src/data/Game.vala"
	G_OBJECT_CLASS (game_hub_data_game_parent_class)->finalize (obj);
#line 7611 "Game.c"
}

GType
game_hub_data_game_get_type (void)
{
	static volatile gsize game_hub_data_game_type_id__volatile = 0;
	if (g_once_init_enter (&game_hub_data_game_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (GameHubDataGameClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) game_hub_data_game_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GameHubDataGame), 0, (GInstanceInitFunc) game_hub_data_game_instance_init, NULL };
		GType game_hub_data_game_type_id;
		game_hub_data_game_type_id = g_type_register_static (GAME_HUB_DATA_TYPE_RUNNABLE, "GameHubDataGame", &g_define_type_info, G_TYPE_FLAG_ABSTRACT);
		GameHubDataGame_private_offset = g_type_add_instance_private (game_hub_data_game_type_id, sizeof (GameHubDataGamePrivate));
		g_once_init_leave (&game_hub_data_game_type_id__volatile, game_hub_data_game_type_id);
	}
	return game_hub_data_game_type_id__volatile;
}

static void
_vala_game_hub_data_game_get_property (GObject * object,
                                       guint property_id,
                                       GValue * value,
                                       GParamSpec * pspec)
{
	GameHubDataGame * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GAME_HUB_DATA_TYPE_GAME, GameHubDataGame);
#line 27 "../src/data/Game.vala"
	switch (property_id) {
#line 27 "../src/data/Game.vala"
		case GAME_HUB_DATA_GAME_SOURCE_PROPERTY:
#line 27 "../src/data/Game.vala"
		game_hub_data_value_set_game_source (value, game_hub_data_game_get_source (self));
#line 27 "../src/data/Game.vala"
		break;
#line 27 "../src/data/Game.vala"
		case GAME_HUB_DATA_GAME_DESCRIPTION_PROPERTY:
#line 27 "../src/data/Game.vala"
		g_value_set_string (value, game_hub_data_game_get_description (self));
#line 27 "../src/data/Game.vala"
		break;
#line 27 "../src/data/Game.vala"
		case GAME_HUB_DATA_GAME_ICON_PROPERTY:
#line 27 "../src/data/Game.vala"
		g_value_set_string (value, game_hub_data_game_get_icon (self));
#line 27 "../src/data/Game.vala"
		break;
#line 27 "../src/data/Game.vala"
		case GAME_HUB_DATA_GAME_IMAGE_PROPERTY:
#line 27 "../src/data/Game.vala"
		g_value_set_string (value, game_hub_data_game_get_image (self));
#line 27 "../src/data/Game.vala"
		break;
#line 27 "../src/data/Game.vala"
		case GAME_HUB_DATA_GAME_INFO_PROPERTY:
#line 27 "../src/data/Game.vala"
		g_value_set_string (value, game_hub_data_game_get_info (self));
#line 27 "../src/data/Game.vala"
		break;
#line 27 "../src/data/Game.vala"
		case GAME_HUB_DATA_GAME_INFO_DETAILED_PROPERTY:
#line 27 "../src/data/Game.vala"
		g_value_set_string (value, game_hub_data_game_get_info_detailed (self));
#line 27 "../src/data/Game.vala"
		break;
#line 27 "../src/data/Game.vala"
		case GAME_HUB_DATA_GAME_FULL_ID_PROPERTY:
#line 27 "../src/data/Game.vala"
		g_value_take_string (value, game_hub_data_game_get_full_id (self));
#line 27 "../src/data/Game.vala"
		break;
#line 27 "../src/data/Game.vala"
		case GAME_HUB_DATA_GAME_VERSION_PROPERTY:
#line 27 "../src/data/Game.vala"
		g_value_set_string (value, game_hub_data_game_get_version (self));
#line 27 "../src/data/Game.vala"
		break;
#line 27 "../src/data/Game.vala"
		case GAME_HUB_DATA_GAME_TAGS_PROPERTY:
#line 27 "../src/data/Game.vala"
		g_value_set_object (value, game_hub_data_game_get_tags (self));
#line 27 "../src/data/Game.vala"
		break;
#line 27 "../src/data/Game.vala"
		case GAME_HUB_DATA_GAME_INSTALLERS_DIR_PROPERTY:
#line 27 "../src/data/Game.vala"
		g_value_set_object (value, game_hub_data_game_get_installers_dir (self));
#line 27 "../src/data/Game.vala"
		break;
#line 27 "../src/data/Game.vala"
		case GAME_HUB_DATA_GAME_IS_INSTALLABLE_PROPERTY:
#line 27 "../src/data/Game.vala"
		g_value_set_boolean (value, game_hub_data_game_get_is_installable (self));
#line 27 "../src/data/Game.vala"
		break;
#line 27 "../src/data/Game.vala"
		case GAME_HUB_DATA_GAME_STORE_PAGE_PROPERTY:
#line 27 "../src/data/Game.vala"
		g_value_set_string (value, game_hub_data_game_get_store_page (self));
#line 27 "../src/data/Game.vala"
		break;
#line 27 "../src/data/Game.vala"
		case GAME_HUB_DATA_GAME_LAST_LAUNCH_PROPERTY:
#line 27 "../src/data/Game.vala"
		g_value_set_int64 (value, game_hub_data_game_get_last_launch (self));
#line 27 "../src/data/Game.vala"
		break;
#line 27 "../src/data/Game.vala"
		case GAME_HUB_DATA_GAME_STATUS_PROPERTY:
#line 27 "../src/data/Game.vala"
		game_hub_data_game_value_set_status (value, game_hub_data_game_get_status (self));
#line 27 "../src/data/Game.vala"
		break;
#line 27 "../src/data/Game.vala"
		case GAME_HUB_DATA_GAME_PLAYTIME_SOURCE_PROPERTY:
#line 27 "../src/data/Game.vala"
		g_value_set_int64 (value, game_hub_data_game_get_playtime_source (self));
#line 27 "../src/data/Game.vala"
		break;
#line 27 "../src/data/Game.vala"
		case GAME_HUB_DATA_GAME_PLAYTIME_TRACKED_PROPERTY:
#line 27 "../src/data/Game.vala"
		g_value_set_int64 (value, game_hub_data_game_get_playtime_tracked (self));
#line 27 "../src/data/Game.vala"
		break;
#line 27 "../src/data/Game.vala"
		case GAME_HUB_DATA_GAME_PLAYTIME_PROPERTY:
#line 27 "../src/data/Game.vala"
		g_value_set_int64 (value, game_hub_data_game_get_playtime (self));
#line 27 "../src/data/Game.vala"
		break;
#line 27 "../src/data/Game.vala"
		case GAME_HUB_DATA_GAME_EXECUTABLE_PROPERTY:
#line 27 "../src/data/Game.vala"
		g_value_take_object (value, game_hub_data_runnable_get_executable ((GameHubDataRunnable*) self));
#line 27 "../src/data/Game.vala"
		break;
#line 27 "../src/data/Game.vala"
		case GAME_HUB_DATA_GAME_OVERLAYS_ENABLED_PROPERTY:
#line 27 "../src/data/Game.vala"
		g_value_set_boolean (value, game_hub_data_game_get_overlays_enabled (self));
#line 27 "../src/data/Game.vala"
		break;
#line 27 "../src/data/Game.vala"
		case GAME_HUB_DATA_GAME_ACHIEVEMENTS_PROPERTY:
#line 27 "../src/data/Game.vala"
		g_value_set_object (value, game_hub_data_game_get_achievements (self));
#line 27 "../src/data/Game.vala"
		break;
#line 7758 "Game.c"
		default:
#line 27 "../src/data/Game.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 27 "../src/data/Game.vala"
		break;
#line 7764 "Game.c"
	}
}

static void
_vala_game_hub_data_game_set_property (GObject * object,
                                       guint property_id,
                                       const GValue * value,
                                       GParamSpec * pspec)
{
	GameHubDataGame * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GAME_HUB_DATA_TYPE_GAME, GameHubDataGame);
#line 27 "../src/data/Game.vala"
	switch (property_id) {
#line 27 "../src/data/Game.vala"
		case GAME_HUB_DATA_GAME_SOURCE_PROPERTY:
#line 27 "../src/data/Game.vala"
		game_hub_data_game_set_source (self, game_hub_data_value_get_game_source (value));
#line 27 "../src/data/Game.vala"
		break;
#line 27 "../src/data/Game.vala"
		case GAME_HUB_DATA_GAME_DESCRIPTION_PROPERTY:
#line 27 "../src/data/Game.vala"
		game_hub_data_game_set_description (self, g_value_get_string (value));
#line 27 "../src/data/Game.vala"
		break;
#line 27 "../src/data/Game.vala"
		case GAME_HUB_DATA_GAME_ICON_PROPERTY:
#line 27 "../src/data/Game.vala"
		game_hub_data_game_set_icon (self, g_value_get_string (value));
#line 27 "../src/data/Game.vala"
		break;
#line 27 "../src/data/Game.vala"
		case GAME_HUB_DATA_GAME_IMAGE_PROPERTY:
#line 27 "../src/data/Game.vala"
		game_hub_data_game_set_image (self, g_value_get_string (value));
#line 27 "../src/data/Game.vala"
		break;
#line 27 "../src/data/Game.vala"
		case GAME_HUB_DATA_GAME_INFO_PROPERTY:
#line 27 "../src/data/Game.vala"
		game_hub_data_game_set_info (self, g_value_get_string (value));
#line 27 "../src/data/Game.vala"
		break;
#line 27 "../src/data/Game.vala"
		case GAME_HUB_DATA_GAME_INFO_DETAILED_PROPERTY:
#line 27 "../src/data/Game.vala"
		game_hub_data_game_set_info_detailed (self, g_value_get_string (value));
#line 27 "../src/data/Game.vala"
		break;
#line 27 "../src/data/Game.vala"
		case GAME_HUB_DATA_GAME_VERSION_PROPERTY:
#line 27 "../src/data/Game.vala"
		game_hub_data_game_set_version (self, g_value_get_string (value));
#line 27 "../src/data/Game.vala"
		break;
#line 27 "../src/data/Game.vala"
		case GAME_HUB_DATA_GAME_TAGS_PROPERTY:
#line 27 "../src/data/Game.vala"
		game_hub_data_game_set_tags (self, g_value_get_object (value));
#line 27 "../src/data/Game.vala"
		break;
#line 27 "../src/data/Game.vala"
		case GAME_HUB_DATA_GAME_INSTALLERS_DIR_PROPERTY:
#line 27 "../src/data/Game.vala"
		game_hub_data_game_set_installers_dir (self, g_value_get_object (value));
#line 27 "../src/data/Game.vala"
		break;
#line 27 "../src/data/Game.vala"
		case GAME_HUB_DATA_GAME_IS_INSTALLABLE_PROPERTY:
#line 27 "../src/data/Game.vala"
		game_hub_data_game_set_is_installable (self, g_value_get_boolean (value));
#line 27 "../src/data/Game.vala"
		break;
#line 27 "../src/data/Game.vala"
		case GAME_HUB_DATA_GAME_STORE_PAGE_PROPERTY:
#line 27 "../src/data/Game.vala"
		game_hub_data_game_set_store_page (self, g_value_get_string (value));
#line 27 "../src/data/Game.vala"
		break;
#line 27 "../src/data/Game.vala"
		case GAME_HUB_DATA_GAME_LAST_LAUNCH_PROPERTY:
#line 27 "../src/data/Game.vala"
		game_hub_data_game_set_last_launch (self, g_value_get_int64 (value));
#line 27 "../src/data/Game.vala"
		break;
#line 27 "../src/data/Game.vala"
		case GAME_HUB_DATA_GAME_STATUS_PROPERTY:
#line 27 "../src/data/Game.vala"
		game_hub_data_game_set_status (self, game_hub_data_game_value_get_status (value));
#line 27 "../src/data/Game.vala"
		break;
#line 27 "../src/data/Game.vala"
		case GAME_HUB_DATA_GAME_PLAYTIME_SOURCE_PROPERTY:
#line 27 "../src/data/Game.vala"
		game_hub_data_game_set_playtime_source (self, g_value_get_int64 (value));
#line 27 "../src/data/Game.vala"
		break;
#line 27 "../src/data/Game.vala"
		case GAME_HUB_DATA_GAME_PLAYTIME_TRACKED_PROPERTY:
#line 27 "../src/data/Game.vala"
		game_hub_data_game_set_playtime_tracked (self, g_value_get_int64 (value));
#line 27 "../src/data/Game.vala"
		break;
#line 27 "../src/data/Game.vala"
		case GAME_HUB_DATA_GAME_EXECUTABLE_PROPERTY:
#line 27 "../src/data/Game.vala"
		game_hub_data_runnable_set_executable ((GameHubDataRunnable*) self, g_value_get_object (value));
#line 27 "../src/data/Game.vala"
		break;
#line 27 "../src/data/Game.vala"
		case GAME_HUB_DATA_GAME_ACHIEVEMENTS_PROPERTY:
#line 27 "../src/data/Game.vala"
		game_hub_data_game_set_achievements (self, g_value_get_object (value));
#line 27 "../src/data/Game.vala"
		break;
#line 7880 "Game.c"
		default:
#line 27 "../src/data/Game.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 27 "../src/data/Game.vala"
		break;
#line 7886 "Game.c"
	}
}

static void
_vala_array_destroy (gpointer array,
                     gint array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gint array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

